/* This file was generated by SableCC (http://www.sablecc.org/). */

package de.be4.eventb.core.parser.lexer;

import java.io.*;
import java.util.*;
import de.be4.eventb.core.parser.node.*;
import de.hhu.stups.sablecc.patch.*;
import java.util.concurrent.LinkedBlockingQueue;

@SuppressWarnings({"unused"}) 
public class Lexer implements ITokenListContainer
{
    protected Token token;
    protected State state = State.NORMAL;

    private PushbackReader in;
    private int line;
    private int pos;
    private boolean cr;
    private boolean eof;
    private final StringBuffer text = new StringBuffer();
    
	private List<IToken> tokenList;
    private final Queue<IToken> nextList = new LinkedBlockingQueue<IToken>();

	private IToken tok;

    public Queue<IToken> getNextList() {
        return nextList;
    }

	public List<IToken> getTokenList() {
		return tokenList;
	}
	
	private void setToken(Token t) {
	  tok = t;
   	  token = t;	
	}
	
	
	public void setTokenList(final List<IToken> list) {
		tokenList = list;
	}

     
    protected void filter() throws LexerException, IOException
    {
        // Do nothing
    }

    protected void filterWrap() throws LexerException, IOException
    {
       filter();
       if (token != null) {
	          getTokenList().add(token); 
              nextList.add(token);
	   }
    }


    public Lexer(  PushbackReader in)
    {
        this.in = in;
    	setTokenList(new ArrayList<IToken>());
    }
    
    public Token peek() throws LexerException, IOException
    {
        while(this.token == null)
        {
            this.setToken(getToken());
            filterWrap();
        }

        return (Token) nextList.peek();
    }

    public Token next() throws LexerException, IOException
    {
        while(this.token == null)
        {
            this.setToken(getToken());
            filterWrap();
        }

        Token result = (Token) nextList.poll();
        this.setToken(null);
        return result;
    }

    protected Token getToken() throws IOException, LexerException
    {
        int dfa_state = 0;

        int start_pos = this.pos;
        int start_line = this.line;

        int accept_state = -1;
        int accept_token = -1;
        int accept_length = -1;
        int accept_pos = -1;
        int accept_line = -1;

          int[][][] gotoTable = Lexer.gotoTable[this.state.id()];
          int[] accept = Lexer.accept[this.state.id()];
        this.text.setLength(0);

        while(true)
        {
            int c = getChar();

            if(c != -1)
            {
                switch(c)
                {
                case 10:
                    if(this.cr)
                    {
                        this.cr = false;
                    }
                    else
                    {
                        this.line++;
                        this.pos = 0;
                    }
                    break;
                case 13:
                    this.line++;
                    this.pos = 0;
                    this.cr = true;
                    break;
                default:
                    this.pos++;
                    this.cr = false;
                    break;
                }

                this.text.append((char) c);

                do
                {
                    int oldState = (dfa_state < -1) ? (-2 -dfa_state) : dfa_state;

                    dfa_state = -1;

                    int[][] tmp1 =  gotoTable[oldState];
                    int low = 0;
                    int high = tmp1.length - 1;

                    while(low <= high)
                    {
                        int middle = (low + high) / 2;
                        int[] tmp2 = tmp1[middle];

                        if(c < tmp2[0])
                        {
                            high = middle - 1;
                        }
                        else if(c > tmp2[1])
                        {
                            low = middle + 1;
                        }
                        else
                        {
                            dfa_state = tmp2[2];
                            break;
                        }
                    }
                }while(dfa_state < -1);
            }
            else
            {
                dfa_state = -1;
            }

            if(dfa_state >= 0)
            {
                if(accept[dfa_state] != -1)
                {
                    accept_state = dfa_state;
                    accept_token = accept[dfa_state];
                    accept_length = this.text.length();
                    accept_pos = this.pos;
                    accept_line = this.line;
                }
            }
            else
            {
                if(accept_state != -1)
                {
                    switch(accept_token)
                    {
                    case 0:
                        {
                              Token token = new0(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                                case 0: state = State.COMMENT; break;
                            }
                            return token;
                        }
                    case 1:
                        {
                              Token token = new1(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 3: state = State.COMMENT; break;
                            }
                            return token;
                        }
                    case 2:
                        {
                              Token token = new2(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 3: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 3:
                        {
                              Token token = new3(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.MULTI_COMMENT; break;
                                case 0: state = State.MULTI_COMMENT; break;
                            }
                            return token;
                        }
                    case 4:
                        {
                              Token token = new4(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 4: state = State.MULTI_COMMENT; break;
                            }
                            return token;
                        }
                    case 5:
                        {
                              Token token = new5(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 4: state = State.MULTI_COMMENT; break;
                            }
                            return token;
                        }
                    case 6:
                        {
                              Token token = new6(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.FORMULA; break;
                                case 4: state = State.MULTI_COMMENT; break;
                            }
                            return token;
                        }
                    case 7:
                        {
                              Token token = new7(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 4: state = State.MULTI_COMMENT; break;
                            }
                            return token;
                        }
                    case 8:
                        {
                              Token token = new8(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                                case 0: state = State.LABEL; break;
                            }
                            return token;
                        }
                    case 9:
                        {
                              Token token = new9(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 10:
                        {
                              Token token = new10(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.FORMULA; break;
                            }
                            return token;
                        }
                    case 11:
                        {
                              Token token = new11(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 12:
                        {
                              Token token = new12(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 13:
                        {
                              Token token = new13(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 14:
                        {
                              Token token = new14(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 15:
                        {
                              Token token = new15(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 16:
                        {
                              Token token = new16(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 17:
                        {
                              Token token = new17(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 18:
                        {
                              Token token = new18(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 19:
                        {
                              Token token = new19(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 20:
                        {
                              Token token = new20(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 21:
                        {
                              Token token = new21(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 22:
                        {
                              Token token = new22(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                                case 0: state = State.FORMULA; break;
                            }
                            return token;
                        }
                    case 23:
                        {
                              Token token = new23(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 24:
                        {
                              Token token = new24(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 25:
                        {
                              Token token = new25(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 26:
                        {
                              Token token = new26(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 27:
                        {
                              Token token = new27(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 28:
                        {
                              Token token = new28(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 29:
                        {
                              Token token = new29(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 30:
                        {
                              Token token = new30(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 31:
                        {
                              Token token = new31(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 32:
                        {
                              Token token = new32(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 33:
                        {
                              Token token = new33(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 34:
                        {
                              Token token = new34(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 35:
                        {
                              Token token = new35(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 2: state = State.LABEL; break;
                            }
                            return token;
                        }
                    case 36:
                        {
                              Token token = new36(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.FORMULA; break;
                                case 2: state = State.FORMULA; break;
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 37:
                        {
                              Token token = new37(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.FORMULA; break;
                            }
                            return token;
                        }
                    }
                }
                else
                {
                    if(this.text.length() > 0)
                    {
                        throw new LexerException(
                            "[" + (start_line + 1) + "," + (start_pos + 1) + "]" +
                            " Unknown token: " + this.text);
                    }

                      EOF token = new EOF(
                        start_line + 1,
                        start_pos + 1);
                    return token;
                }
            }
        }
    }

    Token new0(  String text,   int line,   int pos) { return new TCommentStart(text, line, pos); }
    Token new1(  String text,   int line,   int pos) { return new TComment(text, line, pos); }
    Token new2(  String text,   int line,   int pos) { return new TCommentEnd(text, line, pos); }
    Token new3(  String text,   int line,   int pos) { return new TMultiCommentStart(text, line, pos); }
    Token new4(  String text,   int line,   int pos) { return new TMultiCommentBody(text, line, pos); }
    Token new5(  int line,   int pos) { return new TStar(line, pos); }
    Token new6(  String text,   int line,   int pos) { return new TSlash(text, line, pos); }
    Token new7(  String text,   int line,   int pos) { return new TMultiCommentEnd(text, line, pos); }
    Token new8(  String text,   int line,   int pos) { return new TAt(text, line, pos); }
    Token new9(  int line,   int pos) { return new TComma(line, pos); }
    Token new10(  int line,   int pos) { return new TColon(line, pos); }
    Token new11(  int line,   int pos) { return new TEqual(line, pos); }
    Token new12(  int line,   int pos) { return new TOrdinary(line, pos); }
    Token new13(  int line,   int pos) { return new TConvergent(line, pos); }
    Token new14(  int line,   int pos) { return new TAnticipated(line, pos); }
    Token new15(  int line,   int pos) { return new TMachine(line, pos); }
    Token new16(  int line,   int pos) { return new TRefines(line, pos); }
    Token new17(  int line,   int pos) { return new TSees(line, pos); }
    Token new18(  int line,   int pos) { return new TVariables(line, pos); }
    Token new19(  int line,   int pos) { return new TInvariants(line, pos); }
    Token new20(  int line,   int pos) { return new TTheorem(line, pos); }
    Token new21(  int line,   int pos) { return new TEvents(line, pos); }
    Token new22(  int line,   int pos) { return new TVariant(line, pos); }
    Token new23(  int line,   int pos) { return new TEnd(line, pos); }
    Token new24(  int line,   int pos) { return new TContext(line, pos); }
    Token new25(  int line,   int pos) { return new TExtends(line, pos); }
    Token new26(  int line,   int pos) { return new TSets(line, pos); }
    Token new27(  int line,   int pos) { return new TConstants(line, pos); }
    Token new28(  int line,   int pos) { return new TAxioms(line, pos); }
    Token new29(  int line,   int pos) { return new TEvent(line, pos); }
    Token new30(  int line,   int pos) { return new TAny(line, pos); }
    Token new31(  String text,   int line,   int pos) { return new TWhere(text, line, pos); }
    Token new32(  int line,   int pos) { return new TWith(line, pos); }
    Token new33(  String text,   int line,   int pos) { return new TThen(text, line, pos); }
    Token new34(  String text,   int line,   int pos) { return new TIdentifierLiteral(text, line, pos); }
    Token new35(  String text,   int line,   int pos) { return new TLabel(text, line, pos); }
    Token new36(  String text,   int line,   int pos) { return new TWhiteSpace(text, line, pos); }
    Token new37(  String text,   int line,   int pos) { return new TFormula(text, line, pos); }

    private int getChar() throws IOException
    {
        if(this.eof)
        {
            return -1;
        }

        int result = this.in.read();

        if(result == -1)
        {
            this.eof = true;
        }

        return result;
    }

    private void pushBack(int acceptLength) throws IOException
    {
        int length = this.text.length();
        for(int i = length - 1; i >= acceptLength; i--)
        {
            this.eof = false;

            this.in.unread(this.text.charAt(i));
        }
    }

    protected void unread(  Token token) throws IOException
    {
          String text = token.getText();
        int length = text.length();

        for(int i = length - 1; i >= 0; i--)
        {
            this.eof = false;

            this.in.unread(text.charAt(i));
        }

        this.pos = token.getPos() - 1;
        this.line = token.getLine() - 1;
    }

    private String getText(int acceptLength)
    {
        StringBuffer s = new StringBuffer(acceptLength);
        for(int i = 0; i < acceptLength; i++)
        {
            s.append(this.text.charAt(i));
        }

        return s.toString();
    }

    private static int[][][][] gotoTable;
/*  {
        { // NORMAL
            {{0, 9, 1}, {10, 10, 2}, {11, 12, 1}, {13, 13, 2}, {14, 32, 1}, {44, 44, 3}, {47, 47, 4}, {48, 57, 5}, {58, 58, 6}, {61, 61, 7}, {64, 64, 8}, {65, 90, 9}, {95, 95, 10}, {97, 97, 11}, {98, 98, 12}, {99, 99, 13}, {100, 100, 14}, {101, 101, 15}, {102, 104, 14}, {105, 105, 16}, {106, 108, 14}, {109, 109, 17}, {110, 110, 14}, {111, 111, 18}, {112, 113, 14}, {114, 114, 19}, {115, 115, 20}, {116, 116, 21}, {117, 117, 14}, {118, 118, 22}, {119, 119, 23}, {120, 122, 14}, {127, 160, 1}, {170, 170, 24}, {181, 181, 25}, {186, 186, 26}, {192, 214, 27}, {216, 246, 28}, {248, 501, 29}, {506, 535, 30}, {592, 680, 31}, {688, 696, 32}, {699, 705, 33}, {720, 721, 34}, {736, 740, 35}, {890, 890, 36}, {902, 902, 37}, {904, 906, 38}, {908, 908, 39}, {910, 929, 40}, {931, 974, 41}, {976, 982, 42}, {986, 986, 43}, {988, 988, 44}, {990, 990, 45}, {992, 992, 46}, {994, 1011, 47}, {1025, 1036, 48}, {1038, 1103, 49}, {1105, 1116, 50}, {1118, 1153, 51}, {1168, 1220, 52}, {1223, 1224, 53}, {1227, 1228, 54}, {1232, 1259, 55}, {1262, 1269, 56}, {1272, 1273, 57}, {1329, 1366, 58}, {1369, 1369, 59}, {1377, 1415, 60}, {1488, 1514, 61}, {1520, 1522, 62}, {1569, 1594, 63}, {1600, 1610, 64}, {1632, 1641, 65}, {1649, 1719, 66}, {1722, 1726, 67}, {1728, 1742, 68}, {1744, 1747, 69}, {1749, 1749, 70}, {1765, 1766, 71}, {1776, 1785, 72}, {2309, 2361, 73}, {2365, 2365, 74}, {2392, 2401, 75}, {2406, 2415, 76}, {2437, 2444, 77}, {2447, 2448, 78}, {2451, 2472, 79}, {2474, 2480, 80}, {2482, 2482, 81}, {2486, 2489, 82}, {2524, 2525, 83}, {2527, 2529, 84}, {2534, 2543, 85}, {2544, 2545, 86}, {2565, 2570, 87}, {2575, 2576, 88}, {2579, 2600, 89}, {2602, 2608, 90}, {2610, 2611, 91}, {2613, 2614, 92}, {2616, 2617, 93}, {2649, 2652, 94}, {2654, 2654, 95}, {2662, 2671, 96}, {2674, 2676, 97}, {2693, 2699, 98}, {2701, 2701, 99}, {2703, 2705, 100}, {2707, 2728, 101}, {2730, 2736, 102}, {2738, 2739, 103}, {2741, 2745, 104}, {2749, 2749, 105}, {2784, 2784, 106}, {2790, 2799, 107}, {2821, 2828, 108}, {2831, 2832, 109}, {2835, 2856, 110}, {2858, 2864, 111}, {2866, 2867, 112}, {2870, 2873, 113}, {2877, 2877, 114}, {2908, 2909, 115}, {2911, 2913, 116}, {2918, 2927, 117}, {2949, 2954, 118}, {2958, 2960, 119}, {2962, 2965, 120}, {2969, 2970, 121}, {2972, 2972, 122}, {2974, 2975, 123}, {2979, 2980, 124}, {2984, 2986, 125}, {2990, 2997, 126}, {2999, 3001, 127}, {3047, 3055, 128}, {3077, 3084, 129}, {3086, 3088, 130}, {3090, 3112, 131}, {3114, 3123, 132}, {3125, 3129, 133}, {3168, 3169, 134}, {3174, 3183, 135}, {3205, 3212, 136}, {3214, 3216, 137}, {3218, 3240, 138}, {3242, 3251, 139}, {3253, 3257, 140}, {3294, 3294, 141}, {3296, 3297, 142}, {3302, 3311, 143}, {3333, 3340, 144}, {3342, 3344, 145}, {3346, 3368, 146}, {3370, 3385, 147}, {3424, 3425, 148}, {3430, 3439, 149}, {3585, 3630, 150}, {3632, 3632, 151}, {3634, 3635, 152}, {3648, 3654, 153}, {3664, 3673, 154}, {3713, 3714, 155}, {3716, 3716, 156}, {3719, 3720, 157}, {3722, 3722, 158}, {3725, 3725, 159}, {3732, 3735, 160}, {3737, 3743, 161}, {3745, 3747, 162}, {3749, 3749, 163}, {3751, 3751, 164}, {3754, 3755, 165}, {3757, 3758, 166}, {3760, 3760, 167}, {3762, 3763, 168}, {3773, 3773, 169}, {3776, 3780, 170}, {3782, 3782, 171}, {3792, 3801, 172}, {3804, 3805, 173}, {3872, 3881, 174}, {3904, 3911, 175}, {3913, 3945, 176}, {4256, 4293, 177}, {4304, 4342, 178}, {4352, 4441, 179}, {4447, 4514, 180}, {4520, 4601, 181}, {7680, 7835, 182}, {7840, 7929, 183}, {7936, 7957, 184}, {7960, 7965, 185}, {7968, 8005, 186}, {8008, 8013, 187}, {8016, 8023, 188}, {8025, 8025, 189}, {8027, 8027, 190}, {8029, 8029, 191}, {8031, 8061, 192}, {8064, 8116, 193}, {8118, 8124, 194}, {8126, 8126, 195}, {8130, 8132, 196}, {8134, 8140, 197}, {8144, 8147, 198}, {8150, 8155, 199}, {8160, 8172, 200}, {8178, 8180, 201}, {8182, 8188, 202}, {8206, 8207, 1}, {8232, 8233, 1}, {8319, 8319, 203}, {8450, 8450, 204}, {8455, 8455, 205}, {8458, 8467, 206}, {8469, 8469, 207}, {8472, 8477, 208}, {8484, 8484, 209}, {8486, 8486, 210}, {8488, 8488, 211}, {8490, 8497, 212}, {8499, 8504, 213}, {12293, 12293, 214}, {12337, 12341, 215}, {12353, 12436, 216}, {12443, 12446, 217}, {12449, 12538, 218}, {12540, 12542, 219}, {12549, 12588, 220}, {12593, 12686, 221}, {19968, 40869, 222}, {44032, 55203, 223}, {63744, 64045, 224}, {64256, 64262, 225}, {64275, 64279, 226}, {64287, 64296, 227}, {64298, 64310, 228}, {64312, 64316, 229}, {64318, 64318, 230}, {64320, 64321, 231}, {64323, 64324, 232}, {64326, 64433, 233}, {64467, 64829, 234}, {64848, 64911, 235}, {64914, 64967, 236}, {65008, 65019, 237}, {65136, 65138, 238}, {65140, 65140, 239}, {65142, 65276, 240}, {65296, 65305, 241}, {65313, 65338, 242}, {65345, 65370, 243}, {65382, 65470, 244}, {65474, 65479, 245}, {65482, 65487, 246}, {65490, 65495, 247}, {65498, 65500, 248}, },
            {{0, 9, 1}, {11, 12, 1}, {14, 32, 1}, {127, 160, 1}, {8206, 8233, -2}, },
            {},
            {},
            {{42, 42, 249}, {47, 47, 250}, },
            {{39, 39, 251}, {48, 57, 252}, {65, 90, 253}, {95, 95, 254}, {97, 122, 255}, {170, 170, 256}, {181, 181, 257}, {186, 186, 258}, {192, 214, 259}, {216, 246, 260}, {248, 501, 261}, {506, 535, 262}, {592, 680, 263}, {688, 696, 264}, {699, 705, 265}, {720, 721, 266}, {736, 740, 267}, {890, 890, 268}, {902, 902, 269}, {904, 906, 270}, {908, 908, 271}, {910, 929, 272}, {931, 974, 273}, {976, 982, 274}, {986, 986, 275}, {988, 988, 276}, {990, 990, 277}, {992, 992, 278}, {994, 1011, 279}, {1025, 1036, 280}, {1038, 1103, 281}, {1105, 1116, 282}, {1118, 1153, 283}, {1168, 1220, 284}, {1223, 1224, 285}, {1227, 1228, 286}, {1232, 1259, 287}, {1262, 1269, 288}, {1272, 1273, 289}, {1329, 1366, 290}, {1369, 1369, 291}, {1377, 1415, 292}, {1488, 1514, 293}, {1520, 1522, 294}, {1569, 1594, 295}, {1600, 1610, 296}, {1632, 1641, 297}, {1649, 1719, 298}, {1722, 1726, 299}, {1728, 1742, 300}, {1744, 1747, 301}, {1749, 1749, 302}, {1765, 1766, 303}, {1776, 1785, 304}, {2309, 2361, 305}, {2365, 2365, 306}, {2392, 2401, 307}, {2406, 2415, 308}, {2437, 2444, 309}, {2447, 2448, 310}, {2451, 2472, 311}, {2474, 2480, 312}, {2482, 2482, 313}, {2486, 2489, 314}, {2524, 2525, 315}, {2527, 2529, 316}, {2534, 2543, 317}, {2544, 2545, 318}, {2565, 2570, 319}, {2575, 2576, 320}, {2579, 2600, 321}, {2602, 2608, 322}, {2610, 2611, 323}, {2613, 2614, 324}, {2616, 2617, 325}, {2649, 2652, 326}, {2654, 2654, 327}, {2662, 2671, 328}, {2674, 2676, 329}, {2693, 2699, 330}, {2701, 2701, 331}, {2703, 2705, 332}, {2707, 2728, 333}, {2730, 2736, 334}, {2738, 2739, 335}, {2741, 2745, 336}, {2749, 2749, 337}, {2784, 2784, 338}, {2790, 2799, 339}, {2821, 2828, 340}, {2831, 2832, 341}, {2835, 2856, 342}, {2858, 2864, 343}, {2866, 2867, 344}, {2870, 2873, 345}, {2877, 2877, 346}, {2908, 2909, 347}, {2911, 2913, 348}, {2918, 2927, 349}, {2949, 2954, 350}, {2958, 2960, 351}, {2962, 2965, 352}, {2969, 2970, 353}, {2972, 2972, 354}, {2974, 2975, 355}, {2979, 2980, 356}, {2984, 2986, 357}, {2990, 2997, 358}, {2999, 3001, 359}, {3047, 3055, 360}, {3077, 3084, 361}, {3086, 3088, 362}, {3090, 3112, 363}, {3114, 3123, 364}, {3125, 3129, 365}, {3168, 3169, 366}, {3174, 3183, 367}, {3205, 3212, 368}, {3214, 3216, 369}, {3218, 3240, 370}, {3242, 3251, 371}, {3253, 3257, 372}, {3294, 3294, 373}, {3296, 3297, 374}, {3302, 3311, 375}, {3333, 3340, 376}, {3342, 3344, 377}, {3346, 3368, 378}, {3370, 3385, 379}, {3424, 3425, 380}, {3430, 3439, 381}, {3585, 3630, 382}, {3632, 3632, 383}, {3634, 3635, 384}, {3648, 3654, 385}, {3664, 3673, 386}, {3713, 3714, 387}, {3716, 3716, 388}, {3719, 3720, 389}, {3722, 3722, 390}, {3725, 3725, 391}, {3732, 3735, 392}, {3737, 3743, 393}, {3745, 3747, 394}, {3749, 3749, 395}, {3751, 3751, 396}, {3754, 3755, 397}, {3757, 3758, 398}, {3760, 3760, 399}, {3762, 3763, 400}, {3773, 3773, 401}, {3776, 3780, 402}, {3782, 3782, 403}, {3792, 3801, 404}, {3804, 3805, 405}, {3872, 3881, 406}, {3904, 3911, 407}, {3913, 3945, 408}, {4256, 4293, 409}, {4304, 4342, 410}, {4352, 4441, 411}, {4447, 4514, 412}, {4520, 4601, 413}, {7680, 7835, 414}, {7840, 7929, 415}, {7936, 7957, 416}, {7960, 7965, 417}, {7968, 8005, 418}, {8008, 8013, 419}, {8016, 8023, 420}, {8025, 8025, 421}, {8027, 8027, 422}, {8029, 8029, 423}, {8031, 8061, 424}, {8064, 8116, 425}, {8118, 8124, 426}, {8126, 8126, 427}, {8130, 8132, 428}, {8134, 8140, 429}, {8144, 8147, 430}, {8150, 8155, 431}, {8160, 8172, 432}, {8178, 8180, 433}, {8182, 8188, 434}, {8319, 8319, 435}, {8450, 8450, 436}, {8455, 8455, 437}, {8458, 8467, 438}, {8469, 8469, 439}, {8472, 8477, 440}, {8484, 8484, 441}, {8486, 8486, 442}, {8488, 8488, 443}, {8490, 8497, 444}, {8499, 8504, 445}, {12293, 12293, 446}, {12337, 12341, 447}, {12353, 12436, 448}, {12443, 12446, 449}, {12449, 12538, 450}, {12540, 12542, 451}, {12549, 12588, 452}, {12593, 12686, 453}, {19968, 40869, 454}, {44032, 55203, 455}, {63744, 64045, 456}, {64256, 64262, 457}, {64275, 64279, 458}, {64287, 64296, 459}, {64298, 64310, 460}, {64312, 64316, 461}, {64318, 64318, 462}, {64320, 64321, 463}, {64323, 64324, 464}, {64326, 64433, 465}, {64467, 64829, 466}, {64848, 64911, 467}, {64914, 64967, 468}, {65008, 65019, 469}, {65136, 65138, 470}, {65140, 65140, 471}, {65142, 65276, 472}, {65296, 65305, 473}, {65313, 65338, 474}, {65345, 65370, 475}, {65382, 65470, 476}, {65474, 65479, 477}, {65482, 65487, 478}, {65490, 65495, 479}, {65498, 65500, 480}, },
            {},
            {},
            {},
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 95, -7}, {97, 109, 255}, {110, 110, 481}, {111, 119, 255}, {120, 120, 482}, {121, 122, 255}, {170, 65500, -7}, },
            {{39, 95, -7}, {97, 100, 255}, {101, 101, 483}, {102, 122, 255}, {170, 65500, -7}, },
            {{39, 95, -7}, {97, 110, 255}, {111, 111, 484}, {112, 122, 255}, {170, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 109, -13}, {110, 110, 485}, {111, 117, 255}, {118, 118, 486}, {119, 119, 255}, {120, 120, 487}, {121, 65500, -13}, },
            {{39, 109, -13}, {110, 110, 488}, {111, 122, 255}, {170, 65500, -7}, },
            {{39, 95, -7}, {97, 97, 489}, {98, 122, 255}, {170, 65500, -7}, },
            {{39, 95, -7}, {97, 113, 255}, {114, 114, 490}, {115, 122, 255}, {170, 65500, -7}, },
            {{39, 100, -14}, {101, 101, 491}, {102, 65500, -14}, },
            {{39, 100, -14}, {101, 101, 492}, {102, 65500, -14}, },
            {{39, 95, -7}, {97, 103, 255}, {104, 104, 493}, {105, 122, 255}, {170, 65500, -7}, },
            {{39, 95, -7}, {97, 97, 494}, {98, 65500, -19}, },
            {{39, 103, -23}, {104, 104, 495}, {105, 105, 496}, {106, 122, 255}, {170, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{32, 32, 497}, },
            {{32, 32, 498}, },
            {},
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 95, -7}, {97, 115, 255}, {116, 116, 499}, {117, 120, 255}, {121, 121, 500}, {122, 122, 255}, {170, 65500, -7}, },
            {{39, 95, -7}, {97, 104, 255}, {105, 105, 501}, {106, 65500, -25}, },
            {{39, 95, -7}, {97, 102, 255}, {103, 103, 502}, {104, 122, 255}, {170, 65500, -7}, },
            {{39, 109, -13}, {110, 110, 503}, {111, 65500, -18}, },
            {{39, 95, -7}, {97, 99, 255}, {100, 100, 504}, {101, 122, 255}, {170, 65500, -7}, },
            {{39, 100, -14}, {101, 101, 505}, {102, 65500, -14}, },
            {{39, 115, -483}, {116, 116, 506}, {117, 122, 255}, {170, 65500, -7}, },
            {{39, 95, -7}, {97, 117, 255}, {118, 118, 507}, {119, 122, 255}, {170, 65500, -7}, },
            {{39, 95, -7}, {97, 98, 255}, {99, 99, 508}, {100, 122, 255}, {170, 65500, -7}, },
            {{39, 99, -487}, {100, 100, 509}, {101, 65500, -487}, },
            {{39, 95, -7}, {97, 101, 255}, {102, 102, 510}, {103, 122, 255}, {170, 65500, -7}, },
            {{39, 100, -14}, {101, 101, 511}, {102, 115, 255}, {116, 116, 512}, {117, 65500, -489}, },
            {{39, 100, -14}, {101, 101, 513}, {102, 65500, -14}, },
            {{39, 113, -20}, {114, 114, 514}, {115, 65500, -20}, },
            {{39, 100, -14}, {101, 101, 515}, {102, 65500, -14}, },
            {{39, 115, -483}, {116, 116, 516}, {117, 65500, -489}, },
            {{32, 32, 497}, },
            {{32, 32, 498}, },
            {{39, 104, -484}, {105, 105, 517}, {106, 65500, -25}, },
            {{39, 65500, -7}, },
            {{39, 110, -15}, {111, 111, 518}, {112, 65500, -15}, },
            {{39, 104, -484}, {105, 105, 519}, {106, 65500, -25}, },
            {{39, 95, -7}, {97, 114, 255}, {115, 115, 520}, {116, 116, 521}, {117, 117, 255}, {118, 118, 522}, {119, 65500, -490}, },
            {{39, 65500, -7}, },
            {{39, 109, -13}, {110, 110, 523}, {111, 65500, -18}, },
            {{39, 100, -14}, {101, 101, 524}, {102, 65500, -14}, },
            {{39, 95, -7}, {97, 97, 525}, {98, 65500, -19}, },
            {{39, 103, -23}, {104, 104, 526}, {105, 65500, -23}, },
            {{39, 104, -484}, {105, 105, 527}, {106, 65500, -25}, },
            {{39, 104, -484}, {105, 105, 528}, {106, 65500, -25}, },
            {{39, 114, -505}, {115, 115, 529}, {116, 122, 255}, {170, 65500, -7}, },
            {{39, 114, -505}, {115, 115, 530}, {116, 65500, -513}, },
            {{39, 109, -13}, {110, 110, 531}, {111, 111, 532}, {112, 65500, -15}, },
            {{39, 104, -484}, {105, 105, 533}, {106, 65500, -25}, },
            {{39, 109, -13}, {110, 110, 534}, {111, 113, 255}, {114, 114, 535}, {115, 65500, -20}, },
            {{39, 103, -23}, {104, 104, 536}, {105, 65500, -23}, },
            {{39, 98, -491}, {99, 99, 537}, {100, 65500, -491}, },
            {{39, 95, -7}, {97, 108, 255}, {109, 109, 538}, {110, 122, 255}, {170, 65500, -7}, },
            {{39, 109, -13}, {110, 110, 539}, {111, 65500, -18}, },
            {{39, 115, -483}, {116, 116, 540}, {117, 65500, -489}, },
            {{39, 100, -14}, {101, 101, 541}, {102, 65500, -14}, },
            {{39, 100, -14}, {101, 101, 542}, {102, 65500, -14}, },
            {{39, 115, -483}, {116, 116, 543}, {117, 65500, -489}, },
            {{39, 109, -13}, {110, 110, 544}, {111, 65500, -18}, },
            {{39, 113, -20}, {114, 114, 545}, {115, 65500, -20}, },
            {{39, 104, -484}, {105, 105, 546}, {106, 65500, -25}, },
            {{39, 109, -13}, {110, 110, 547}, {111, 65500, -18}, },
            {{39, 109, -13}, {110, 110, 548}, {111, 65500, -18}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 113, -20}, {114, 114, 549}, {115, 65500, -20}, },
            {{39, 95, -7}, {97, 97, 550}, {98, 65500, -19}, },
            {{39, 65500, -7}, },
            {{39, 100, -14}, {101, 101, 551}, {102, 65500, -14}, },
            {{39, 65500, -7}, },
            {{39, 104, -484}, {105, 105, 552}, {106, 65500, -25}, },
            {{39, 114, -505}, {115, 115, 553}, {116, 65500, -513}, },
            {{39, 65500, -7}, },
            {{39, 95, -7}, {97, 97, 554}, {98, 65500, -19}, },
            {{39, 95, -7}, {97, 119, 255}, {120, 120, 555}, {121, 65500, -13}, },
            {{39, 113, -20}, {114, 114, 556}, {115, 65500, -20}, },
            {{39, 114, -505}, {115, 115, 557}, {116, 65500, -513}, },
            {{39, 99, -487}, {100, 100, 558}, {101, 65500, -487}, },
            {{39, 104, -484}, {105, 105, 559}, {106, 65500, -25}, },
            {{39, 109, -13}, {110, 110, 560}, {111, 65500, -18}, },
            {{39, 95, -7}, {97, 97, 561}, {98, 65500, -19}, },
            {{39, 100, -14}, {101, 101, 562}, {102, 65500, -14}, },
            {{39, 100, -14}, {101, 101, 563}, {102, 65500, -14}, },
            {{39, 95, -7}, {97, 97, 255}, {98, 98, 564}, {99, 109, 255}, {110, 110, 565}, {111, 65500, -18}, },
            {{39, 65500, -7}, },
            {{39, 95, -7}, {97, 111, 255}, {112, 112, 566}, {113, 122, 255}, {170, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 109, -13}, {110, 110, 567}, {111, 65500, -18}, },
            {{39, 115, -483}, {116, 116, 568}, {117, 65500, -489}, },
            {{39, 102, -485}, {103, 103, 569}, {104, 65500, -485}, },
            {{39, 65500, -7}, },
            {{39, 114, -505}, {115, 115, 570}, {116, 65500, -513}, },
            {{39, 95, -7}, {97, 97, 571}, {98, 65500, -19}, },
            {{39, 100, -14}, {101, 101, 572}, {102, 65500, -14}, },
            {{39, 113, -20}, {114, 114, 573}, {115, 65500, -20}, },
            {{39, 114, -505}, {115, 115, 574}, {116, 65500, -513}, },
            {{39, 108, -520}, {109, 109, 575}, {110, 65500, -520}, },
            {{39, 95, -7}, {97, 107, 255}, {108, 108, 576}, {109, 122, 255}, {170, 65500, -7}, },
            {{39, 115, -483}, {116, 116, 577}, {117, 65500, -489}, },
            {{39, 95, -7}, {97, 97, 578}, {98, 65500, -19}, },
            {{39, 115, -483}, {116, 116, 579}, {117, 65500, -489}, },
            {{39, 65500, -7}, },
            {{39, 100, -14}, {101, 101, 580}, {102, 65500, -14}, },
            {{39, 65500, -7}, },
            {{39, 109, -13}, {110, 110, 581}, {111, 65500, -18}, },
            {{39, 65500, -7}, },
            {{39, 95, -7}, {97, 120, 255}, {121, 121, 582}, {122, 65500, -483}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 100, -14}, {101, 101, 583}, {102, 65500, -14}, },
            {{39, 65500, -7}, },
            {{39, 115, -483}, {116, 116, 584}, {117, 65500, -489}, },
            {{39, 114, -505}, {115, 115, 585}, {116, 65500, -513}, },
            {{39, 109, -13}, {110, 110, 586}, {111, 65500, -18}, },
            {{39, 115, -483}, {116, 116, 587}, {117, 65500, -489}, },
            {{39, 65500, -7}, },
            {{39, 114, -505}, {115, 115, 588}, {116, 65500, -513}, },
            {{39, 100, -14}, {101, 101, 589}, {102, 65500, -14}, },
            {{39, 65500, -7}, },
            {{39, 115, -483}, {116, 116, 590}, {117, 65500, -489}, },
            {{39, 114, -505}, {115, 115, 591}, {116, 65500, -513}, },
            {{39, 65500, -7}, },
            {{39, 99, -487}, {100, 100, 592}, {101, 65500, -487}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
            {{39, 65500, -7}, },
        }
        { // FORMULA
            {{0, 9, 1}, {10, 10, 2}, {11, 12, 1}, {13, 13, 2}, {14, 32, 1}, {33, 46, 3}, {47, 47, 4}, {48, 63, 3}, {64, 64, 5}, {65, 96, 3}, {97, 97, 6}, {98, 98, 7}, {99, 99, 8}, {100, 100, 3}, {101, 101, 9}, {102, 104, 3}, {105, 105, 10}, {106, 108, 3}, {109, 109, 11}, {110, 110, 3}, {111, 111, 12}, {112, 113, 3}, {114, 114, 13}, {115, 115, 14}, {116, 116, 15}, {117, 117, 3}, {118, 118, 16}, {119, 119, 17}, {120, 126, 3}, {127, 160, 1}, {161, 8205, 3}, {8206, 8207, 1}, {8208, 8231, 3}, {8232, 8233, 1}, {8234, 65535, 3}, },
            {{0, 9, 1}, {11, 12, 1}, {14, 32, 1}, {127, 160, 1}, {8206, 8207, 1}, {8232, 8233, 1}, },
            {},
            {{33, 46, 3}, {48, 63, 3}, {65, 126, 3}, {161, 8205, 3}, {8208, 8231, 3}, {8234, 65535, 3}, },
            {{42, 42, 18}, {47, 47, 19}, },
            {},
            {{33, 63, -5}, {65, 109, 3}, {110, 110, 20}, {111, 119, 3}, {120, 120, 21}, {121, 126, 3}, {161, 65535, -5}, },
            {{33, 63, -5}, {65, 100, 3}, {101, 101, 22}, {102, 126, 3}, {161, 65535, -5}, },
            {{33, 63, -5}, {65, 110, 3}, {111, 111, 23}, {112, 126, 3}, {161, 65535, -5}, },
            {{33, 109, -8}, {110, 110, 24}, {111, 117, 3}, {118, 118, 25}, {119, 119, 3}, {120, 120, 26}, {121, 65535, -8}, },
            {{33, 109, -8}, {110, 110, 27}, {111, 126, 3}, {161, 65535, -5}, },
            {{33, 63, -5}, {65, 96, 3}, {97, 97, 28}, {98, 126, 3}, {161, 65535, -5}, },
            {{33, 63, -5}, {65, 113, 3}, {114, 114, 29}, {115, 126, 3}, {161, 65535, -5}, },
            {{33, 100, -9}, {101, 101, 30}, {102, 65535, -9}, },
            {{33, 100, -9}, {101, 101, 31}, {102, 65535, -9}, },
            {{33, 63, -5}, {65, 103, 3}, {104, 104, 32}, {105, 126, 3}, {161, 65535, -5}, },
            {{33, 96, -13}, {97, 97, 33}, {98, 65535, -13}, },
            {{33, 103, -17}, {104, 104, 34}, {105, 105, 35}, {106, 126, 3}, {161, 65535, -5}, },
            {{32, 32, 36}, },
            {{32, 32, 37}, },
            {{33, 63, -5}, {65, 115, 3}, {116, 116, 38}, {117, 120, 3}, {121, 121, 39}, {122, 126, 3}, {161, 65535, -5}, },
            {{33, 63, -5}, {65, 104, 3}, {105, 105, 40}, {106, 65535, -19}, },
            {{33, 63, -5}, {65, 102, 3}, {103, 103, 41}, {104, 126, 3}, {161, 65535, -5}, },
            {{33, 109, -8}, {110, 110, 42}, {111, 65535, -12}, },
            {{33, 63, -5}, {65, 99, 3}, {100, 100, 43}, {101, 126, 3}, {161, 65535, -5}, },
            {{33, 100, -9}, {101, 101, 44}, {102, 65535, -9}, },
            {{33, 115, -22}, {116, 116, 45}, {117, 126, 3}, {161, 65535, -5}, },
            {{33, 63, -5}, {65, 117, 3}, {118, 118, 46}, {119, 126, 3}, {161, 65535, -5}, },
            {{33, 63, -5}, {65, 98, 3}, {99, 99, 47}, {100, 126, 3}, {161, 65535, -5}, },
            {{33, 99, -26}, {100, 100, 48}, {101, 65535, -26}, },
            {{33, 63, -5}, {65, 101, 3}, {102, 102, 49}, {103, 126, 3}, {161, 65535, -5}, },
            {{33, 100, -9}, {101, 101, 50}, {102, 115, 3}, {116, 116, 51}, {117, 65535, -28}, },
            {{33, 100, -9}, {101, 101, 52}, {102, 65535, -9}, },
            {{33, 113, -14}, {114, 114, 53}, {115, 65535, -14}, },
            {{33, 100, -9}, {101, 101, 54}, {102, 65535, -9}, },
            {{33, 115, -22}, {116, 116, 55}, {117, 65535, -28}, },
            {{32, 32, 36}, },
            {{32, 32, 37}, },
            {{33, 104, -23}, {105, 105, 56}, {106, 65535, -19}, },
            {{33, 65535, -5}, },
            {{33, 110, -10}, {111, 111, 57}, {112, 65535, -10}, },
            {{33, 104, -23}, {105, 105, 58}, {106, 65535, -19}, },
            {{33, 63, -5}, {65, 114, 3}, {115, 115, 59}, {116, 116, 60}, {117, 117, 3}, {118, 118, 61}, {119, 65535, -29}, },
            {{33, 65535, -5}, },
            {{33, 109, -8}, {110, 110, 62}, {111, 65535, -12}, },
            {{33, 100, -9}, {101, 101, 63}, {102, 65535, -9}, },
            {{33, 96, -13}, {97, 97, 64}, {98, 65535, -13}, },
            {{33, 103, -17}, {104, 104, 65}, {105, 65535, -17}, },
            {{33, 104, -23}, {105, 105, 66}, {106, 65535, -19}, },
            {{33, 104, -23}, {105, 105, 67}, {106, 65535, -19}, },
            {{33, 114, -44}, {115, 115, 68}, {116, 126, 3}, {161, 65535, -5}, },
            {{33, 114, -44}, {115, 115, 69}, {116, 65535, -52}, },
            {{33, 109, -8}, {110, 110, 70}, {111, 111, 71}, {112, 65535, -10}, },
            {{33, 104, -23}, {105, 105, 72}, {106, 65535, -19}, },
            {{33, 109, -8}, {110, 110, 73}, {111, 113, 3}, {114, 114, 74}, {115, 65535, -14}, },
            {{33, 103, -17}, {104, 104, 75}, {105, 65535, -17}, },
            {{33, 98, -30}, {99, 99, 76}, {100, 65535, -30}, },
            {{33, 63, -5}, {65, 108, 3}, {109, 109, 77}, {110, 126, 3}, {161, 65535, -5}, },
            {{33, 109, -8}, {110, 110, 78}, {111, 65535, -12}, },
            {{33, 115, -22}, {116, 116, 79}, {117, 65535, -28}, },
            {{33, 100, -9}, {101, 101, 80}, {102, 65535, -9}, },
            {{33, 100, -9}, {101, 101, 81}, {102, 65535, -9}, },
            {{33, 115, -22}, {116, 116, 82}, {117, 65535, -28}, },
            {{33, 109, -8}, {110, 110, 83}, {111, 65535, -12}, },
            {{33, 113, -14}, {114, 114, 84}, {115, 65535, -14}, },
            {{33, 104, -23}, {105, 105, 85}, {106, 65535, -19}, },
            {{33, 109, -8}, {110, 110, 86}, {111, 65535, -12}, },
            {{33, 109, -8}, {110, 110, 87}, {111, 65535, -12}, },
            {{33, 65535, -5}, },
            {{33, 65535, -5}, },
            {{33, 65535, -5}, },
            {{33, 113, -14}, {114, 114, 88}, {115, 65535, -14}, },
            {{33, 96, -13}, {97, 97, 89}, {98, 65535, -13}, },
            {{33, 65535, -5}, },
            {{33, 100, -9}, {101, 101, 90}, {102, 65535, -9}, },
            {{33, 65535, -5}, },
            {{33, 104, -23}, {105, 105, 91}, {106, 65535, -19}, },
            {{33, 114, -44}, {115, 115, 92}, {116, 65535, -52}, },
            {{33, 65535, -5}, },
            {{33, 96, -13}, {97, 97, 93}, {98, 65535, -13}, },
            {{33, 63, -5}, {65, 119, 3}, {120, 120, 94}, {121, 65535, -8}, },
            {{33, 113, -14}, {114, 114, 95}, {115, 65535, -14}, },
            {{33, 114, -44}, {115, 115, 96}, {116, 65535, -52}, },
            {{33, 99, -26}, {100, 100, 97}, {101, 65535, -26}, },
            {{33, 104, -23}, {105, 105, 98}, {106, 65535, -19}, },
            {{33, 109, -8}, {110, 110, 99}, {111, 65535, -12}, },
            {{33, 96, -13}, {97, 97, 100}, {98, 65535, -13}, },
            {{33, 100, -9}, {101, 101, 101}, {102, 65535, -9}, },
            {{33, 100, -9}, {101, 101, 102}, {102, 65535, -9}, },
            {{33, 63, -5}, {65, 97, 3}, {98, 98, 103}, {99, 109, 3}, {110, 110, 104}, {111, 65535, -12}, },
            {{33, 65535, -5}, },
            {{33, 63, -5}, {65, 111, 3}, {112, 112, 105}, {113, 126, 3}, {161, 65535, -5}, },
            {{33, 65535, -5}, },
            {{33, 109, -8}, {110, 110, 106}, {111, 65535, -12}, },
            {{33, 115, -22}, {116, 116, 107}, {117, 65535, -28}, },
            {{33, 102, -24}, {103, 103, 108}, {104, 65535, -24}, },
            {{33, 65535, -5}, },
            {{33, 114, -44}, {115, 115, 109}, {116, 65535, -52}, },
            {{33, 96, -13}, {97, 97, 110}, {98, 65535, -13}, },
            {{33, 100, -9}, {101, 101, 111}, {102, 65535, -9}, },
            {{33, 113, -14}, {114, 114, 112}, {115, 65535, -14}, },
            {{33, 114, -44}, {115, 115, 113}, {116, 65535, -52}, },
            {{33, 108, -59}, {109, 109, 114}, {110, 65535, -59}, },
            {{33, 63, -5}, {65, 107, 3}, {108, 108, 115}, {109, 126, 3}, {161, 65535, -5}, },
            {{33, 115, -22}, {116, 116, 116}, {117, 65535, -28}, },
            {{33, 96, -13}, {97, 97, 117}, {98, 65535, -13}, },
            {{33, 115, -22}, {116, 116, 118}, {117, 65535, -28}, },
            {{33, 65535, -5}, },
            {{33, 100, -9}, {101, 101, 119}, {102, 65535, -9}, },
            {{33, 65535, -5}, },
            {{33, 109, -8}, {110, 110, 120}, {111, 65535, -12}, },
            {{33, 65535, -5}, },
            {{33, 63, -5}, {65, 120, 3}, {121, 121, 121}, {122, 65535, -22}, },
            {{33, 65535, -5}, },
            {{33, 65535, -5}, },
            {{33, 100, -9}, {101, 101, 122}, {102, 65535, -9}, },
            {{33, 65535, -5}, },
            {{33, 115, -22}, {116, 116, 123}, {117, 65535, -28}, },
            {{33, 114, -44}, {115, 115, 124}, {116, 65535, -52}, },
            {{33, 109, -8}, {110, 110, 125}, {111, 65535, -12}, },
            {{33, 115, -22}, {116, 116, 126}, {117, 65535, -28}, },
            {{33, 65535, -5}, },
            {{33, 114, -44}, {115, 115, 127}, {116, 65535, -52}, },
            {{33, 100, -9}, {101, 101, 128}, {102, 65535, -9}, },
            {{33, 65535, -5}, },
            {{33, 115, -22}, {116, 116, 129}, {117, 65535, -28}, },
            {{33, 114, -44}, {115, 115, 130}, {116, 65535, -52}, },
            {{33, 65535, -5}, },
            {{33, 99, -26}, {100, 100, 131}, {101, 65535, -26}, },
            {{33, 65535, -5}, },
            {{33, 65535, -5}, },
            {{33, 65535, -5}, },
        }
        { // LABEL
            {{0, 9, 1}, {10, 10, 2}, {11, 12, 1}, {13, 13, 2}, {14, 32, 1}, {33, 126, 3}, {127, 160, 1}, {161, 8205, 3}, {8206, 8207, 1}, {8208, 8231, 3}, {8232, 8233, 1}, {8234, 65535, 3}, },
            {{0, 9, 1}, {11, 12, 1}, {14, 32, 1}, {127, 160, 1}, {8206, 8207, 1}, {8232, 8233, 1}, },
            {{10, 10, 3}, {13, 13, 3}, {33, 38, 3}, {39, 39, 4}, {40, 126, 3}, {161, 8205, 3}, {8208, 8231, 3}, {8234, 65535, 3}, },
            {{10, 65535, -4}, },
            {{10, 65535, -4}, },
        }
        { // COMMENT
            {{0, 9, 1}, {10, 10, 2}, {11, 12, 1}, {13, 13, 2}, {14, 65535, 1}, },
            {{0, 9, 1}, {11, 12, 1}, {14, 65535, 1}, },
            {},
        }
        { // MULTI_COMMENT
            {{0, 41, 1}, {42, 42, 2}, {43, 46, 1}, {47, 47, 3}, {48, 65535, 1}, },
            {{0, 41, 1}, {43, 46, 1}, {48, 65535, 1}, },
            {{47, 47, 4}, },
            {},
            {},
        }
    };*/

    private static int[][] accept;
/*  {
        // NORMAL
        {-1, 36, 36, 9, -1, 34, 10, 11, 8, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 3, 0, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 3, 0, 34, 30, 34, 34, 34, 23, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 17, 26, 33, 34, 34, 31, 34, 32, 34, 34, 33, 34, 34, 34, 29, 34, 34, 34, 34, 34, 34, 34, 31, 34, 28, 34, 34, 34, 21, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 24, 34, 25, 34, 15, 34, 16, 20, 34, 22, 34, 34, 34, 34, 12, 34, 34, 27, 34, 34, 18, 34, 13, 19, 14, },
        // FORMULA
        {-1, 36, 36, 37, 6, 8, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 3, 0, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 3, 0, 37, 30, 37, 37, 37, 23, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 17, 26, 33, 37, 37, 31, 37, 32, 37, 37, 33, 37, 37, 37, 29, 37, 37, 37, 37, 37, 37, 37, 31, 37, 28, 37, 37, 37, 21, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 24, 37, 25, 37, 15, 37, 16, 20, 37, 22, 37, 37, 37, 37, 12, 37, 37, 27, 37, 37, 18, 37, 13, 19, 14, },
        // LABEL
        {-1, 36, 35, 35, 35, },
        // COMMENT
        {1, 1, 2, },
        // MULTI_COMMENT
        {4, 4, 5, 6, 7, },

    };*/

    public static class State
    {
        public final static State NORMAL = new State(0);
        public final static State FORMULA = new State(1);
        public final static State LABEL = new State(2);
        public final static State COMMENT = new State(3);
        public final static State MULTI_COMMENT = new State(4);

        private int id;

        private State(  int id)
        {
            this.id = id;
        }

        public int id()
        {
            return this.id;
        }
    }

    static 
    {
        try
        {
            DataInputStream s = new DataInputStream(
                new BufferedInputStream(
                Lexer.class.getResourceAsStream("lexer.dat")));

            // read gotoTable
            int length = s.readInt();
            gotoTable = new int[length][][][];
            for(int i = 0; i < gotoTable.length; i++)
            {
                length = s.readInt();
                gotoTable[i] = new int[length][][];
                for(int j = 0; j < gotoTable[i].length; j++)
                {
                    length = s.readInt();
                    gotoTable[i][j] = new int[length][3];
                    for(int k = 0; k < gotoTable[i][j].length; k++)
                    {
                        for(int l = 0; l < 3; l++)
                        {
                            gotoTable[i][j][k][l] = s.readInt();
                        }
                    }
                }
            }

            // read accept
            length = s.readInt();
            accept = new int[length][];
            for(int i = 0; i < accept.length; i++)
            {
                length = s.readInt();
                accept[i] = new int[length];
                for(int j = 0; j < accept[i].length; j++)
                {
                    accept[i][j] = s.readInt();
                }
            }

            s.close();
        }
        catch(Exception e)
        {
            throw new RuntimeException("The file \"lexer.dat\" is either missing or corrupted.");
        }
    }
}
