/* This file was generated by SableCC (http://www.sablecc.org/). */

package de.be4.classicalb.core.parser.lexer;

import java.io.*;
import java.util.*;
import de.be4.classicalb.core.parser.node.*;
import de.hhu.stups.sablecc.patch.*;
import java.util.concurrent.LinkedBlockingQueue;

@SuppressWarnings({"unused"}) 
public class Lexer implements ITokenListContainer
{
    protected Token token;
    protected State state = State.NORMAL;

    private PushbackReader in;
    private int line;
    private int pos;
    private boolean cr;
    private boolean eof;
    private final StringBuffer text = new StringBuffer();
    
	private List<IToken> tokenList;
    private final Queue<IToken> nextList = new LinkedBlockingQueue<IToken>();

	private IToken tok;

    public Queue<IToken> getNextList() {
        return nextList;
    }

	public List<IToken> getTokenList() {
		return tokenList;
	}
	
	private void setToken(Token t) {
	  tok = t;
   	  token = t;	
	}
	
	
	public void setTokenList(final List<IToken> list) {
		tokenList = list;
	}

     
    protected void filter() throws LexerException, IOException
    {
        // Do nothing
    }

    protected void filterWrap() throws LexerException, IOException
    {
       filter();
       if (token != null) {
	          getTokenList().add(token); 
              nextList.add(token);
	   }
    }


    public Lexer(  PushbackReader in)
    {
        this.in = in;
    	setTokenList(new ArrayList<IToken>());
    }
    
    public Token peek() throws LexerException, IOException
    {
        while(this.token == null)
        {
            this.setToken(getToken());
            filterWrap();
        }

        return (Token) nextList.peek();
    }

    public Token next() throws LexerException, IOException
    {
        while(this.token == null)
        {
            this.setToken(getToken());
            filterWrap();
        }

        Token result = (Token) nextList.poll();
        this.setToken(null);
        return result;
    }

    protected Token getToken() throws IOException, LexerException
    {
        int dfa_state = 0;

        int start_pos = this.pos;
        int start_line = this.line;

        int accept_state = -1;
        int accept_token = -1;
        int accept_length = -1;
        int accept_pos = -1;
        int accept_line = -1;

          int[][][] gotoTable = Lexer.gotoTable[this.state.id()];
          int[] accept = Lexer.accept[this.state.id()];
        this.text.setLength(0);

        while(true)
        {
            int c = getChar();

            if(c != -1)
            {
                switch(c)
                {
                case 10:
                    if(this.cr)
                    {
                        this.cr = false;
                    }
                    else
                    {
                        this.line++;
                        this.pos = 0;
                    }
                    break;
                case 13:
                    this.line++;
                    this.pos = 0;
                    this.cr = true;
                    break;
                default:
                    this.pos++;
                    this.cr = false;
                    break;
                }

                this.text.append((char) c);

                do
                {
                    int oldState = (dfa_state < -1) ? (-2 -dfa_state) : dfa_state;

                    dfa_state = -1;

                    int[][] tmp1 =  gotoTable[oldState];
                    int low = 0;
                    int high = tmp1.length - 1;

                    while(low <= high)
                    {
                        int middle = (low + high) / 2;
                        int[] tmp2 = tmp1[middle];

                        if(c < tmp2[0])
                        {
                            high = middle - 1;
                        }
                        else if(c > tmp2[1])
                        {
                            low = middle + 1;
                        }
                        else
                        {
                            dfa_state = tmp2[2];
                            break;
                        }
                    }
                }while(dfa_state < -1);
            }
            else
            {
                dfa_state = -1;
            }

            if(dfa_state >= 0)
            {
                if(accept[dfa_state] != -1)
                {
                    accept_state = dfa_state;
                    accept_token = accept[dfa_state];
                    accept_length = this.text.length();
                    accept_pos = this.pos;
                    accept_line = this.line;
                }
            }
            else
            {
                if(accept_state != -1)
                {
                    switch(accept_token)
                    {
                    case 0:
                        {
                              Token token = new0(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.SHEBANG; break;
                                case 1: state = State.SHEBANG; break;
                            }
                            return token;
                        }
                    case 1:
                        {
                              Token token = new1(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 2:
                        {
                              Token token = new2(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.SHEBANG; break;
                            }
                            return token;
                        }
                    case 3:
                        {
                              Token token = new3(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 2: state = State.COMMENT; break;
                                case 0: state = State.COMMENT; break;
                            }
                            return token;
                        }
                    case 4:
                        {
                              Token token = new4(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 2: state = State.COMMENT; break;
                            }
                            return token;
                        }
                    case 5:
                        {
                              Token token = new5(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 2: state = State.COMMENT; break;
                            }
                            return token;
                        }
                    case 6:
                        {
                              Token token = new6(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 2: state = State.COMMENT; break;
                            }
                            return token;
                        }
                    case 7:
                        {
                              Token token = new7(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 2: state = State.COMMENT; break;
                            }
                            return token;
                        }
                    case 8:
                        {
                              Token token = new8(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 9:
                        {
                              Token token = new9(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 10:
                        {
                              Token token = new10(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 11:
                        {
                              Token token = new11(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 12:
                        {
                              Token token = new12(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 13:
                        {
                              Token token = new13(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 14:
                        {
                              Token token = new14(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 15:
                        {
                              Token token = new15(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 16:
                        {
                              Token token = new16(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 17:
                        {
                              Token token = new17(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 18:
                        {
                              Token token = new18(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 19:
                        {
                              Token token = new19(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 20:
                        {
                              Token token = new20(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 21:
                        {
                              Token token = new21(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 22:
                        {
                              Token token = new22(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 23:
                        {
                              Token token = new23(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 24:
                        {
                              Token token = new24(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 25:
                        {
                              Token token = new25(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 26:
                        {
                              Token token = new26(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 27:
                        {
                              Token token = new27(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 28:
                        {
                              Token token = new28(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 29:
                        {
                              Token token = new29(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 30:
                        {
                              Token token = new30(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 31:
                        {
                              Token token = new31(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 32:
                        {
                              Token token = new32(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 33:
                        {
                              Token token = new33(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 34:
                        {
                              Token token = new34(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 35:
                        {
                              Token token = new35(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 36:
                        {
                              Token token = new36(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 37:
                        {
                              Token token = new37(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 38:
                        {
                              Token token = new38(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 39:
                        {
                              Token token = new39(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 40:
                        {
                              Token token = new40(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 41:
                        {
                              Token token = new41(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 42:
                        {
                              Token token = new42(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 43:
                        {
                              Token token = new43(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 44:
                        {
                              Token token = new44(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 45:
                        {
                              Token token = new45(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 46:
                        {
                              Token token = new46(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 47:
                        {
                              Token token = new47(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 48:
                        {
                              Token token = new48(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 49:
                        {
                              Token token = new49(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 50:
                        {
                              Token token = new50(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 51:
                        {
                              Token token = new51(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 52:
                        {
                              Token token = new52(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 53:
                        {
                              Token token = new53(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 54:
                        {
                              Token token = new54(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 55:
                        {
                              Token token = new55(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 56:
                        {
                              Token token = new56(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 57:
                        {
                              Token token = new57(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 58:
                        {
                              Token token = new58(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 59:
                        {
                              Token token = new59(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 60:
                        {
                              Token token = new60(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 61:
                        {
                              Token token = new61(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 62:
                        {
                              Token token = new62(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 63:
                        {
                              Token token = new63(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 64:
                        {
                              Token token = new64(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 65:
                        {
                              Token token = new65(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 66:
                        {
                              Token token = new66(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 67:
                        {
                              Token token = new67(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 68:
                        {
                              Token token = new68(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 69:
                        {
                              Token token = new69(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 70:
                        {
                              Token token = new70(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 71:
                        {
                              Token token = new71(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 72:
                        {
                              Token token = new72(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 73:
                        {
                              Token token = new73(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 74:
                        {
                              Token token = new74(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 75:
                        {
                              Token token = new75(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 76:
                        {
                              Token token = new76(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 77:
                        {
                              Token token = new77(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 78:
                        {
                              Token token = new78(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 79:
                        {
                              Token token = new79(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 80:
                        {
                              Token token = new80(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 81:
                        {
                              Token token = new81(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 82:
                        {
                              Token token = new82(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 83:
                        {
                              Token token = new83(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 84:
                        {
                              Token token = new84(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 85:
                        {
                              Token token = new85(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 86:
                        {
                              Token token = new86(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 87:
                        {
                              Token token = new87(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 88:
                        {
                              Token token = new88(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 89:
                        {
                              Token token = new89(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 90:
                        {
                              Token token = new90(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 91:
                        {
                              Token token = new91(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 92:
                        {
                              Token token = new92(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 93:
                        {
                              Token token = new93(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 94:
                        {
                              Token token = new94(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 95:
                        {
                              Token token = new95(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 96:
                        {
                              Token token = new96(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 97:
                        {
                              Token token = new97(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 98:
                        {
                              Token token = new98(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 99:
                        {
                              Token token = new99(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 100:
                        {
                              Token token = new100(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 101:
                        {
                              Token token = new101(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 102:
                        {
                              Token token = new102(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 103:
                        {
                              Token token = new103(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 104:
                        {
                              Token token = new104(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 105:
                        {
                              Token token = new105(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 106:
                        {
                              Token token = new106(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 107:
                        {
                              Token token = new107(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 108:
                        {
                              Token token = new108(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 109:
                        {
                              Token token = new109(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 110:
                        {
                              Token token = new110(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 111:
                        {
                              Token token = new111(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 112:
                        {
                              Token token = new112(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 113:
                        {
                              Token token = new113(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 114:
                        {
                              Token token = new114(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 115:
                        {
                              Token token = new115(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 116:
                        {
                              Token token = new116(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 117:
                        {
                              Token token = new117(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 118:
                        {
                              Token token = new118(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 119:
                        {
                              Token token = new119(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 120:
                        {
                              Token token = new120(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 121:
                        {
                              Token token = new121(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 122:
                        {
                              Token token = new122(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 123:
                        {
                              Token token = new123(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 124:
                        {
                              Token token = new124(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 125:
                        {
                              Token token = new125(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 126:
                        {
                              Token token = new126(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 127:
                        {
                              Token token = new127(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 128:
                        {
                              Token token = new128(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 129:
                        {
                              Token token = new129(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 130:
                        {
                              Token token = new130(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 131:
                        {
                              Token token = new131(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 132:
                        {
                              Token token = new132(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 133:
                        {
                              Token token = new133(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 134:
                        {
                              Token token = new134(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 135:
                        {
                              Token token = new135(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 136:
                        {
                              Token token = new136(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 137:
                        {
                              Token token = new137(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 138:
                        {
                              Token token = new138(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 139:
                        {
                              Token token = new139(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 140:
                        {
                              Token token = new140(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 141:
                        {
                              Token token = new141(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 142:
                        {
                              Token token = new142(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 143:
                        {
                              Token token = new143(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 144:
                        {
                              Token token = new144(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 145:
                        {
                              Token token = new145(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 146:
                        {
                              Token token = new146(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 147:
                        {
                              Token token = new147(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 148:
                        {
                              Token token = new148(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 149:
                        {
                              Token token = new149(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 150:
                        {
                              Token token = new150(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 151:
                        {
                              Token token = new151(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 152:
                        {
                              Token token = new152(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 153:
                        {
                              Token token = new153(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 154:
                        {
                              Token token = new154(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 155:
                        {
                              Token token = new155(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 156:
                        {
                              Token token = new156(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 157:
                        {
                              Token token = new157(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 158:
                        {
                              Token token = new158(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 159:
                        {
                              Token token = new159(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 160:
                        {
                              Token token = new160(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 161:
                        {
                              Token token = new161(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 162:
                        {
                              Token token = new162(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 163:
                        {
                              Token token = new163(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 164:
                        {
                              Token token = new164(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 165:
                        {
                              Token token = new165(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 166:
                        {
                              Token token = new166(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 167:
                        {
                              Token token = new167(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 168:
                        {
                              Token token = new168(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 169:
                        {
                              Token token = new169(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 170:
                        {
                              Token token = new170(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 171:
                        {
                              Token token = new171(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 172:
                        {
                              Token token = new172(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 173:
                        {
                              Token token = new173(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 174:
                        {
                              Token token = new174(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 175:
                        {
                              Token token = new175(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 176:
                        {
                              Token token = new176(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 177:
                        {
                              Token token = new177(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 178:
                        {
                              Token token = new178(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 179:
                        {
                              Token token = new179(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 180:
                        {
                              Token token = new180(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 181:
                        {
                              Token token = new181(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 182:
                        {
                              Token token = new182(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 183:
                        {
                              Token token = new183(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 184:
                        {
                              Token token = new184(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 185:
                        {
                              Token token = new185(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 186:
                        {
                              Token token = new186(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 187:
                        {
                              Token token = new187(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 188:
                        {
                              Token token = new188(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 189:
                        {
                              Token token = new189(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 190:
                        {
                              Token token = new190(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 191:
                        {
                              Token token = new191(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 192:
                        {
                              Token token = new192(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 193:
                        {
                              Token token = new193(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 194:
                        {
                              Token token = new194(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 195:
                        {
                              Token token = new195(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 196:
                        {
                              Token token = new196(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 197:
                        {
                              Token token = new197(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 198:
                        {
                              Token token = new198(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 199:
                        {
                              Token token = new199(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 200:
                        {
                              Token token = new200(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 201:
                        {
                              Token token = new201(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 202:
                        {
                              Token token = new202(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 203:
                        {
                              Token token = new203(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 204:
                        {
                              Token token = new204(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 205:
                        {
                              Token token = new205(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 206:
                        {
                              Token token = new206(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 207:
                        {
                              Token token = new207(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 208:
                        {
                              Token token = new208(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 209:
                        {
                              Token token = new209(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 210:
                        {
                              Token token = new210(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 211:
                        {
                              Token token = new211(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 212:
                        {
                              Token token = new212(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 213:
                        {
                              Token token = new213(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 214:
                        {
                              Token token = new214(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 215:
                        {
                              Token token = new215(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 216:
                        {
                              Token token = new216(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 217:
                        {
                              Token token = new217(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 218:
                        {
                              Token token = new218(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 219:
                        {
                              Token token = new219(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 220:
                        {
                              Token token = new220(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 221:
                        {
                              Token token = new221(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 222:
                        {
                              Token token = new222(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 223:
                        {
                              Token token = new223(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 224:
                        {
                              Token token = new224(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 225:
                        {
                              Token token = new225(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 226:
                        {
                              Token token = new226(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 227:
                        {
                              Token token = new227(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 228:
                        {
                              Token token = new228(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 229:
                        {
                              Token token = new229(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 230:
                        {
                              Token token = new230(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 231:
                        {
                              Token token = new231(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 232:
                        {
                              Token token = new232(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 233:
                        {
                              Token token = new233(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 234:
                        {
                              Token token = new234(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 235:
                        {
                              Token token = new235(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 236:
                        {
                              Token token = new236(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 237:
                        {
                              Token token = new237(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 238:
                        {
                              Token token = new238(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 239:
                        {
                              Token token = new239(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 240:
                        {
                              Token token = new240(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 241:
                        {
                              Token token = new241(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 242:
                        {
                              Token token = new242(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 243:
                        {
                              Token token = new243(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 244:
                        {
                              Token token = new244(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 245:
                        {
                              Token token = new245(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 246:
                        {
                              Token token = new246(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    }
                }
                else
                {
                    if(this.text.length() > 0)
                    {
                        throw new LexerException(
                            "[" + (start_line + 1) + "," + (start_pos + 1) + "]" +
                            " Unknown token: " + this.text);
                    }

                      EOF token = new EOF(
                        start_line + 1,
                        start_pos + 1);
                    return token;
                }
            }
        }
    }

    Token new0(  int line,   int pos) { return new TShebang(line, pos); }
    Token new1(  String text,   int line,   int pos) { return new TShebangEnd(text, line, pos); }
    Token new2(  String text,   int line,   int pos) { return new TShebangChar(text, line, pos); }
    Token new3(  String text,   int line,   int pos) { return new TComment(text, line, pos); }
    Token new4(  String text,   int line,   int pos) { return new TCommentEnd(text, line, pos); }
    Token new5(  String text,   int line,   int pos) { return new TCommentBody(text, line, pos); }
    Token new6(  int line,   int pos) { return new TStar(line, pos); }
    Token new7(  int line,   int pos) { return new TSlash(line, pos); }
    Token new8(  String text,   int line,   int pos) { return new TStringLiteral(text, line, pos); }
    Token new9(  String text,   int line,   int pos) { return new TForAny(text, line, pos); }
    Token new10(  String text,   int line,   int pos) { return new TExists(text, line, pos); }
    Token new11(  int line,   int pos) { return new TDollar(line, pos); }
    Token new12(  String text,   int line,   int pos) { return new TLambda(text, line, pos); }
    Token new13(  String text,   int line,   int pos) { return new TConjunction(text, line, pos); }
    Token new14(  String text,   int line,   int pos) { return new TSingleQuotation(text, line, pos); }
    Token new15(  int line,   int pos) { return new TLeftPar(line, pos); }
    Token new16(  int line,   int pos) { return new TRightPar(line, pos); }
    Token new17(  String text,   int line,   int pos) { return new TProduct(text, line, pos); }
    Token new18(  int line,   int pos) { return new TPowerOf(line, pos); }
    Token new19(  String text,   int line,   int pos) { return new TPlus(text, line, pos); }
    Token new20(  String text,   int line,   int pos) { return new TPartialFunction(text, line, pos); }
    Token new21(  String text,   int line,   int pos) { return new TPartialSurjection(text, line, pos); }
    Token new22(  int line,   int pos) { return new TComma(line, pos); }
    Token new23(  String text,   int line,   int pos) { return new TMinus(text, line, pos); }
    Token new24(  String text,   int line,   int pos) { return new TTotalFunction(text, line, pos); }
    Token new25(  String text,   int line,   int pos) { return new TTotalSurjection(text, line, pos); }
    Token new26(  String text,   int line,   int pos) { return new TInsertStartSequence(text, line, pos); }
    Token new27(  int line,   int pos) { return new TDot(line, pos); }
    Token new28(  String text,   int line,   int pos) { return new TInterval(text, line, pos); }
    Token new29(  String text,   int line,   int pos) { return new TDotPar(text, line, pos); }
    Token new30(  String text,   int line,   int pos) { return new TDivision(text, line, pos); }
    Token new31(  String text,   int line,   int pos) { return new TNotBelonging(text, line, pos); }
    Token new32(  String text,   int line,   int pos) { return new TNonInclusion(text, line, pos); }
    Token new33(  String text,   int line,   int pos) { return new TStrictNonInclusion(text, line, pos); }
    Token new34(  String text,   int line,   int pos) { return new TNotEqual(text, line, pos); }
    Token new35(  int line,   int pos) { return new TSetSubtraction(line, pos); }
    Token new36(  String text,   int line,   int pos) { return new TIntersection(text, line, pos); }
    Token new37(  String text,   int line,   int pos) { return new TRestrictHeadSequence(text, line, pos); }
    Token new38(  String text,   int line,   int pos) { return new TElementOf(text, line, pos); }
    Token new39(  String text,   int line,   int pos) { return new TDoubleColon(text, line, pos); }
    Token new40(  int line,   int pos) { return new TAssign(line, pos); }
    Token new41(  int line,   int pos) { return new TSemicolon(line, pos); }
    Token new42(  int line,   int pos) { return new TLess(line, pos); }
    Token new43(  String text,   int line,   int pos) { return new TOverwriteRelation(text, line, pos); }
    Token new44(  String text,   int line,   int pos) { return new TSetRelation(text, line, pos); }
    Token new45(  String text,   int line,   int pos) { return new TInsertEndSequence(text, line, pos); }
    Token new46(  String text,   int line,   int pos) { return new TOutputParameters(text, line, pos); }
    Token new47(  String text,   int line,   int pos) { return new TInclusion(text, line, pos); }
    Token new48(  String text,   int line,   int pos) { return new TStrictInclusion(text, line, pos); }
    Token new49(  String text,   int line,   int pos) { return new TDomainSubtraction(text, line, pos); }
    Token new50(  String text,   int line,   int pos) { return new TLessEqual(text, line, pos); }
    Token new51(  String text,   int line,   int pos) { return new TEquivalence(text, line, pos); }
    Token new52(  String text,   int line,   int pos) { return new TDomainRestriction(text, line, pos); }
    Token new53(  int line,   int pos) { return new TEqual(line, pos); }
    Token new54(  int line,   int pos) { return new TDoubleEqual(line, pos); }
    Token new55(  String text,   int line,   int pos) { return new TImplies(text, line, pos); }
    Token new56(  int line,   int pos) { return new TGreater(line, pos); }
    Token new57(  String text,   int line,   int pos) { return new TPartialInjection(text, line, pos); }
    Token new58(  String text,   int line,   int pos) { return new TTotalInjection(text, line, pos); }
    Token new59(  int line,   int pos) { return new TPartialBijection(line, pos); }
    Token new60(  String text,   int line,   int pos) { return new TTotalBijection(text, line, pos); }
    Token new61(  String text,   int line,   int pos) { return new TDirectProduct(text, line, pos); }
    Token new62(  String text,   int line,   int pos) { return new TGreaterEqual(text, line, pos); }
    Token new63(  int line,   int pos) { return new TAbstractConstants(line, pos); }
    Token new64(  int line,   int pos) { return new TAbstractVariables(line, pos); }
    Token new65(  int line,   int pos) { return new TAny(line, pos); }
    Token new66(  int line,   int pos) { return new TAssert(line, pos); }
    Token new67(  int line,   int pos) { return new TAssertions(line, pos); }
    Token new68(  int line,   int pos) { return new TBe(line, pos); }
    Token new69(  int line,   int pos) { return new TBegin(line, pos); }
    Token new70(  int line,   int pos) { return new TBool(line, pos); }
    Token new71(  int line,   int pos) { return new TBfalse(line, pos); }
    Token new72(  int line,   int pos) { return new TCase(line, pos); }
    Token new73(  int line,   int pos) { return new TChoice(line, pos); }
    Token new74(  int line,   int pos) { return new TConcreteConstants(line, pos); }
    Token new75(  int line,   int pos) { return new TConcreteVariables(line, pos); }
    Token new76(  int line,   int pos) { return new TConstants(line, pos); }
    Token new77(  int line,   int pos) { return new TConstraints(line, pos); }
    Token new78(  int line,   int pos) { return new TDefinitions(line, pos); }
    Token new79(  int line,   int pos) { return new TDo(line, pos); }
    Token new80(  int line,   int pos) { return new TEither(line, pos); }
    Token new81(  int line,   int pos) { return new TElse(line, pos); }
    Token new82(  int line,   int pos) { return new TElsif(line, pos); }
    Token new83(  int line,   int pos) { return new TEnd(line, pos); }
    Token new84(  int line,   int pos) { return new TExtends(line, pos); }
    Token new85(  String text,   int line,   int pos) { return new TFalse(text, line, pos); }
    Token new86(  int line,   int pos) { return new TFin(line, pos); }
    Token new87(  int line,   int pos) { return new TFin1(line, pos); }
    Token new88(  int line,   int pos) { return new TIf(line, pos); }
    Token new89(  int line,   int pos) { return new TImplementation(line, pos); }
    Token new90(  int line,   int pos) { return new TImports(line, pos); }
    Token new91(  int line,   int pos) { return new TIn(line, pos); }
    Token new92(  int line,   int pos) { return new TIncludes(line, pos); }
    Token new93(  String text,   int line,   int pos) { return new TInitialisation(text, line, pos); }
    Token new94(  int line,   int pos) { return new TInt(line, pos); }
    Token new95(  String text,   int line,   int pos) { return new TInteger(text, line, pos); }
    Token new96(  String text,   int line,   int pos) { return new TQuantifiedInter(text, line, pos); }
    Token new97(  int line,   int pos) { return new TInvariant(line, pos); }
    Token new98(  int line,   int pos) { return new TLet(line, pos); }
    Token new99(  int line,   int pos) { return new TLocalOperations(line, pos); }
    Token new100(  int line,   int pos) { return new TMachine(line, pos); }
    Token new101(  int line,   int pos) { return new TModel(line, pos); }
    Token new102(  int line,   int pos) { return new TSystem(line, pos); }
    Token new103(  int line,   int pos) { return new TMaxInt(line, pos); }
    Token new104(  int line,   int pos) { return new TMinInt(line, pos); }
    Token new105(  int line,   int pos) { return new TNat(line, pos); }
    Token new106(  int line,   int pos) { return new TNat1(line, pos); }
    Token new107(  String text,   int line,   int pos) { return new TNatural(text, line, pos); }
    Token new108(  String text,   int line,   int pos) { return new TNatural1(text, line, pos); }
    Token new109(  int line,   int pos) { return new TOf(line, pos); }
    Token new110(  String text,   int line,   int pos) { return new TOperations(text, line, pos); }
    Token new111(  int line,   int pos) { return new TOr(line, pos); }
    Token new112(  String text,   int line,   int pos) { return new TPi(text, line, pos); }
    Token new113(  String text,   int line,   int pos) { return new TPow(text, line, pos); }
    Token new114(  String text,   int line,   int pos) { return new TPow1(text, line, pos); }
    Token new115(  int line,   int pos) { return new TPre(line, pos); }
    Token new116(  int line,   int pos) { return new TPromotes(line, pos); }
    Token new117(  int line,   int pos) { return new TProperties(line, pos); }
    Token new118(  int line,   int pos) { return new TRefines(line, pos); }
    Token new119(  int line,   int pos) { return new TRefinement(line, pos); }
    Token new120(  int line,   int pos) { return new TSees(line, pos); }
    Token new121(  int line,   int pos) { return new TSelect(line, pos); }
    Token new122(  int line,   int pos) { return new TSets(line, pos); }
    Token new123(  int line,   int pos) { return new TQuantifiedSet(line, pos); }
    Token new124(  String text,   int line,   int pos) { return new TSigma(text, line, pos); }
    Token new125(  int line,   int pos) { return new TString(line, pos); }
    Token new126(  int line,   int pos) { return new TThen(line, pos); }
    Token new127(  String text,   int line,   int pos) { return new TTrue(text, line, pos); }
    Token new128(  String text,   int line,   int pos) { return new TQuantifiedUnion(text, line, pos); }
    Token new129(  int line,   int pos) { return new TUses(line, pos); }
    Token new130(  int line,   int pos) { return new TValue(line, pos); }
    Token new131(  int line,   int pos) { return new TVar(line, pos); }
    Token new132(  int line,   int pos) { return new TVariant(line, pos); }
    Token new133(  int line,   int pos) { return new TVariables(line, pos); }
    Token new134(  int line,   int pos) { return new TWhen(line, pos); }
    Token new135(  int line,   int pos) { return new TWhere(line, pos); }
    Token new136(  int line,   int pos) { return new TWhile(line, pos); }
    Token new137(  String text,   int line,   int pos) { return new TEmptySequence(text, line, pos); }
    Token new138(  int line,   int pos) { return new TLeftBracket(line, pos); }
    Token new139(  int line,   int pos) { return new TRightBracket(line, pos); }
    Token new140(  String text,   int line,   int pos) { return new TUnion(text, line, pos); }
    Token new141(  String text,   int line,   int pos) { return new TRestrictTailSequence(text, line, pos); }
    Token new142(  String text,   int line,   int pos) { return new TConcatSequence(text, line, pos); }
    Token new143(  int line,   int pos) { return new TArity(line, pos); }
    Token new144(  int line,   int pos) { return new TBin(line, pos); }
    Token new145(  int line,   int pos) { return new TBoolCast(line, pos); }
    Token new146(  int line,   int pos) { return new TBtree(line, pos); }
    Token new147(  int line,   int pos) { return new TCard(line, pos); }
    Token new148(  int line,   int pos) { return new TClosure(line, pos); }
    Token new149(  int line,   int pos) { return new TClosure1(line, pos); }
    Token new150(  int line,   int pos) { return new TConc(line, pos); }
    Token new151(  int line,   int pos) { return new TConst(line, pos); }
    Token new152(  int line,   int pos) { return new TDom(line, pos); }
    Token new153(  int line,   int pos) { return new TFather(line, pos); }
    Token new154(  int line,   int pos) { return new TFirst(line, pos); }
    Token new155(  int line,   int pos) { return new TFnc(line, pos); }
    Token new156(  int line,   int pos) { return new TFront(line, pos); }
    Token new157(  int line,   int pos) { return new TId(line, pos); }
    Token new158(  int line,   int pos) { return new TInfix(line, pos); }
    Token new159(  int line,   int pos) { return new TGeneralizedInter(line, pos); }
    Token new160(  int line,   int pos) { return new TIseq(line, pos); }
    Token new161(  int line,   int pos) { return new TIseq1(line, pos); }
    Token new162(  int line,   int pos) { return new TIterate(line, pos); }
    Token new163(  int line,   int pos) { return new TLast(line, pos); }
    Token new164(  int line,   int pos) { return new TLeft(line, pos); }
    Token new165(  int line,   int pos) { return new TMax(line, pos); }
    Token new166(  int line,   int pos) { return new TMin(line, pos); }
    Token new167(  int line,   int pos) { return new TMirror(line, pos); }
    Token new168(  int line,   int pos) { return new TMod(line, pos); }
    Token new169(  String text,   int line,   int pos) { return new TNot(text, line, pos); }
    Token new170(  String text,   int line,   int pos) { return new TLogicalOr(text, line, pos); }
    Token new171(  int line,   int pos) { return new TPerm(line, pos); }
    Token new172(  int line,   int pos) { return new TPostfix(line, pos); }
    Token new173(  int line,   int pos) { return new TPred(line, pos); }
    Token new174(  int line,   int pos) { return new TPrefix(line, pos); }
    Token new175(  int line,   int pos) { return new TPrj1(line, pos); }
    Token new176(  int line,   int pos) { return new TPrj2(line, pos); }
    Token new177(  int line,   int pos) { return new TRank(line, pos); }
    Token new178(  int line,   int pos) { return new TRan(line, pos); }
    Token new179(  int line,   int pos) { return new TRec(line, pos); }
    Token new180(  int line,   int pos) { return new TRel(line, pos); }
    Token new181(  int line,   int pos) { return new TRev(line, pos); }
    Token new182(  int line,   int pos) { return new TRight(line, pos); }
    Token new183(  int line,   int pos) { return new TSeq(line, pos); }
    Token new184(  int line,   int pos) { return new TSeq1(line, pos); }
    Token new185(  int line,   int pos) { return new TSizet(line, pos); }
    Token new186(  int line,   int pos) { return new TSize(line, pos); }
    Token new187(  int line,   int pos) { return new TSkip(line, pos); }
    Token new188(  int line,   int pos) { return new TSons(line, pos); }
    Token new189(  int line,   int pos) { return new TSon(line, pos); }
    Token new190(  int line,   int pos) { return new TStruct(line, pos); }
    Token new191(  int line,   int pos) { return new TSubtree(line, pos); }
    Token new192(  int line,   int pos) { return new TSucc(line, pos); }
    Token new193(  int line,   int pos) { return new TTail(line, pos); }
    Token new194(  int line,   int pos) { return new TTop(line, pos); }
    Token new195(  int line,   int pos) { return new TTree(line, pos); }
    Token new196(  int line,   int pos) { return new TGeneralizedUnion(line, pos); }
    Token new197(  String text,   int line,   int pos) { return new TEmptySet(text, line, pos); }
    Token new198(  int line,   int pos) { return new TLeftBrace(line, pos); }
    Token new199(  int line,   int pos) { return new TRightBrace(line, pos); }
    Token new200(  int line,   int pos) { return new TVerticalBar(line, pos); }
    Token new201(  String text,   int line,   int pos) { return new TDoubleVerticalBar(text, line, pos); }
    Token new202(  String text,   int line,   int pos) { return new TMaplet(text, line, pos); }
    Token new203(  String text,   int line,   int pos) { return new TRangeRestriction(text, line, pos); }
    Token new204(  String text,   int line,   int pos) { return new TRangeSubtraction(text, line, pos); }
    Token new205(  String text,   int line,   int pos) { return new TTilde(text, line, pos); }
    Token new206(  String text,   int line,   int pos) { return new TTotalRelation(text, line, pos); }
    Token new207(  String text,   int line,   int pos) { return new TSurjectionRelation(text, line, pos); }
    Token new208(  String text,   int line,   int pos) { return new TTotalSurjectionRelation(text, line, pos); }
    Token new209(  int line,   int pos) { return new TKwFreetypes(line, pos); }
    Token new210(  int line,   int pos) { return new TKwExpression(line, pos); }
    Token new211(  int line,   int pos) { return new TKwPredicate(line, pos); }
    Token new212(  int line,   int pos) { return new TKwFormula(line, pos); }
    Token new213(  int line,   int pos) { return new TKwSubstitution(line, pos); }
    Token new214(  int line,   int pos) { return new TKwAbstractConstants(line, pos); }
    Token new215(  int line,   int pos) { return new TKwAbstractVariables(line, pos); }
    Token new216(  int line,   int pos) { return new TKwAssertions(line, pos); }
    Token new217(  int line,   int pos) { return new TKwConcreteConstants(line, pos); }
    Token new218(  int line,   int pos) { return new TKwConcreteVariables(line, pos); }
    Token new219(  int line,   int pos) { return new TKwConstants(line, pos); }
    Token new220(  int line,   int pos) { return new TKwConstraints(line, pos); }
    Token new221(  int line,   int pos) { return new TKwDefinitions(line, pos); }
    Token new222(  int line,   int pos) { return new TKwDefinition(line, pos); }
    Token new223(  int line,   int pos) { return new TKwExtends(line, pos); }
    Token new224(  int line,   int pos) { return new TKwImports(line, pos); }
    Token new225(  int line,   int pos) { return new TKwIncludes(line, pos); }
    Token new226(  int line,   int pos) { return new TKwInitialisation(line, pos); }
    Token new227(  int line,   int pos) { return new TKwInvariant(line, pos); }
    Token new228(  int line,   int pos) { return new TKwLocalOperations(line, pos); }
    Token new229(  int line,   int pos) { return new TKwOperations(line, pos); }
    Token new230(  int line,   int pos) { return new TKwPromotes(line, pos); }
    Token new231(  int line,   int pos) { return new TKwProperties(line, pos); }
    Token new232(  int line,   int pos) { return new TKwSees(line, pos); }
    Token new233(  int line,   int pos) { return new TKwSets(line, pos); }
    Token new234(  int line,   int pos) { return new TKwUses(line, pos); }
    Token new235(  int line,   int pos) { return new TKwVariables(line, pos); }
    Token new236(  int line,   int pos) { return new TKwValues(line, pos); }
    Token new237(  int line,   int pos) { return new TKwOppattern(line, pos); }
    Token new238(  String text,   int line,   int pos) { return new TIdentifierLiteral(text, line, pos); }
    Token new239(  String text,   int line,   int pos) { return new TDefLiteralSubstitution(text, line, pos); }
    Token new240(  String text,   int line,   int pos) { return new TDefLiteralPredicate(text, line, pos); }
    Token new241(  String text,   int line,   int pos) { return new TPredicateIdentifier(text, line, pos); }
    Token new242(  int line,   int pos) { return new TTruthPredicate(line, pos); }
    Token new243(  String text,   int line,   int pos) { return new TIntegerLiteral(text, line, pos); }
    Token new244(  String text,   int line,   int pos) { return new THexLiteral(text, line, pos); }
    Token new245(  String text,   int line,   int pos) { return new TUnderscore(text, line, pos); }
    Token new246(  String text,   int line,   int pos) { return new TWhiteSpace(text, line, pos); }

    private int getChar() throws IOException
    {
        if(this.eof)
        {
            return -1;
        }

        int result = this.in.read();

        if(result == -1)
        {
            this.eof = true;
        }

        return result;
    }

    private void pushBack(int acceptLength) throws IOException
    {
        int length = this.text.length();
        for(int i = length - 1; i >= acceptLength; i--)
        {
            this.eof = false;

            this.in.unread(this.text.charAt(i));
        }
    }

    protected void unread(  Token token) throws IOException
    {
          String text = token.getText();
        int length = text.length();

        for(int i = length - 1; i >= 0; i--)
        {
            this.eof = false;

            this.in.unread(text.charAt(i));
        }

        this.pos = token.getPos() - 1;
        this.line = token.getLine() - 1;
    }

    private String getText(int acceptLength)
    {
        StringBuffer s = new StringBuffer(acceptLength);
        for(int i = 0; i < acceptLength; i++)
        {
            s.append(this.text.charAt(i));
        }

        return s.toString();
    }

    private static int[][][][] gotoTable;
/*  {
        { // NORMAL
            {{0, 9, 1}, {10, 10, 2}, {11, 12, 1}, {13, 13, 2}, {14, 32, 1}, {33, 33, 3}, {34, 34, 4}, {35, 35, 5}, {36, 36, 6}, {37, 37, 7}, {38, 38, 8}, {39, 39, 9}, {40, 40, 10}, {41, 41, 11}, {42, 42, 12}, {43, 43, 13}, {44, 44, 14}, {45, 45, 15}, {46, 46, 16}, {47, 47, 17}, {48, 48, 18}, {49, 57, 19}, {58, 58, 20}, {59, 59, 21}, {60, 60, 22}, {61, 61, 23}, {62, 62, 24}, {65, 65, 25}, {66, 66, 26}, {67, 67, 27}, {68, 68, 28}, {69, 69, 29}, {70, 70, 30}, {71, 72, 31}, {73, 73, 32}, {74, 75, 31}, {76, 76, 33}, {77, 77, 34}, {78, 78, 35}, {79, 79, 36}, {80, 80, 37}, {81, 81, 31}, {82, 82, 38}, {83, 83, 39}, {84, 84, 40}, {85, 85, 41}, {86, 86, 42}, {87, 87, 43}, {88, 90, 31}, {91, 91, 44}, {92, 92, 45}, {93, 93, 46}, {94, 94, 47}, {95, 95, 48}, {97, 97, 49}, {98, 98, 50}, {99, 99, 51}, {100, 100, 52}, {101, 101, 53}, {102, 102, 54}, {103, 104, 53}, {105, 105, 55}, {106, 107, 53}, {108, 108, 56}, {109, 109, 57}, {110, 110, 58}, {111, 111, 59}, {112, 112, 60}, {113, 113, 53}, {114, 114, 61}, {115, 115, 62}, {116, 116, 63}, {117, 117, 64}, {118, 122, 53}, {123, 123, 65}, {124, 124, 66}, {125, 125, 67}, {126, 126, 68}, {127, 160, 1}, {172, 172, 69}, {183, 183, 70}, {215, 215, 71}, {247, 247, 72}, {955, 955, 73}, {8206, 8207, 1}, {8229, 8229, 74}, {8232, 8233, 1}, {8315, 8315, 75}, {8469, 8469, 76}, {8473, 8473, 77}, {8484, 8484, 78}, {8592, 8592, 79}, {8593, 8593, 80}, {8594, 8594, 81}, {8595, 8595, 82}, {8596, 8596, 83}, {8608, 8608, 84}, {8611, 8611, 85}, {8614, 8614, 86}, {8658, 8658, 87}, {8660, 8660, 88}, {8696, 8696, 89}, {8701, 8701, 90}, {8702, 8702, 91}, {8704, 8704, 92}, {8707, 8707, 93}, {8709, 8709, 94}, {8712, 8712, 95}, {8713, 8713, 96}, {8719, 8719, 97}, {8721, 8721, 98}, {8722, 8722, 99}, {8741, 8741, 100}, {8743, 8743, 101}, {8744, 8744, 102}, {8745, 8745, 103}, {8746, 8746, 104}, {8764, 8764, 105}, {8800, 8800, 106}, {8804, 8804, 107}, {8805, 8805, 108}, {8834, 8834, 109}, {8836, 8836, 110}, {8838, 8838, 111}, {8840, 8840, 112}, {8855, 8855, 113}, {8868, 8868, 114}, {8869, 8869, 115}, {8898, 8898, 116}, {8899, 8899, 117}, {8918, 8918, 118}, {8978, 8978, 119}, {9654, 9654, 120}, {9655, 9655, 121}, {9664, 9664, 122}, {9665, 9665, 123}, {10496, 10496, 124}, {10516, 10516, 125}, {10518, 10518, 126}, {10852, 10852, 127}, {10853, 10853, 128}, {57600, 57600, 129}, {57601, 57601, 130}, {57602, 57602, 131}, {57603, 57603, 132}, },
            {{0, 9, 1}, {11, 12, 1}, {14, 32, 1}, {127, 160, 1}, {8206, 8207, 1}, {8232, 8233, 1}, },
            {},
            {},
            {{0, 33, 133}, {34, 34, 134}, {35, 65535, 133}, },
            {{33, 33, 135}, {65, 65, 136}, {67, 67, 137}, {68, 68, 138}, {69, 69, 139}, {70, 70, 140}, {73, 73, 141}, {76, 76, 142}, {79, 79, 143}, {80, 80, 144}, {83, 83, 145}, {85, 85, 146}, {86, 86, 147}, {108, 108, 148}, {112, 112, 149}, {116, 116, 150}, },
            {},
            {},
            {},
            {},
            {},
            {},
            {{42, 42, 151}, },
            {{45, 45, 152}, },
            {},
            {{45, 45, 153}, {62, 62, 154}, },
            {{0, 9, 155}, {10, 10, 156}, {11, 12, 155}, {13, 13, 156}, {14, 32, 155}, {40, 40, 157}, {46, 46, 158}, {127, 160, 155}, {8206, 8207, 155}, {8232, 8233, 155}, },
            {{42, 42, 159}, {58, 58, 160}, {60, 60, 161}, {61, 61, 162}, {92, 92, 163}, {124, 124, 164}, },
            {{48, 57, 19}, {120, 120, 165}, },
            {{48, 57, 19}, },
            {{58, 58, 166}, {61, 61, 167}, {8712, 8712, 168}, },
            {},
            {{0, 9, 169}, {10, 10, 170}, {11, 12, 169}, {13, 13, 170}, {14, 32, 169}, {43, 43, 171}, {45, 45, 172}, {58, 58, 173}, {60, 60, 174}, {61, 61, 175}, {62, 62, 176}, {124, 124, 177}, {127, 160, 169}, {8206, 8207, 169}, {8232, 8233, 169}, },
            {{61, 61, 178}, {62, 62, 179}, },
            {{43, 43, 180}, {45, 45, 181}, {60, 60, 182}, {61, 61, 183}, },
            {{48, 57, 184}, {65, 65, 185}, {66, 66, 186}, {67, 77, 185}, {78, 78, 187}, {79, 82, 185}, {83, 83, 188}, {84, 90, 185}, {95, 95, 189}, {97, 122, 190}, },
            {{48, 57, 184}, {65, 68, 185}, {69, 69, 191}, {70, 78, 185}, {79, 79, 192}, {80, 90, 185}, {95, 122, -27}, },
            {{48, 57, 184}, {65, 65, 193}, {66, 71, 185}, {72, 72, 194}, {73, 78, 185}, {79, 79, 195}, {80, 122, -28}, },
            {{48, 68, -28}, {69, 69, 196}, {70, 78, 185}, {79, 79, 197}, {80, 122, -28}, },
            {{48, 57, 184}, {65, 72, 185}, {73, 73, 198}, {74, 75, 185}, {76, 76, 199}, {77, 77, 185}, {78, 78, 200}, {79, 85, 185}, {86, 86, 201}, {87, 87, 185}, {88, 88, 202}, {89, 90, 185}, {95, 122, -27}, },
            {{48, 57, 184}, {65, 65, 203}, {66, 72, 185}, {73, 73, 204}, {74, 81, 185}, {82, 82, 205}, {83, 90, 185}, {95, 122, -27}, },
            {{48, 57, 184}, {65, 90, 185}, {95, 122, -27}, },
            {{48, 57, 184}, {65, 69, 185}, {70, 70, 206}, {71, 76, 185}, {77, 77, 207}, {78, 78, 208}, {79, 90, 185}, {95, 122, -27}, },
            {{48, 68, -28}, {69, 69, 209}, {70, 78, 185}, {79, 79, 210}, {80, 122, -28}, },
            {{48, 57, 184}, {65, 65, 211}, {66, 72, 185}, {73, 73, 212}, {74, 78, 185}, {79, 79, 213}, {80, 122, -28}, },
            {{48, 57, 184}, {65, 65, 214}, {66, 90, 185}, {95, 122, -27}, },
            {{48, 69, -34}, {70, 70, 215}, {71, 79, 185}, {80, 80, 216}, {81, 81, 185}, {82, 82, 217}, {83, 122, -32}, },
            {{48, 72, -31}, {73, 73, 218}, {74, 78, 185}, {79, 79, 219}, {80, 81, 185}, {82, 82, 220}, {83, 122, -32}, },
            {{48, 68, -28}, {69, 69, 221}, {70, 90, 185}, {95, 122, -27}, },
            {{48, 68, -28}, {69, 69, 222}, {70, 72, 185}, {73, 73, 223}, {74, 83, 185}, {84, 84, 224}, {85, 88, 185}, {89, 89, 225}, {90, 90, 185}, {95, 122, -27}, },
            {{48, 57, 184}, {65, 71, 185}, {72, 72, 226}, {73, 81, 185}, {82, 82, 227}, {83, 122, -32}, },
            {{48, 57, 184}, {65, 77, 185}, {78, 78, 228}, {79, 82, 185}, {83, 83, 229}, {84, 122, -27}, },
            {{48, 57, 184}, {65, 65, 230}, {66, 122, -37}, },
            {{48, 71, -42}, {72, 72, 231}, {73, 90, 185}, {95, 122, -27}, },
            {{0, 9, 232}, {10, 10, 233}, {11, 12, 232}, {13, 13, 233}, {14, 32, 232}, {93, 93, 234}, {127, 160, 232}, {8206, 8207, 232}, {8232, 8233, 232}, },
            {{47, 47, 235}, {124, 124, 236}, },
            {},
            {},
            {},
            {{48, 95, -33}, {97, 113, 190}, {114, 114, 237}, {115, 122, 190}, },
            {{48, 95, -33}, {97, 101, 190}, {102, 102, 238}, {103, 104, 190}, {105, 105, 239}, {106, 110, 190}, {111, 111, 240}, {112, 115, 190}, {116, 116, 241}, {117, 122, 190}, },
            {{48, 95, -33}, {97, 97, 242}, {98, 107, 190}, {108, 108, 243}, {109, 110, 190}, {111, 111, 244}, {112, 122, 190}, },
            {{48, 95, -33}, {97, 110, 190}, {111, 111, 245}, {112, 122, 190}, },
            {{48, 122, -33}, },
            {{48, 95, -33}, {97, 97, 246}, {98, 104, 190}, {105, 105, 247}, {106, 109, 190}, {110, 110, 248}, {111, 113, 190}, {114, 114, 249}, {115, 122, 190}, },
            {{48, 95, -33}, {97, 99, 190}, {100, 100, 250}, {101, 109, 190}, {110, 110, 251}, {111, 114, 190}, {115, 115, 252}, {116, 116, 253}, {117, 122, 190}, },
            {{48, 95, -33}, {97, 97, 254}, {98, 100, 190}, {101, 101, 255}, {102, 122, 190}, },
            {{48, 95, -33}, {97, 97, 256}, {98, 104, 190}, {105, 105, 257}, {106, 110, 190}, {111, 111, 258}, {112, 122, 190}, },
            {{48, 110, -54}, {111, 111, 259}, {112, 122, 190}, },
            {{48, 113, -51}, {114, 114, 260}, {115, 122, 190}, },
            {{48, 95, -33}, {97, 100, 190}, {101, 101, 261}, {102, 110, 190}, {111, 111, 262}, {112, 113, 190}, {114, 114, 263}, {115, 122, 190}, },
            {{48, 95, -33}, {97, 97, 264}, {98, 100, 190}, {101, 101, 265}, {102, 104, 190}, {105, 105, 266}, {106, 122, 190}, },
            {{48, 100, -62}, {101, 101, 267}, {102, 104, 190}, {105, 105, 268}, {106, 106, 190}, {107, 107, 269}, {108, 110, 190}, {111, 111, 270}, {112, 115, 190}, {116, 116, 271}, {117, 117, 272}, {118, 122, 190}, },
            {{48, 95, -33}, {97, 97, 273}, {98, 110, 190}, {111, 111, 274}, {112, 113, 190}, {114, 114, 275}, {115, 122, 190}, },
            {{48, 95, -33}, {97, 109, 190}, {110, 110, 276}, {111, 122, 190}, },
            {{0, 9, 277}, {10, 10, 278}, {11, 12, 277}, {13, 13, 278}, {14, 32, 277}, {125, 125, 279}, {127, 160, 277}, {8206, 8207, 277}, {8232, 8233, 277}, },
            {{45, 45, 280}, {62, 62, 281}, {124, 124, 282}, },
            {},
            {},
            {},
            {{0, 9, 283}, {10, 10, 284}, {11, 12, 283}, {13, 13, 284}, {14, 32, 283}, {40, 40, 285}, {127, 160, 283}, {8206, 8207, 283}, {8232, 8233, 283}, },
            {},
            {},
            {},
            {},
            {{185, 185, 286}, },
            {{49, 49, 287}, {8321, 8321, 288}, },
            {{49, 49, 289}, {8321, 8321, 290}, },
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {{0, 65535, -6}, },
            {},
            {},
            {{66, 66, 291}, {83, 83, 292}, },
            {{79, 79, 293}, },
            {{69, 69, 294}, },
            {{88, 88, 295}, },
            {{79, 79, 296}, },
            {{77, 77, 297}, {78, 78, 298}, },
            {{79, 79, 299}, },
            {{80, 80, 300}, },
            {{82, 82, 301}, },
            {{69, 69, 302}, {85, 85, 303}, },
            {{83, 83, 304}, },
            {{65, 65, 305}, },
            {{105, 105, 306}, },
            {{114, 114, 307}, },
            {{114, 114, 308}, },
            {},
            {{62, 62, 309}, },
            {{62, 62, 310}, },
            {},
            {{0, 40, -18}, {127, 8233, -18}, },
            {{0, 8233, -157}, },
            {},
            {},
            {},
            {},
            {{58, 58, 311}, {60, 60, 312}, },
            {},
            {},
            {{92, 92, 313}, },
            {{48, 57, 314}, {65, 70, 314}, {97, 102, 314}, },
            {},
            {},
            {},
            {{0, 32, -24}, {62, 62, 176}, {127, 8233, -24}, },
            {{0, 8233, -171}, },
            {},
            {{45, 45, 315}, {62, 62, 316}, },
            {},
            {{45, 45, 317}, {58, 58, 318}, {124, 124, 319}, },
            {{62, 62, 320}, },
            {},
            {},
            {},
            {},
            {{62, 62, 321}, },
            {{62, 62, 322}, },
            {},
            {},
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 57, 184}, {65, 82, 185}, {83, 83, 323}, {84, 122, -27}, },
            {{48, 57, 184}, {65, 88, 185}, {89, 89, 324}, {90, 122, -41}, },
            {{48, 82, -188}, {83, 83, 325}, {84, 122, -27}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 57, 184}, {65, 70, 185}, {71, 71, 326}, {72, 90, 185}, {95, 122, -27}, },
            {{48, 57, 184}, {65, 78, 185}, {79, 79, 327}, {80, 122, -28}, },
            {{48, 82, -188}, {83, 83, 328}, {84, 122, -27}, },
            {{48, 78, -194}, {79, 79, 329}, {80, 122, -28}, },
            {{48, 77, -43}, {78, 78, 330}, {79, 122, -34}, },
            {{48, 69, -34}, {70, 70, 331}, {71, 90, 185}, {95, 122, -27}, },
            {{48, 122, -33}, },
            {{48, 57, 184}, {65, 83, 185}, {84, 84, 332}, {85, 90, 185}, {95, 122, -27}, },
            {{48, 82, -188}, {83, 83, 333}, {84, 122, -27}, },
            {{48, 57, 184}, {65, 67, 185}, {68, 68, 334}, {69, 90, 185}, {95, 122, -27}, },
            {{48, 68, -28}, {69, 69, 335}, {70, 122, -40}, },
            {{48, 83, -200}, {84, 84, 336}, {85, 122, -200}, },
            {{48, 57, 184}, {65, 75, 185}, {76, 76, 337}, {77, 90, 185}, {95, 122, -27}, },
            {{48, 77, -43}, {78, 78, 338}, {79, 122, -34}, },
            {{48, 68, -28}, {69, 69, 339}, {70, 122, -40}, },
            {{48, 122, -33}, },
            {{48, 57, 184}, {65, 79, 185}, {80, 80, 340}, {81, 90, 185}, {95, 122, -27}, },
            {{48, 57, 184}, {65, 66, 185}, {67, 67, 341}, {68, 72, 185}, {73, 73, 342}, {74, 83, 185}, {84, 84, 343}, {85, 85, 185}, {86, 86, 344}, {87, 90, 185}, {95, 122, -27}, },
            {{48, 83, -200}, {84, 84, 345}, {85, 122, -200}, },
            {{48, 66, -210}, {67, 67, 346}, {68, 90, 185}, {95, 122, -27}, },
            {{48, 66, -210}, {67, 67, 347}, {68, 87, 185}, {88, 88, 348}, {89, 122, -31}, },
            {{48, 77, -43}, {78, 78, 349}, {79, 122, -34}, },
            {{48, 67, -202}, {68, 68, 350}, {69, 122, -202}, },
            {{48, 83, -200}, {84, 84, 351}, {85, 122, -200}, },
            {{48, 122, -33}, },
            {{48, 68, -28}, {69, 69, 352}, {70, 122, -40}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 57, 184}, {65, 86, 185}, {87, 87, 353}, {88, 90, 185}, {95, 122, -27}, },
            {{48, 68, -28}, {69, 69, 354}, {70, 78, 185}, {79, 79, 355}, {80, 122, -28}, },
            {{48, 69, -34}, {70, 70, 356}, {71, 122, -198}, },
            {{48, 68, -28}, {69, 69, 357}, {70, 75, 185}, {76, 76, 358}, {77, 83, 185}, {84, 84, 359}, {85, 122, -200}, },
            {{48, 70, -193}, {71, 71, 360}, {72, 122, -193}, },
            {{48, 57, 184}, {65, 81, 185}, {82, 82, 361}, {83, 122, -32}, },
            {{48, 82, -188}, {83, 83, 362}, {84, 122, -27}, },
            {{48, 68, -28}, {69, 69, 363}, {70, 122, -40}, },
            {{48, 57, 184}, {65, 84, 185}, {85, 85, 364}, {86, 90, 185}, {95, 122, -27}, },
            {{48, 72, -31}, {73, 73, 365}, {74, 90, 185}, {95, 122, -27}, },
            {{48, 68, -28}, {69, 69, 366}, {70, 122, -40}, },
            {{48, 75, -205}, {76, 76, 367}, {77, 81, 185}, {82, 82, 368}, {83, 122, -32}, },
            {{48, 68, -28}, {69, 69, 369}, {70, 72, 185}, {73, 73, 370}, {74, 122, -230}, },
            {{0, 8233, -46}, },
            {{0, 8233, -46}, },
            {},
            {},
            {{47, 47, 371}, },
            {{48, 95, -33}, {97, 104, 190}, {105, 105, 372}, {106, 122, 190}, },
            {{48, 95, -33}, {97, 97, 373}, {98, 122, 190}, },
            {{48, 109, -66}, {110, 110, 374}, {111, 122, 190}, },
            {{48, 110, -54}, {111, 111, 375}, {112, 122, 190}, },
            {{48, 113, -51}, {114, 114, 376}, {115, 122, 190}, },
            {{48, 113, -51}, {114, 114, 377}, {115, 122, 190}, },
            {{48, 110, -54}, {111, 111, 378}, {112, 122, 190}, },
            {{48, 109, -66}, {110, 110, 379}, {111, 122, 190}, },
            {{48, 95, -33}, {97, 108, 190}, {109, 109, 380}, {110, 122, 190}, },
            {{48, 95, -33}, {97, 115, 190}, {116, 116, 381}, {117, 122, 190}, },
            {{48, 113, -51}, {114, 114, 382}, {115, 122, 190}, },
            {{48, 95, -33}, {97, 98, 190}, {99, 99, 383}, {100, 122, 190}, },
            {{48, 110, -54}, {111, 111, 384}, {112, 122, 190}, },
            {{48, 122, -33}, },
            {{48, 101, -52}, {102, 102, 385}, {103, 115, 190}, {116, 116, 386}, {117, 122, 190}, },
            {{48, 100, -62}, {101, 101, 387}, {102, 122, 190}, },
            {{48, 100, -62}, {101, 101, 388}, {102, 122, 190}, },
            {{48, 95, -33}, {97, 114, 190}, {115, 115, 389}, {116, 122, 190}, },
            {{48, 101, -52}, {102, 102, 390}, {103, 122, 190}, },
            {{48, 95, -33}, {97, 119, 190}, {120, 120, 391}, {121, 122, 190}, },
            {{48, 109, -66}, {110, 110, 392}, {111, 113, 190}, {114, 114, 393}, {115, 122, 190}, },
            {{48, 99, -57}, {100, 100, 394}, {101, 122, 190}, },
            {{48, 115, -248}, {116, 116, 395}, {117, 122, 190}, },
            {{48, 122, -33}, },
            {{48, 113, -51}, {114, 114, 396}, {115, 122, 190}, },
            {{48, 114, -256}, {115, 115, 397}, {116, 122, 190}, },
            {{48, 100, -62}, {101, 101, 398}, {102, 105, 190}, {106, 106, 399}, {107, 122, 190}, },
            {{48, 109, -66}, {110, 110, 400}, {111, 122, 190}, },
            {{48, 98, -250}, {99, 99, 401}, {100, 107, 190}, {108, 108, 402}, {109, 117, 190}, {118, 118, 403}, {119, 122, 190}, },
            {{48, 95, -33}, {97, 102, 190}, {103, 103, 404}, {104, 122, 190}, },
            {{48, 95, -33}, {97, 112, 190}, {113, 113, 405}, {114, 122, 190}, },
            {{48, 95, -33}, {97, 121, 190}, {122, 122, 406}, },
            {{48, 104, -239}, {105, 105, 407}, {106, 122, 190}, },
            {{48, 109, -66}, {110, 110, 408}, {111, 122, 190}, },
            {{48, 113, -51}, {114, 114, 409}, {115, 122, 190}, },
            {{48, 95, -33}, {97, 97, 190}, {98, 98, 410}, {99, 99, 411}, {100, 122, 190}, },
            {{48, 104, -239}, {105, 105, 412}, {106, 122, 190}, },
            {{48, 95, -33}, {97, 111, 190}, {112, 112, 413}, {113, 122, 190}, },
            {{48, 100, -62}, {101, 101, 414}, {102, 122, 190}, },
            {{48, 104, -239}, {105, 105, 415}, {106, 122, 190}, },
            {{0, 8233, -67}, },
            {{0, 8233, -67}, },
            {},
            {{62, 62, 416}, },
            {{62, 62, 417}, },
            {},
            {{0, 8233, -72}, },
            {{0, 8233, -72}, },
            {},
            {},
            {},
            {},
            {},
            {},
            {{83, 83, 418}, },
            {{83, 83, 419}, },
            {{78, 78, 420}, },
            {{70, 70, 421}, },
            {{80, 80, 422}, {84, 84, 423}, },
            {{82, 82, 424}, },
            {{80, 80, 425}, },
            {{67, 67, 426}, {73, 73, 427}, {86, 86, 428}, },
            {{67, 67, 429}, },
            {{69, 69, 430}, {80, 80, 431}, },
            {{69, 69, 432}, {79, 79, 433}, },
            {{69, 69, 434}, {84, 84, 435}, },
            {{66, 66, 436}, },
            {{69, 69, 437}, },
            {{76, 76, 438}, {82, 82, 439}, },
            {{116, 116, 440}, },
            {{101, 101, 441}, },
            {{117, 117, 442}, },
            {{62, 62, 443}, },
            {{62, 62, 444}, },
            {},
            {{58, 58, 445}, },
            {},
            {{48, 102, -167}, },
            {},
            {{62, 62, 446}, },
            {{62, 62, 447}, },
            {},
            {},
            {},
            {{62, 62, 448}, },
            {{62, 62, 449}, },
            {{48, 83, -200}, {84, 84, 450}, {85, 122, -200}, },
            {{48, 122, -33}, },
            {{48, 68, -28}, {69, 69, 451}, {70, 122, -40}, },
            {{48, 72, -31}, {73, 73, 452}, {74, 122, -230}, },
            {{48, 75, -205}, {76, 76, 453}, {77, 122, -205}, },
            {{48, 68, -28}, {69, 69, 454}, {70, 122, -40}, },
            {{48, 72, -31}, {73, 73, 455}, {74, 122, -230}, },
            {{48, 66, -210}, {67, 67, 456}, {68, 82, 185}, {83, 83, 457}, {84, 122, -27}, },
            {{48, 72, -31}, {73, 73, 458}, {74, 122, -230}, },
            {{48, 71, -42}, {72, 72, 459}, {73, 122, -45}, },
            {{48, 68, -28}, {69, 69, 460}, {70, 72, 185}, {73, 73, 461}, {74, 122, -230}, },
            {{48, 122, -33}, },
            {{48, 77, -43}, {78, 78, 462}, {79, 122, -34}, },
            {{48, 68, -28}, {69, 69, 463}, {70, 122, -40}, },
            {{48, 82, -188}, {83, 83, 464}, {84, 122, -27}, },
            {{48, 48, 184}, {49, 49, 465}, {50, 57, 184}, {65, 122, -33}, },
            {{48, 68, -28}, {69, 69, 466}, {70, 122, -40}, },
            {{48, 75, -205}, {76, 76, 467}, {77, 78, 185}, {79, 79, 468}, {80, 122, -28}, },
            {{48, 75, -205}, {76, 76, 469}, {77, 122, -205}, },
            {{48, 83, -200}, {84, 84, 470}, {85, 122, -200}, },
            {{48, 68, -28}, {69, 69, 471}, {70, 122, -40}, },
            {{48, 57, 184}, {65, 65, 472}, {66, 122, -37}, },
            {{48, 122, -33}, },
            {{48, 57, 184}, {65, 65, 473}, {66, 122, -37}, },
            {{48, 71, -42}, {72, 72, 474}, {73, 122, -45}, },
            {{48, 72, -31}, {73, 73, 475}, {74, 122, -230}, },
            {{48, 72, -31}, {73, 73, 476}, {74, 122, -230}, },
            {{48, 68, -28}, {69, 69, 477}, {70, 122, -40}, },
            {{48, 48, 184}, {49, 49, 478}, {50, 57, 184}, {65, 84, 185}, {85, 85, 479}, {86, 122, -229}, },
            {{48, 81, -226}, {82, 82, 480}, {83, 122, -32}, },
            {{48, 48, 184}, {49, 49, 481}, {50, 122, -340}, },
            {{48, 122, -33}, },
            {{48, 57, 184}, {65, 76, 185}, {77, 77, 482}, {78, 79, 185}, {80, 80, 483}, {81, 122, -209}, },
            {{48, 72, -31}, {73, 73, 484}, {74, 122, -230}, },
            {{48, 82, -188}, {83, 83, 485}, {84, 122, -27}, },
            {{48, 68, -28}, {69, 69, 486}, {70, 122, -40}, },
            {{48, 82, -188}, {83, 83, 487}, {84, 122, -27}, },
            {{48, 76, -357}, {77, 77, 488}, {78, 90, 185}, {95, 122, -27}, },
            {{48, 72, -31}, {73, 73, 489}, {74, 122, -230}, },
            {{48, 83, -200}, {84, 84, 490}, {85, 122, -200}, },
            {{48, 77, -43}, {78, 78, 491}, {79, 122, -34}, },
            {{48, 68, -28}, {69, 69, 492}, {70, 122, -40}, },
            {{48, 78, -194}, {79, 79, 493}, {80, 122, -28}, },
            {{48, 82, -188}, {83, 83, 494}, {84, 122, -27}, },
            {{48, 84, -229}, {85, 85, 495}, {86, 122, -229}, },
            {{48, 72, -31}, {73, 73, 496}, {74, 122, -230}, },
            {{48, 77, -43}, {78, 78, 497}, {79, 81, 185}, {82, 82, 498}, {83, 122, -32}, },
            {{48, 75, -205}, {76, 76, 499}, {77, 122, -205}, },
            {},
            {{48, 115, -248}, {116, 116, 500}, {117, 122, 190}, },
            {{48, 95, -33}, {97, 107, 190}, {108, 108, 501}, {109, 122, 190}, },
            {{48, 122, -33}, },
            {{48, 107, -375}, {108, 108, 502}, {109, 122, 190}, },
            {{48, 100, -62}, {101, 101, 503}, {102, 122, 190}, },
            {{48, 99, -57}, {100, 100, 504}, {101, 122, 190}, },
            {{48, 114, -256}, {115, 115, 505}, {116, 122, 190}, },
            {{48, 98, -250}, {99, 99, 506}, {100, 114, 190}, {115, 115, 507}, {116, 122, 190}, },
            {{48, 122, -33}, },
            {{48, 95, -33}, {97, 103, 190}, {104, 104, 508}, {105, 122, 190}, },
            {{48, 114, -256}, {115, 115, 509}, {116, 122, 190}, },
            {{48, 122, -33}, },
            {{48, 109, -66}, {110, 110, 510}, {111, 122, 190}, },
            {{48, 104, -239}, {105, 105, 511}, {106, 122, 190}, },
            {{48, 100, -62}, {101, 101, 512}, {102, 122, 190}, },
            {{48, 112, -269}, {113, 113, 513}, {114, 122, 190}, },
            {{48, 113, -51}, {114, 114, 514}, {115, 122, 190}, },
            {{48, 115, -248}, {116, 116, 515}, {117, 122, 190}, },
            {{48, 115, -248}, {116, 116, 516}, {117, 122, 190}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 113, -51}, {114, 114, 517}, {115, 122, 190}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 108, -247}, {109, 109, 518}, {110, 122, 190}, },
            {{48, 115, -248}, {116, 116, 519}, {117, 122, 190}, },
            {{48, 99, -57}, {100, 100, 520}, {101, 101, 190}, {102, 102, 521}, {103, 122, 190}, },
            {{48, 48, 184}, {49, 49, 522}, {50, 50, 523}, {51, 57, 184}, {65, 122, -33}, },
            {{48, 95, -33}, {97, 106, 190}, {107, 107, 524}, {108, 122, 190}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 103, -383}, {104, 104, 525}, {105, 122, 190}, },
            {{48, 48, 184}, {49, 49, 526}, {50, 122, -340}, },
            {{48, 100, -62}, {101, 101, 527}, {102, 122, 190}, },
            {{48, 111, -276}, {112, 112, 528}, {113, 122, 190}, },
            {{48, 114, -256}, {115, 115, 529}, {116, 122, 190}, },
            {{48, 95, -33}, {97, 116, 190}, {117, 117, 530}, {118, 122, 190}, },
            {{48, 115, -248}, {116, 116, 531}, {117, 122, 190}, },
            {{48, 98, -250}, {99, 99, 532}, {100, 122, 190}, },
            {{48, 107, -375}, {108, 108, 533}, {109, 122, 190}, },
            {{48, 122, -33}, },
            {{48, 100, -62}, {101, 101, 534}, {102, 122, 190}, },
            {{48, 110, -54}, {111, 111, 535}, {112, 122, 190}, },
            {},
            {},
            {{84, 84, 536}, },
            {{69, 69, 537}, },
            {{67, 67, 538}, {83, 83, 539}, },
            {{73, 73, 540}, },
            {{82, 82, 541}, },
            {{69, 69, 542}, },
            {{77, 77, 543}, },
            {{79, 79, 544}, },
            {{76, 76, 545}, },
            {{84, 84, 546}, },
            {{65, 65, 547}, },
            {{65, 65, 548}, },
            {{82, 82, 549}, },
            {{65, 65, 550}, },
            {{68, 68, 551}, },
            {{77, 77, 552}, {80, 80, 553}, },
            {{83, 83, 554}, },
            {{83, 83, 555}, },
            {{83, 83, 556}, },
            {{83, 83, 557}, },
            {{85, 85, 558}, },
            {{73, 73, 559}, },
            {{101, 101, 560}, },
            {{100, 100, 561}, },
            {{116, 116, 562}, },
            {},
            {},
            {},
            {},
            {{62, 62, 563}, },
            {},
            {},
            {{48, 81, -226}, {82, 82, 564}, {83, 122, -32}, },
            {{48, 81, -226}, {82, 82, 565}, {83, 122, -32}, },
            {{48, 77, -43}, {78, 78, 566}, {79, 122, -34}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 66, -210}, {67, 67, 567}, {68, 122, -212}, },
            {{48, 81, -226}, {82, 82, 568}, {83, 122, -32}, },
            {{48, 83, -200}, {84, 84, 569}, {85, 122, -200}, },
            {{48, 77, -43}, {78, 78, 570}, {79, 122, -34}, },
            {{48, 68, -28}, {69, 69, 571}, {70, 122, -40}, },
            {{48, 122, -33}, },
            {{48, 69, -34}, {70, 70, 572}, {71, 122, -198}, },
            {{48, 83, -200}, {84, 84, 573}, {85, 122, -200}, },
            {{48, 77, -43}, {78, 78, 574}, {79, 122, -34}, },
            {{48, 68, -28}, {69, 69, 575}, {70, 122, -40}, },
            {{48, 122, -33}, },
            {{48, 83, -200}, {84, 84, 576}, {85, 122, -200}, },
            {{48, 68, -28}, {69, 69, 577}, {70, 122, -40}, },
            {{48, 81, -226}, {82, 82, 578}, {83, 122, -32}, },
            {{48, 84, -229}, {85, 85, 579}, {86, 122, -229}, },
            {{48, 72, -31}, {73, 73, 580}, {74, 122, -230}, },
            {{48, 70, -193}, {71, 71, 581}, {72, 81, 185}, {82, 82, 582}, {83, 122, -32}, },
            {{48, 81, -226}, {82, 82, 583}, {83, 122, -32}, },
            {{48, 75, -205}, {76, 76, 584}, {77, 122, -205}, },
            {{48, 72, -31}, {73, 73, 585}, {74, 122, -230}, },
            {{48, 77, -43}, {78, 78, 586}, {79, 122, -34}, },
            {{48, 77, -43}, {78, 78, 587}, {79, 122, -34}, },
            {{48, 75, -205}, {76, 76, 588}, {77, 122, -205}, },
            {{48, 122, -33}, },
            {{48, 81, -226}, {82, 82, 589}, {83, 122, -32}, },
            {{48, 57, 184}, {65, 65, 590}, {66, 122, -37}, },
            {{48, 122, -33}, },
            {{48, 78, -194}, {79, 79, 591}, {80, 122, -28}, },
            {{48, 68, -28}, {69, 69, 592}, {70, 122, -40}, },
            {{48, 77, -43}, {78, 78, 593}, {79, 122, -34}, },
            {{48, 122, -33}, },
            {{48, 66, -210}, {67, 67, 594}, {68, 122, -212}, },
            {{48, 122, -33}, },
            {{48, 57, 184}, {65, 65, 595}, {66, 122, -37}, },
            {{48, 77, -43}, {78, 78, 596}, {79, 122, -34}, },
            {{48, 68, -28}, {69, 69, 597}, {70, 122, -40}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 77, -43}, {78, 78, 598}, {79, 122, -34}, },
            {{48, 122, -33}, },
            {{48, 68, -28}, {69, 69, 599}, {70, 122, -40}, },
            {{48, 57, 184}, {65, 65, 600}, {66, 122, -37}, },
            {{48, 122, -33}, },
            {{48, 68, -28}, {69, 69, 601}, {70, 122, -40}, },
            {{48, 68, -28}, {69, 69, 602}, {70, 122, -40}, },
            {{48, 95, -33}, {97, 120, 190}, {121, 121, 603}, {122, 122, 190}, },
            {{48, 114, -256}, {115, 115, 604}, {116, 122, 190}, },
            {{48, 122, -33}, },
            {{48, 100, -62}, {101, 101, 605}, {102, 122, 190}, },
            {{48, 122, -33}, },
            {{48, 116, -411}, {117, 117, 606}, {118, 122, 190}, },
            {{48, 122, -33}, },
            {{48, 115, -248}, {116, 116, 607}, {117, 122, 190}, },
            {{48, 100, -62}, {101, 101, 608}, {102, 122, 190}, },
            {{48, 115, -248}, {116, 116, 609}, {117, 122, 190}, },
            {{48, 115, -248}, {116, 116, 610}, {117, 122, 190}, },
            {{48, 119, -258}, {120, 120, 611}, {121, 122, 190}, },
            {{48, 113, -51}, {114, 114, 612}, {115, 122, 190}, },
            {{48, 48, 184}, {49, 49, 613}, {50, 122, -340}, },
            {{48, 95, -33}, {97, 97, 614}, {98, 122, 190}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 110, -54}, {111, 111, 615}, {112, 122, 190}, },
            {{48, 122, -33}, },
            {{48, 101, -52}, {102, 102, 616}, {103, 122, 190}, },
            {{48, 122, -33}, },
            {{48, 104, -239}, {105, 105, 617}, {106, 122, 190}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 115, -248}, {116, 116, 618}, {117, 122, 190}, },
            {{48, 122, -33}, },
            {{48, 115, -248}, {116, 116, 619}, {117, 122, 190}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 98, -250}, {99, 99, 620}, {100, 122, 190}, },
            {{48, 113, -51}, {114, 114, 621}, {115, 122, 190}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 109, -66}, {110, 110, 622}, {111, 122, 190}, },
            {{82, 82, 623}, },
            {{82, 82, 624}, },
            {{82, 82, 625}, },
            {{84, 84, 626}, },
            {{78, 78, 627}, },
            {{69, 69, 628}, },
            {{78, 78, 629}, },
            {{85, 85, 630}, },
            {{82, 82, 631}, },
            {{85, 85, 632}, },
            {{73, 73, 633}, },
            {{82, 82, 634}, },
            {{76, 76, 635}, },
            {{65, 65, 636}, },
            {{84, 84, 637}, },
            {{73, 73, 638}, },
            {{79, 79, 639}, },
            {{69, 69, 640}, },
            {},
            {},
            {{84, 84, 641}, },
            {},
            {{69, 69, 642}, },
            {{65, 65, 643}, },
            {{114, 114, 644}, },
            {{105, 105, 645}, },
            {{104, 104, 646}, },
            {},
            {{48, 57, 184}, {65, 65, 647}, {66, 122, -37}, },
            {{48, 83, -200}, {84, 84, 648}, {85, 122, -200}, },
            {{48, 122, -33}, },
            {{48, 68, -28}, {69, 69, 649}, {70, 122, -40}, },
            {{48, 68, -28}, {69, 69, 650}, {70, 122, -40}, },
            {{48, 57, 184}, {65, 65, 651}, {66, 81, 185}, {82, 82, 652}, {83, 122, -32}, },
            {{48, 72, -31}, {73, 73, 653}, {74, 122, -230}, },
            {{48, 81, -226}, {82, 82, 654}, {83, 122, -32}, },
            {{48, 122, -33}, },
            {{48, 82, -188}, {83, 83, 655}, {84, 122, -27}, },
            {{48, 67, -202}, {68, 68, 656}, {69, 122, -202}, },
            {{48, 122, -33}, },
            {{48, 88, -189}, {89, 89, 657}, {90, 122, -41}, },
            {{48, 76, -357}, {77, 77, 658}, {78, 122, -362}, },
            {{48, 83, -200}, {84, 84, 659}, {85, 122, -200}, },
            {{48, 67, -202}, {68, 68, 660}, {69, 122, -202}, },
            {{48, 57, 184}, {65, 65, 661}, {66, 122, -37}, },
            {{48, 68, -28}, {69, 69, 662}, {70, 122, -40}, },
            {{48, 122, -33}, },
            {{48, 72, -31}, {73, 73, 663}, {74, 122, -230}, },
            {{48, 90, -33}, {95, 95, 664}, {97, 122, 190}, },
            {{48, 77, -43}, {78, 78, 665}, {79, 122, -34}, },
            {{48, 83, -200}, {84, 84, 666}, {85, 122, -200}, },
            {{48, 83, -200}, {84, 84, 667}, {85, 122, -200}, },
            {{48, 122, -33}, },
            {{48, 57, 184}, {65, 65, 668}, {66, 122, -37}, },
            {{48, 83, -200}, {84, 84, 669}, {85, 122, -200}, },
            {{48, 83, -200}, {84, 84, 670}, {85, 122, -200}, },
            {{48, 81, -226}, {82, 82, 671}, {83, 122, -32}, },
            {{48, 68, -28}, {69, 69, 672}, {70, 122, -40}, },
            {{48, 83, -200}, {84, 84, 673}, {85, 122, -200}, },
            {{48, 122, -33}, },
            {{48, 70, -193}, {71, 71, 674}, {72, 122, -193}, },
            {{48, 76, -357}, {77, 77, 675}, {78, 122, -362}, },
            {{48, 122, -33}, },
            {{48, 82, -188}, {83, 83, 676}, {84, 122, -27}, },
            {{48, 65, -27}, {66, 66, 677}, {67, 77, 185}, {78, 78, 678}, {79, 122, -34}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 100, -62}, {101, 101, 679}, {102, 122, 190}, },
            {{48, 122, -33}, },
            {{48, 113, -51}, {114, 114, 680}, {115, 122, 190}, },
            {{48, 122, -33}, },
            {{48, 113, -51}, {114, 114, 681}, {115, 122, 190}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 115, -248}, {116, 116, 682}, {117, 122, 190}, },
            {{48, 113, -51}, {114, 114, 683}, {115, 122, 190}, },
            {{48, 104, -239}, {105, 105, 684}, {106, 122, 190}, },
            {{48, 119, -258}, {120, 120, 685}, {121, 122, 190}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 115, -248}, {116, 116, 686}, {117, 122, 190}, },
            {{48, 100, -62}, {101, 101, 687}, {102, 122, 190}, },
            {{48, 122, -33}, },
            {{65, 65, 688}, },
            {{84, 84, 689}, },
            {{69, 69, 690}, },
            {{65, 65, 691}, {82, 82, 692}, },
            {{73, 73, 693}, },
            {{83, 83, 694}, },
            {{68, 68, 695}, },
            {{76, 76, 696}, },
            {{84, 84, 697}, },
            {{68, 68, 698}, },
            {{65, 65, 699}, },
            {{73, 73, 700}, },
            {{95, 95, 701}, },
            {{84, 84, 702}, },
            {{84, 84, 703}, },
            {{67, 67, 704}, },
            {{84, 84, 705}, },
            {{82, 82, 706}, },
            {{73, 73, 707}, },
            {{83, 83, 708}, },
            {{66, 66, 709}, },
            {{97, 97, 710}, },
            {{99, 99, 711}, },
            {{95, 95, 712}, },
            {{48, 66, -210}, {67, 67, 713}, {68, 122, -212}, },
            {{48, 72, -31}, {73, 73, 714}, {74, 122, -230}, },
            {{48, 122, -33}, },
            {{48, 83, -200}, {84, 84, 715}, {85, 122, -200}, },
            {{48, 77, -43}, {78, 78, 716}, {79, 122, -34}, },
            {{48, 57, 184}, {65, 65, 717}, {66, 122, -37}, },
            {{48, 83, -200}, {84, 84, 718}, {85, 122, -200}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 82, -188}, {83, 83, 719}, {84, 122, -27}, },
            {{48, 79, -209}, {80, 80, 720}, {81, 122, -209}, },
            {{48, 68, -28}, {69, 69, 721}, {70, 122, -40}, },
            {{48, 82, -188}, {83, 83, 722}, {84, 122, -27}, },
            {{48, 68, -28}, {69, 69, 723}, {70, 122, -40}, },
            {{48, 75, -205}, {76, 76, 724}, {77, 122, -205}, },
            {{48, 81, -226}, {82, 82, 725}, {83, 122, -32}, },
            {{48, 57, 184}, {65, 65, 726}, {66, 122, -37}, },
            {{48, 78, -194}, {79, 79, 727}, {80, 122, -28}, },
            {{48, 68, -28}, {69, 69, 728}, {70, 122, -40}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 75, -205}, {76, 76, 729}, {77, 122, -205}, },
            {{48, 72, -31}, {73, 73, 730}, {74, 122, -230}, },
            {{48, 68, -28}, {69, 69, 731}, {70, 122, -40}, },
            {{48, 83, -200}, {84, 84, 732}, {85, 122, -200}, },
            {{48, 76, -357}, {77, 77, 733}, {78, 82, 185}, {83, 83, 734}, {84, 122, -27}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 75, -205}, {76, 76, 735}, {77, 122, -205}, },
            {{48, 83, -200}, {84, 84, 736}, {85, 122, -200}, },
            {{48, 122, -33}, },
            {{48, 100, -62}, {101, 101, 737}, {102, 122, 190}, },
            {{48, 122, -33}, },
            {{48, 100, -62}, {101, 101, 738}, {102, 122, 190}, },
            {{48, 122, -33}, },
            {{48, 119, -258}, {120, 120, 739}, {121, 122, 190}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 100, -62}, {101, 101, 740}, {102, 122, 190}, },
            {{67, 67, 741}, },
            {{73, 73, 742}, },
            {{84, 84, 743}, },
            {{78, 78, 744}, },
            {{65, 65, 745}, },
            {{84, 84, 746}, },
            {{83, 83, 747}, },
            {{83, 83, 748}, },
            {{65, 65, 749}, },
            {{83, 83, 750}, },
            {{69, 69, 751}, },
            {{76, 76, 752}, },
            {{65, 65, 753}, },
            {{79, 79, 754}, },
            {{73, 73, 755}, },
            {{69, 69, 756}, },
            {{65, 65, 757}, },
            {{69, 69, 758}, },
            {{84, 84, 759}, },
            {{84, 84, 760}, },
            {},
            {{76, 76, 761}, },
            {{108, 108, 762}, },
            {{97, 97, 763}, },
            {{112, 112, 764}, },
            {{48, 83, -200}, {84, 84, 765}, {85, 122, -200}, },
            {{48, 78, -194}, {79, 79, 766}, {80, 122, -28}, },
            {{48, 68, -28}, {69, 69, 767}, {70, 122, -40}, },
            {{48, 83, -200}, {84, 84, 768}, {85, 122, -200}, },
            {{48, 72, -31}, {73, 73, 769}, {74, 122, -230}, },
            {{48, 72, -31}, {73, 73, 770}, {74, 122, -230}, },
            {{48, 122, -33}, },
            {{48, 68, -28}, {69, 69, 771}, {70, 122, -40}, },
            {{48, 77, -43}, {78, 78, 772}, {79, 122, -34}, },
            {{48, 122, -33}, },
            {{48, 82, -188}, {83, 83, 773}, {84, 122, -27}, },
            {{48, 72, -31}, {73, 73, 774}, {74, 122, -230}, },
            {{48, 122, -33}, },
            {{48, 77, -43}, {78, 78, 775}, {79, 122, -34}, },
            {{48, 79, -209}, {80, 80, 776}, {81, 122, -209}, },
            {{48, 122, -33}, },
            {{48, 48, 184}, {49, 49, 777}, {50, 122, -340}, },
            {{48, 78, -194}, {79, 79, 778}, {80, 122, -28}, },
            {{48, 82, -188}, {83, 83, 779}, {84, 122, -27}, },
            {{48, 72, -31}, {73, 73, 780}, {74, 122, -230}, },
            {{48, 68, -28}, {69, 69, 781}, {70, 122, -40}, },
            {{48, 122, -33}, },
            {{48, 68, -28}, {69, 69, 782}, {70, 122, -40}, },
            {{48, 122, -33}, },
            {{48, 48, 184}, {49, 49, 783}, {50, 122, -340}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{84, 84, 784}, },
            {{79, 79, 785}, },
            {{69, 69, 786}, },
            {{84, 84, 787}, },
            {{73, 73, 788}, },
            {{73, 73, 789}, },
            {{73, 73, 790}, },
            {},
            {},
            {},
            {{83, 83, 791}, },
            {{73, 73, 792}, },
            {{78, 78, 793}, },
            {{80, 80, 794}, },
            {{79, 79, 795}, },
            {{82, 82, 796}, },
            {{84, 84, 797}, },
            {{83, 83, 798}, },
            {{73, 73, 799}, },
            {{85, 85, 800}, },
            {{69, 69, 801}, },
            {{95, 95, 802}, },
            {{116, 116, 803}, },
            {{114, 114, 804}, },
            {{48, 90, -33}, {95, 95, 805}, {97, 122, 190}, },
            {{48, 77, -43}, {78, 78, 806}, {79, 122, -34}, },
            {{48, 90, -33}, {95, 95, 807}, {97, 122, 190}, },
            {{48, 82, -188}, {83, 83, 808}, {84, 122, -27}, },
            {{48, 77, -43}, {78, 78, 809}, {79, 122, -34}, },
            {{48, 78, -194}, {79, 79, 810}, {80, 122, -28}, },
            {{48, 82, -188}, {83, 83, 811}, {84, 122, -27}, },
            {{48, 83, -200}, {84, 84, 812}, {85, 122, -200}, },
            {{48, 122, -33}, },
            {{48, 82, -188}, {83, 83, 813}, {84, 89, 185}, {90, 90, 814}, {95, 122, -27}, },
            {{48, 83, -200}, {84, 84, 815}, {85, 122, -200}, },
            {{48, 68, -28}, {69, 69, 816}, {70, 122, -40}, },
            {{48, 122, -33}, },
            {{48, 77, -43}, {78, 78, 817}, {79, 122, -34}, },
            {{48, 122, -33}, },
            {{48, 68, -28}, {69, 69, 818}, {70, 122, -40}, },
            {{48, 77, -43}, {78, 78, 819}, {79, 122, -34}, },
            {{48, 82, -188}, {83, 83, 820}, {84, 122, -27}, },
            {{48, 122, -33}, },
            {{95, 95, 821}, },
            {{78, 78, 822}, },
            {{95, 95, 823}, },
            {{83, 83, 824}, },
            {{78, 78, 825}, },
            {{79, 79, 826}, },
            {{79, 79, 827}, },
            {},
            {{83, 83, 828}, },
            {{84, 84, 829}, },
            {{69, 69, 830}, },
            {{78, 78, 831}, },
            {{78, 78, 832}, },
            {{69, 69, 833}, },
            {},
            {{69, 69, 834}, },
            {{84, 84, 835}, },
            {{83, 83, 836}, },
            {{112, 112, 837}, {115, 115, 838}, },
            {{101, 101, 839}, },
            {{101, 101, 840}, },
            {{48, 66, -210}, {67, 67, 841}, {68, 85, 185}, {86, 86, 842}, {87, 122, -210}, },
            {{48, 82, -188}, {83, 83, 843}, {84, 122, -27}, },
            {{48, 66, -210}, {67, 67, 844}, {68, 85, 185}, {86, 86, 845}, {87, 122, -210}, },
            {{48, 122, -33}, },
            {{48, 83, -200}, {84, 84, 846}, {85, 122, -200}, },
            {{48, 77, -43}, {78, 78, 847}, {79, 122, -34}, },
            {{48, 122, -33}, },
            {{48, 57, 184}, {65, 65, 848}, {66, 122, -37}, },
            {{48, 57, 184}, {65, 65, 849}, {66, 122, -37}, },
            {{48, 57, 184}, {65, 65, 850}, {66, 122, -37}, },
            {{48, 122, -33}, },
            {{48, 81, -226}, {82, 82, 851}, {83, 122, -32}, },
            {{48, 82, -188}, {83, 83, 852}, {84, 122, -27}, },
            {{48, 82, -188}, {83, 83, 853}, {84, 122, -27}, },
            {{48, 83, -200}, {84, 84, 854}, {85, 122, -200}, },
            {{48, 122, -33}, },
            {{67, 67, 855}, {86, 86, 856}, },
            {{83, 83, 857}, },
            {{67, 67, 858}, {86, 86, 859}, },
            {},
            {{84, 84, 860}, },
            {{78, 78, 861}, },
            {{78, 78, 862}, },
            {{65, 65, 863}, },
            {},
            {{82, 82, 864}, },
            {{83, 83, 865}, },
            {},
            {},
            {{83, 83, 866}, },
            {{73, 73, 867}, },
            {},
            {{114, 114, 868}, },
            {{117, 117, 869}, },
            {{95, 95, 870}, },
            {{100, 100, 871}, },
            {{48, 78, -194}, {79, 79, 872}, {80, 122, -28}, },
            {{48, 57, 184}, {65, 65, 873}, {66, 122, -37}, },
            {{48, 122, -33}, },
            {{48, 78, -194}, {79, 79, 874}, {80, 122, -28}, },
            {{48, 57, 184}, {65, 65, 875}, {66, 122, -37}, },
            {{48, 82, -188}, {83, 83, 876}, {84, 122, -27}, },
            {{48, 82, -188}, {83, 83, 877}, {84, 122, -27}, },
            {{48, 83, -200}, {84, 84, 878}, {85, 122, -200}, },
            {{48, 83, -200}, {84, 84, 879}, {85, 122, -200}, },
            {{48, 83, -200}, {84, 84, 880}, {85, 122, -200}, },
            {{48, 57, 184}, {65, 65, 881}, {66, 122, -37}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{79, 79, 882}, },
            {{65, 65, 883}, },
            {},
            {{79, 79, 884}, },
            {{65, 65, 885}, },
            {{83, 83, 886}, },
            {{83, 83, 887}, },
            {},
            {{84, 84, 888}, },
            {{65, 65, 889}, },
            {},
            {},
            {{79, 79, 890}, },
            {{101, 101, 891}, },
            {{98, 98, 892}, },
            {{105, 105, 893}, },
            {{105, 105, 894}, },
            {{48, 77, -43}, {78, 78, 895}, {79, 122, -34}, },
            {{48, 81, -226}, {82, 82, 896}, {83, 122, -32}, },
            {{48, 77, -43}, {78, 78, 897}, {79, 122, -34}, },
            {{48, 81, -226}, {82, 82, 898}, {83, 122, -32}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 72, -31}, {73, 73, 899}, {74, 122, -230}, },
            {{48, 72, -31}, {73, 73, 900}, {74, 122, -230}, },
            {{48, 72, -31}, {73, 73, 901}, {74, 122, -230}, },
            {{48, 83, -200}, {84, 84, 902}, {85, 122, -200}, },
            {{78, 78, 903}, },
            {{82, 82, 904}, },
            {{78, 78, 905}, },
            {{82, 82, 906}, },
            {},
            {},
            {{73, 73, 907}, },
            {{84, 84, 908}, },
            {{78, 78, 909}, },
            {{100, 100, 910}, },
            {{115, 115, 911}, },
            {{100, 100, 912}, },
            {{99, 99, 913}, },
            {{48, 82, -188}, {83, 83, 914}, {84, 122, -27}, },
            {{48, 72, -31}, {73, 73, 915}, {74, 122, -230}, },
            {{48, 82, -188}, {83, 83, 916}, {84, 122, -27}, },
            {{48, 72, -31}, {73, 73, 917}, {74, 122, -230}, },
            {{48, 78, -194}, {79, 79, 918}, {80, 122, -28}, },
            {{48, 78, -194}, {79, 79, 919}, {80, 122, -28}, },
            {{48, 78, -194}, {79, 79, 920}, {80, 122, -28}, },
            {{48, 72, -31}, {73, 73, 921}, {74, 122, -230}, },
            {{83, 83, 922}, },
            {{73, 73, 923}, },
            {{83, 83, 924}, },
            {{73, 73, 925}, },
            {{79, 79, 926}, },
            {{73, 73, 927}, },
            {},
            {{105, 105, 928}, },
            {{116, 116, 929}, },
            {{101, 101, 930}, },
            {{97, 97, 931}, },
            {{48, 83, -200}, {84, 84, 932}, {85, 122, -200}, },
            {{48, 57, 184}, {65, 65, 933}, {66, 122, -37}, },
            {{48, 83, -200}, {84, 84, 934}, {85, 122, -200}, },
            {{48, 57, 184}, {65, 65, 935}, {66, 122, -37}, },
            {{48, 77, -43}, {78, 78, 936}, {79, 122, -34}, },
            {{48, 77, -43}, {78, 78, 937}, {79, 122, -34}, },
            {{48, 77, -43}, {78, 78, 938}, {79, 122, -34}, },
            {{48, 78, -194}, {79, 79, 939}, {80, 122, -28}, },
            {{84, 84, 940}, },
            {{65, 65, 941}, },
            {{84, 84, 942}, },
            {{65, 65, 943}, },
            {{78, 78, 944}, },
            {{79, 79, 945}, },
            {{99, 99, 946}, },
            {{105, 105, 947}, },
            {{110, 110, 948}, },
            {{116, 116, 949}, },
            {{48, 57, 184}, {65, 65, 950}, {66, 122, -37}, },
            {{48, 65, -27}, {66, 66, 951}, {67, 90, 185}, {95, 122, -27}, },
            {{48, 57, 184}, {65, 65, 952}, {66, 122, -37}, },
            {{48, 65, -27}, {66, 66, 953}, {67, 122, -935}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 77, -43}, {78, 78, 954}, {79, 122, -34}, },
            {{65, 65, 955}, },
            {{66, 66, 956}, },
            {{65, 65, 957}, },
            {{66, 66, 958}, },
            {},
            {{78, 78, 959}, },
            {{97, 97, 960}, },
            {{116, 116, 961}, },
            {{116, 116, 962}, },
            {{101, 101, 963}, },
            {{48, 77, -43}, {78, 78, 964}, {79, 122, -34}, },
            {{48, 75, -205}, {76, 76, 965}, {77, 122, -205}, },
            {{48, 77, -43}, {78, 78, 966}, {79, 122, -34}, },
            {{48, 75, -205}, {76, 76, 967}, {77, 122, -205}, },
            {{48, 82, -188}, {83, 83, 968}, {84, 122, -27}, },
            {{78, 78, 969}, },
            {{76, 76, 970}, },
            {{78, 78, 971}, },
            {{76, 76, 972}, },
            {{83, 83, 973}, },
            {{116, 116, 974}, },
            {{117, 117, 975}, },
            {{105, 105, 976}, },
            {},
            {{48, 83, -200}, {84, 84, 977}, {85, 122, -200}, },
            {{48, 68, -28}, {69, 69, 978}, {70, 122, -40}, },
            {{48, 83, -200}, {84, 84, 979}, {85, 122, -200}, },
            {{48, 68, -28}, {69, 69, 980}, {70, 122, -40}, },
            {{48, 122, -33}, },
            {{84, 84, 981}, },
            {{69, 69, 982}, },
            {{84, 84, 983}, },
            {{69, 69, 984}, },
            {},
            {{101, 101, 985}, },
            {{116, 116, 986}, },
            {{102, 102, 987}, },
            {{48, 82, -188}, {83, 83, 988}, {84, 122, -27}, },
            {{48, 82, -188}, {83, 83, 989}, {84, 122, -27}, },
            {{48, 82, -188}, {83, 83, 990}, {84, 122, -27}, },
            {{48, 82, -188}, {83, 83, 991}, {84, 122, -27}, },
            {{83, 83, 992}, },
            {{83, 83, 993}, },
            {{83, 83, 994}, },
            {{83, 83, 995}, },
            {{65, 90, 996}, {97, 122, 997}, },
            {{105, 105, 998}, },
            {{105, 105, 999}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {},
            {},
            {},
            {},
            {{65, 122, -987}, },
            {{65, 122, -987}, },
            {{111, 111, 1000}, },
            {{101, 101, 1001}, },
            {{110, 110, 1002}, },
            {{114, 114, 1003}, },
            {{65, 90, 1004}, {97, 122, 1005}, },
            {{65, 90, 1006}, {97, 122, 1007}, },
            {{65, 122, -1004}, },
            {{65, 122, -1004}, },
            {{65, 122, -1005}, },
            {{65, 122, -1005}, },
        }
        { // SHEBANG
            {{0, 9, 1}, {10, 10, 2}, {11, 12, 1}, {13, 13, 2}, {14, 32, 1}, {33, 34, 3}, {35, 35, 4}, {36, 126, 3}, {127, 160, 1}, {161, 8205, 3}, {8206, 8207, 1}, {8208, 8231, 3}, {8232, 8233, 1}, {8234, 65535, 3}, },
            {{0, 9, 5}, {11, 12, 5}, {14, 32, 5}, {127, 160, 5}, {8206, 8207, 5}, {8232, 8233, 5}, },
            {},
            {},
            {{33, 33, 6}, },
            {{0, 8233, -3}, },
            {},
        }
        { // COMMENT
            {{0, 9, 1}, {10, 10, 2}, {11, 12, 1}, {13, 13, 2}, {14, 32, 1}, {33, 41, 3}, {42, 42, 4}, {43, 46, 3}, {47, 47, 5}, {48, 126, 3}, {127, 160, 1}, {161, 8205, 3}, {8206, 8207, 1}, {8208, 8231, 3}, {8232, 8233, 1}, {8234, 65535, 3}, },
            {{0, 9, 1}, {10, 10, 3}, {11, 12, 1}, {13, 13, 3}, {14, 41, -2}, {43, 46, 3}, {48, 65535, -2}, },
            {{0, 41, 3}, {43, 46, 3}, {48, 65535, 3}, },
            {{0, 65535, -4}, },
            {{47, 47, 6}, },
            {{42, 42, 7}, },
            {},
            {},
        }
    };*/

    private static int[][] accept;
/*  {
        // NORMAL
        {-1, 246, 246, 9, -1, 10, 11, 12, 13, 14, 15, 16, 17, 19, 22, 23, 27, 30, 243, 243, 38, 41, 42, 53, 56, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 138, 35, 139, 142, 245, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 198, 200, 199, 205, 169, -1, 17, 30, 12, 28, -1, 107, 113, 95, 46, 37, 24, 141, 44, 25, 58, 202, 55, 51, 20, 45, 26, 9, 10, 197, 38, 31, 112, 124, 23, 201, 13, 170, 36, 140, 205, 34, 50, 62, 48, 33, 47, 32, 61, 127, 85, 96, 128, 43, 142, 204, 203, 49, 52, 21, 57, 60, 49, 204, 206, 207, 208, 43, -1, 8, 0, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 18, -1, -1, 26, -1, -1, 29, 28, 3, 31, -1, 34, 36, -1, -1, 39, 40, 39, -1, -1, 43, 45, 47, -1, 50, 137, 52, 54, 55, -1, -1, 61, 62, 238, 238, 238, 238, 238, 238, 238, 68, 238, 238, 238, 238, 238, 79, 238, 238, 238, 238, 238, 238, 238, 238, 88, 238, 91, 238, 238, 238, 238, 238, 238, 109, 238, 111, 112, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, -1, -1, 137, 140, -1, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 157, 238, 238, 238, 238, 238, 238, 238, 238, 238, 170, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, -1, -1, 197, -1, 203, 201, -1, -1, 29, 205, 108, 108, 114, 114, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 20, 24, 32, -1, 37, 244, 46, 44, -1, 48, 49, 51, 57, 58, 238, 65, 238, 238, 238, 238, 238, 238, 238, 238, 238, 83, 238, 238, 238, 86, 238, 238, 238, 238, 94, 238, 98, 238, 238, 238, 238, 238, 105, 238, 113, 115, 238, 238, 238, 238, 123, 238, 238, 238, 238, 238, 238, 238, 238, 131, 238, 238, 141, 238, 238, 144, 238, 238, 238, 238, 238, 152, 238, 238, 155, 238, 238, 238, 238, 238, 238, 238, 165, 166, 238, 168, 169, 238, 238, 238, 238, 178, 179, 180, 181, 238, 183, 238, 238, 189, 238, 238, 238, 238, 194, 238, 238, 202, 204, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 21, 25, 33, 207, 206, 59, 60, 238, 238, 238, 70, 72, 238, 238, 238, 238, 238, 81, 238, 238, 238, 238, 87, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 106, 238, 238, 114, 238, 238, 238, 120, 238, 122, 238, 238, 238, 126, 127, 238, 129, 238, 238, 134, 238, 238, 238, 238, 145, 238, 147, 238, 150, 238, 238, 238, 238, 238, 238, 160, 238, 163, 164, 238, 171, 238, 173, 238, 175, 176, 177, 238, 184, 186, 187, 188, 238, 238, 192, 193, 195, 238, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 232, 233, -1, 234, -1, -1, -1, -1, -1, 208, 238, 238, 69, 238, 238, 238, 238, 238, 82, 238, 238, 85, 238, 238, 238, 238, 238, 238, 96, 238, 238, 238, 238, 238, 101, 238, 238, 238, 238, 238, 238, 124, 238, 238, 128, 238, 238, 135, 136, 143, 238, 146, 238, 151, 238, 154, 156, 158, 159, 161, 238, 238, 238, 238, 182, 185, 238, 238, 196, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 238, 66, 73, 238, 238, 238, 238, 80, 110, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 103, 104, 238, 238, 238, 238, 238, 121, 125, 102, 130, 238, 238, 71, 238, 153, 238, 167, 238, 174, 190, 238, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 236, -1, -1, -1, -1, 238, 238, 238, 238, 238, 238, 84, 238, 238, 90, 238, 238, 95, 238, 238, 100, 107, 238, 238, 238, 238, 118, 238, 132, 148, 162, 172, 191, -1, -1, -1, -1, -1, -1, -1, 223, 212, 224, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 238, 238, 238, 238, 238, 238, 238, 238, 92, 238, 238, 238, 108, 238, 116, 238, 238, 238, 149, -1, -1, -1, -1, -1, -1, -1, 225, -1, -1, -1, -1, -1, -1, 230, -1, -1, -1, -1, -1, -1, 238, 238, 238, 76, 238, 238, 209, 238, 238, 238, 97, 238, 238, 238, 238, 133, -1, -1, -1, 219, -1, -1, -1, -1, 227, -1, -1, 237, 211, -1, -1, 235, -1, -1, -1, -1, 238, 238, 67, 238, 238, 238, 238, 238, 238, 238, 238, 110, 117, 119, -1, -1, 216, -1, -1, -1, 222, 210, -1, -1, 229, 231, -1, -1, -1, -1, -1, 238, 238, 238, 238, 77, 78, 238, 238, 238, 238, -1, -1, -1, -1, 220, 221, -1, -1, -1, -1, -1, -1, -1, 238, 238, 238, 238, 238, 238, 238, 238, -1, -1, -1, -1, -1, -1, 213, -1, -1, -1, -1, 238, 238, 238, 238, 238, 238, 238, 238, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 238, 238, 238, 238, 89, 93, 93, 238, -1, -1, -1, -1, 226, -1, -1, -1, -1, -1, 238, 238, 238, 238, 238, -1, -1, -1, -1, -1, -1, -1, -1, 242, 238, 238, 238, 238, 99, -1, -1, -1, -1, 228, -1, -1, -1, 238, 238, 238, 238, -1, -1, -1, -1, 240, -1, -1, 63, 64, 74, 75, 214, 215, 217, 218, 240, 240, -1, -1, -1, -1, 239, 241, 239, 239, 241, 241, },
        // SHEBANG
        {-1, 2, 1, 2, 2, 246, 0, },
        // COMMENT
        {5, 5, 5, 5, 6, 7, 4, 3, },

    };*/

    public static class State
    {
        public final static State NORMAL = new State(0);
        public final static State SHEBANG = new State(1);
        public final static State COMMENT = new State(2);

        private int id;

        private State(  int id)
        {
            this.id = id;
        }

        public int id()
        {
            return this.id;
        }
    }

    static 
    {
        try
        {
            DataInputStream s = new DataInputStream(
                new BufferedInputStream(
                Lexer.class.getResourceAsStream("lexer.dat")));

            // read gotoTable
            int length = s.readInt();
            gotoTable = new int[length][][][];
            for(int i = 0; i < gotoTable.length; i++)
            {
                length = s.readInt();
                gotoTable[i] = new int[length][][];
                for(int j = 0; j < gotoTable[i].length; j++)
                {
                    length = s.readInt();
                    gotoTable[i][j] = new int[length][3];
                    for(int k = 0; k < gotoTable[i][j].length; k++)
                    {
                        for(int l = 0; l < 3; l++)
                        {
                            gotoTable[i][j][k][l] = s.readInt();
                        }
                    }
                }
            }

            // read accept
            length = s.readInt();
            accept = new int[length][];
            for(int i = 0; i < accept.length; i++)
            {
                length = s.readInt();
                accept[i] = new int[length];
                for(int j = 0; j < accept[i].length; j++)
                {
                    accept[i][j] = s.readInt();
                }
            }

            s.close();
        }
        catch(Exception e)
        {
            throw new RuntimeException("The file \"lexer.dat\" is either missing or corrupted.");
        }
    }
}
