/* This file was generated by SableCC (http://www.sablecc.org/). */

package de.be4.eventb.core.parser.parser;

import de.be4.eventb.core.parser.lexer.*;
import de.be4.eventb.core.parser.node.*;
import de.be4.eventb.core.parser.analysis.*;
import java.util.*;
import de.hhu.stups.sablecc.patch.*;


import java.io.DataInputStream;
import java.io.BufferedInputStream;
import java.io.IOException;

@SuppressWarnings({"rawtypes","unchecked","unused"})
public class Parser implements IParser
{
    public final Analysis ignoredTokens = new AnalysisAdapter();

    protected ArrayList nodeList;

    private final Lexer lexer;
    private final ListIterator stack = new LinkedList().listIterator();
    private int last_pos;
    private int last_line;
    private Token last_token;
    private final TokenIndex converter = new TokenIndex();
    private final int[] action = new int[2];

    private final static int SHIFT = 0;
    private final static int REDUCE = 1;
    private final static int ACCEPT = 2;
    private final static int ERROR = 3;
    
    private ArrayList firstPopped = null;
    private ArrayList lastPopped = null;
    private ITokenListContainer lex;

    public Parser(  Lexer lexer)
    {
        this.lexer = lexer;
        this.lex = lexer; 
    }
    
     
    private Map<PositionedNode, SourcecodeRange> mapping = new HashMap<PositionedNode, SourcecodeRange>();    
    public Map<PositionedNode, SourcecodeRange> getMapping() { 	return this.mapping; }

   private void checkResult(Object elementToCheck) {
       checkResult(elementToCheck, false);
   }

	 
	private void checkResult(Object elementToCheck, boolean slurp) {
		// nodes with no tokens or sub nodes at all may exist
		if (this.firstPopped == null) {
			return;
		}

		if (elementToCheck instanceof LinkedList) {
			/*
			 * special case: this is a list of nodes, for example an identifier
			 * list, so we don't want to check the list but the last element
			 * added to it
			 */
			final LinkedList nodeList = (LinkedList) elementToCheck;

			if (nodeList.size() > 0) {
				elementToCheck = nodeList.get(nodeList.size() - 1);
			} else {
				// no positions for empty lists...
				return;
			}
		}

		if (!(elementToCheck instanceof PositionedNode)) {
			throw new Error(
					"Unexpected elementToCheck (not instanceof PositionedNode): "
							+ elementToCheck.getClass().getSimpleName() + "/"
							+ elementToCheck);
		}

		if (!this.getMapping().containsKey(elementToCheck) || slurp ) {
			final PositionedNode node = (PositionedNode) elementToCheck;

			// dealing with a one-token element
			if (this.lastPopped == null) {
				this.lastPopped = this.firstPopped;
			}

			final int begin = findBeginPos(this.lastPopped, node);
			int end = findEndPos(this.firstPopped);
			if (end == -1) end = begin;
			final SourcecodeRange range = new SourcecodeRange(begin, end);

			this.getMapping().put(node, range);

			node.setStartPos(createBeginPos(begin));
			node.setEndPos(createEndPos(end));
		}
	}
	
	 
	private int findBeginPos(final ArrayList list,
			PositionedNode n) {
		Object first = list.get(0);
		if (!(first instanceof PositionedNode) && !(first instanceof IToken)) {
			List list2 = (List) first;

			if (list2.size() > 0) {
				first = list2.get(0);
			} else {
				/*
				 * Sometimes (haven't found out why) we get empty list here. In
				 * the only observed cases we were looking for the source range
				 * of the whole parse unit. Then the index is 0.
				 */
				return 0;
			}
		}

		if (first instanceof IToken) {
			return findIndex((IToken) first);
		}

		final PositionedNode node = (PositionedNode) first;
		final SourcecodeRange item = this.getMapping().get(node);
		if (item == null){
			System.err.println(n.getClass().getSimpleName() + " / " + node.getClass().getSimpleName() + ": " + node);
		}
		return item.getBeginIndex();
	}

	 
	private int findEndPos(final ArrayList list) {
		Object last = list.get(list.size() - 1);
		if (!(last instanceof PositionedNode) && !(last instanceof IToken)) {
			final List list2 = (List) last;
			last = list2.get(list2.size() - 1);
		}

		if (last instanceof IToken) {
			return findIndex((IToken) last);
		}

		final PositionedNode node = (PositionedNode) last;
		final SourcecodeRange item = this.getMapping().get(node);
		if (item == null)
			return -1;
		return item.getEndIndex();
	}

	private int findIndex(final IToken token) {
		final List<IToken> list = this.lex.getTokenList();

		for (int i = list.size() - 1; i >= 0; i--) {
			if (list.get(i) == token) {
				return i;
			}
		}

		return -1;
	}

	private SourcePosition createBeginPos(final int index) {
		final List<IToken> list = this.lex.getTokenList();
		final IToken token = list.get(index);
		return new SourcePosition(token.getLine(), token.getPos());
	}

	private SourcePosition createEndPos(final int index) {
		final List<IToken> list = this.lex.getTokenList();
		final IToken token = list.get(index);
		return new SourcePosition(token.getLine(), token.getPos()
				+ token.getText().length());
	}
	     
    private void push(int numstate, ArrayList listNode) throws ParserException, LexerException, IOException
    {
        this.nodeList = listNode;

        if(!this.stack.hasNext())
        {
            this.stack.add(new State(numstate, this.nodeList));
            return;
        }

        State s = (State) this.stack.next();
        s.state = numstate;
        s.nodes = this.nodeList;
    }

    private int goTo(int index)
    {
        int state = state();
        int low = 1;
        int high = gotoTable[index].length - 1;
        int value = gotoTable[index][0][1];

        while(low <= high)
        {
            int middle = (low + high) / 2;

            if(state < gotoTable[index][middle][0])
            {
                high = middle - 1;
            }
            else if(state > gotoTable[index][middle][0])
            {
                low = middle + 1;
            }
            else
            {
                value = gotoTable[index][middle][1];
                break;
            }
        }

        return value;
    }

    private int state()
    {
        State s = (State) this.stack.previous();
        this.stack.next();
        return s.state;
    }

    private ArrayList pop()
    {
    	ArrayList list = ((State) this.stack.previous()).nodes; 
		if (this.firstPopped == null) {
			this.firstPopped = list;
		} else {
			this.lastPopped = list;
		}
        return list;
    }

    private int index(Switchable token)
    {
        this.converter.index = -1;
        token.apply(this.converter);
        return this.converter.index;
    }

     
    public Start parse() throws ParserException, LexerException, IOException
    {
    	this.getMapping().clear();
    
        push(0, null);
        List<Node> ign = null;
        while(true)
        {
            while(index(this.lexer.peek()) == -1)
            {
                if(ign == null)
                {
                    ign = new LinkedList<Node>();
                }

                ign.add(this.lexer.next());
            }

            if(ign != null)
            {
                this.ignoredTokens.setIn(this.lexer.peek(), ign);
                ign = null;
            }

            this.last_pos = this.lexer.peek().getPos();
            this.last_line = this.lexer.peek().getLine();
            this.last_token = this.lexer.peek();

            int index = index(this.lexer.peek());
            this.action[0] = Parser.actionTable[state()][0][1];
            this.action[1] = Parser.actionTable[state()][0][2];

            int low = 1;
            int high = Parser.actionTable[state()].length - 1;

            while(low <= high)
            {
                int middle = (low + high) / 2;

                if(index < Parser.actionTable[state()][middle][0])
                {
                    high = middle - 1;
                }
                else if(index > Parser.actionTable[state()][middle][0])
                {
                    low = middle + 1;
                }
                else
                {
                    this.action[0] = Parser.actionTable[state()][middle][1];
                    this.action[1] = Parser.actionTable[state()][middle][2];
                    break;
                }
            }

            switch(this.action[0])
            {
                case SHIFT:
		    {
		        ArrayList list = new ArrayList();
		        list.add(this.lexer.next());
                        push(this.action[1], list);
                    }
		    break;
                case REDUCE:
                    switch(this.action[1])
                    {
                    case 0: /* reduce AMachineParseUnit */
		    {
			ArrayList list = new0();
			push(goTo(0), list);
		    }
		    break;
                    case 1: /* reduce AContextParseUnit */
		    {
			ArrayList list = new1();
			push(goTo(0), list);
		    }
		    break;
                    case 2: /* reduce AAmachine1Machine */
		    {
			ArrayList list = new2();
			push(goTo(1), list);
		    }
		    break;
                    case 3: /* reduce AAmachine2Machine */
		    {
			ArrayList list = new3();
			push(goTo(1), list);
		    }
		    break;
                    case 4: /* reduce AAmachine3Machine */
		    {
			ArrayList list = new4();
			push(goTo(1), list);
		    }
		    break;
                    case 5: /* reduce AAmachine4Machine */
		    {
			ArrayList list = new5();
			push(goTo(1), list);
		    }
		    break;
                    case 6: /* reduce AAmachine5Machine */
		    {
			ArrayList list = new6();
			push(goTo(1), list);
		    }
		    break;
                    case 7: /* reduce AAmachine6Machine */
		    {
			ArrayList list = new7();
			push(goTo(1), list);
		    }
		    break;
                    case 8: /* reduce AAmachine7Machine */
		    {
			ArrayList list = new8();
			push(goTo(1), list);
		    }
		    break;
                    case 9: /* reduce AAmachine8Machine */
		    {
			ArrayList list = new9();
			push(goTo(1), list);
		    }
		    break;
                    case 10: /* reduce AAmachine9Machine */
		    {
			ArrayList list = new10();
			push(goTo(1), list);
		    }
		    break;
                    case 11: /* reduce AAmachine10Machine */
		    {
			ArrayList list = new11();
			push(goTo(1), list);
		    }
		    break;
                    case 12: /* reduce AAmachine11Machine */
		    {
			ArrayList list = new12();
			push(goTo(1), list);
		    }
		    break;
                    case 13: /* reduce AAmachine12Machine */
		    {
			ArrayList list = new13();
			push(goTo(1), list);
		    }
		    break;
                    case 14: /* reduce AAmachine13Machine */
		    {
			ArrayList list = new14();
			push(goTo(1), list);
		    }
		    break;
                    case 15: /* reduce AAmachine14Machine */
		    {
			ArrayList list = new15();
			push(goTo(1), list);
		    }
		    break;
                    case 16: /* reduce AAmachine15Machine */
		    {
			ArrayList list = new16();
			push(goTo(1), list);
		    }
		    break;
                    case 17: /* reduce AAmachine16Machine */
		    {
			ArrayList list = new17();
			push(goTo(1), list);
		    }
		    break;
                    case 18: /* reduce AAmachine17Machine */
		    {
			ArrayList list = new18();
			push(goTo(1), list);
		    }
		    break;
                    case 19: /* reduce AAmachine18Machine */
		    {
			ArrayList list = new19();
			push(goTo(1), list);
		    }
		    break;
                    case 20: /* reduce AAmachine19Machine */
		    {
			ArrayList list = new20();
			push(goTo(1), list);
		    }
		    break;
                    case 21: /* reduce AAmachine20Machine */
		    {
			ArrayList list = new21();
			push(goTo(1), list);
		    }
		    break;
                    case 22: /* reduce AAmachine21Machine */
		    {
			ArrayList list = new22();
			push(goTo(1), list);
		    }
		    break;
                    case 23: /* reduce AAmachine22Machine */
		    {
			ArrayList list = new23();
			push(goTo(1), list);
		    }
		    break;
                    case 24: /* reduce AAmachine23Machine */
		    {
			ArrayList list = new24();
			push(goTo(1), list);
		    }
		    break;
                    case 25: /* reduce AAmachine24Machine */
		    {
			ArrayList list = new25();
			push(goTo(1), list);
		    }
		    break;
                    case 26: /* reduce AAmachine25Machine */
		    {
			ArrayList list = new26();
			push(goTo(1), list);
		    }
		    break;
                    case 27: /* reduce AAmachine26Machine */
		    {
			ArrayList list = new27();
			push(goTo(1), list);
		    }
		    break;
                    case 28: /* reduce AAmachine27Machine */
		    {
			ArrayList list = new28();
			push(goTo(1), list);
		    }
		    break;
                    case 29: /* reduce AAmachine28Machine */
		    {
			ArrayList list = new29();
			push(goTo(1), list);
		    }
		    break;
                    case 30: /* reduce AAmachine29Machine */
		    {
			ArrayList list = new30();
			push(goTo(1), list);
		    }
		    break;
                    case 31: /* reduce AAmachine30Machine */
		    {
			ArrayList list = new31();
			push(goTo(1), list);
		    }
		    break;
                    case 32: /* reduce AAmachine31Machine */
		    {
			ArrayList list = new32();
			push(goTo(1), list);
		    }
		    break;
                    case 33: /* reduce AAmachine32Machine */
		    {
			ArrayList list = new33();
			push(goTo(1), list);
		    }
		    break;
                    case 34: /* reduce AAmachine33Machine */
		    {
			ArrayList list = new34();
			push(goTo(1), list);
		    }
		    break;
                    case 35: /* reduce AAmachine34Machine */
		    {
			ArrayList list = new35();
			push(goTo(1), list);
		    }
		    break;
                    case 36: /* reduce AAmachine35Machine */
		    {
			ArrayList list = new36();
			push(goTo(1), list);
		    }
		    break;
                    case 37: /* reduce AAmachine36Machine */
		    {
			ArrayList list = new37();
			push(goTo(1), list);
		    }
		    break;
                    case 38: /* reduce AAmachine37Machine */
		    {
			ArrayList list = new38();
			push(goTo(1), list);
		    }
		    break;
                    case 39: /* reduce AAmachine38Machine */
		    {
			ArrayList list = new39();
			push(goTo(1), list);
		    }
		    break;
                    case 40: /* reduce AAmachine39Machine */
		    {
			ArrayList list = new40();
			push(goTo(1), list);
		    }
		    break;
                    case 41: /* reduce AAmachine40Machine */
		    {
			ArrayList list = new41();
			push(goTo(1), list);
		    }
		    break;
                    case 42: /* reduce AAmachine41Machine */
		    {
			ArrayList list = new42();
			push(goTo(1), list);
		    }
		    break;
                    case 43: /* reduce AAmachine42Machine */
		    {
			ArrayList list = new43();
			push(goTo(1), list);
		    }
		    break;
                    case 44: /* reduce AAmachine43Machine */
		    {
			ArrayList list = new44();
			push(goTo(1), list);
		    }
		    break;
                    case 45: /* reduce AAmachine44Machine */
		    {
			ArrayList list = new45();
			push(goTo(1), list);
		    }
		    break;
                    case 46: /* reduce AAmachine45Machine */
		    {
			ArrayList list = new46();
			push(goTo(1), list);
		    }
		    break;
                    case 47: /* reduce AAmachine46Machine */
		    {
			ArrayList list = new47();
			push(goTo(1), list);
		    }
		    break;
                    case 48: /* reduce AAmachine47Machine */
		    {
			ArrayList list = new48();
			push(goTo(1), list);
		    }
		    break;
                    case 49: /* reduce AAmachine48Machine */
		    {
			ArrayList list = new49();
			push(goTo(1), list);
		    }
		    break;
                    case 50: /* reduce AAmachine49Machine */
		    {
			ArrayList list = new50();
			push(goTo(1), list);
		    }
		    break;
                    case 51: /* reduce AAmachine50Machine */
		    {
			ArrayList list = new51();
			push(goTo(1), list);
		    }
		    break;
                    case 52: /* reduce AAmachine51Machine */
		    {
			ArrayList list = new52();
			push(goTo(1), list);
		    }
		    break;
                    case 53: /* reduce AAmachine52Machine */
		    {
			ArrayList list = new53();
			push(goTo(1), list);
		    }
		    break;
                    case 54: /* reduce AAmachine53Machine */
		    {
			ArrayList list = new54();
			push(goTo(1), list);
		    }
		    break;
                    case 55: /* reduce AAmachine54Machine */
		    {
			ArrayList list = new55();
			push(goTo(1), list);
		    }
		    break;
                    case 56: /* reduce AAmachine55Machine */
		    {
			ArrayList list = new56();
			push(goTo(1), list);
		    }
		    break;
                    case 57: /* reduce AAmachine56Machine */
		    {
			ArrayList list = new57();
			push(goTo(1), list);
		    }
		    break;
                    case 58: /* reduce AAmachine57Machine */
		    {
			ArrayList list = new58();
			push(goTo(1), list);
		    }
		    break;
                    case 59: /* reduce AAmachine58Machine */
		    {
			ArrayList list = new59();
			push(goTo(1), list);
		    }
		    break;
                    case 60: /* reduce AAmachine59Machine */
		    {
			ArrayList list = new60();
			push(goTo(1), list);
		    }
		    break;
                    case 61: /* reduce AAmachine60Machine */
		    {
			ArrayList list = new61();
			push(goTo(1), list);
		    }
		    break;
                    case 62: /* reduce AAmachine61Machine */
		    {
			ArrayList list = new62();
			push(goTo(1), list);
		    }
		    break;
                    case 63: /* reduce AAmachine62Machine */
		    {
			ArrayList list = new63();
			push(goTo(1), list);
		    }
		    break;
                    case 64: /* reduce AAmachine63Machine */
		    {
			ArrayList list = new64();
			push(goTo(1), list);
		    }
		    break;
                    case 65: /* reduce AAmachine64Machine */
		    {
			ArrayList list = new65();
			push(goTo(1), list);
		    }
		    break;
                    case 66: /* reduce AAmachine65Machine */
		    {
			ArrayList list = new66();
			push(goTo(1), list);
		    }
		    break;
                    case 67: /* reduce AAmachine66Machine */
		    {
			ArrayList list = new67();
			push(goTo(1), list);
		    }
		    break;
                    case 68: /* reduce AAmachine67Machine */
		    {
			ArrayList list = new68();
			push(goTo(1), list);
		    }
		    break;
                    case 69: /* reduce AAmachine68Machine */
		    {
			ArrayList list = new69();
			push(goTo(1), list);
		    }
		    break;
                    case 70: /* reduce AAmachine69Machine */
		    {
			ArrayList list = new70();
			push(goTo(1), list);
		    }
		    break;
                    case 71: /* reduce AAmachine70Machine */
		    {
			ArrayList list = new71();
			push(goTo(1), list);
		    }
		    break;
                    case 72: /* reduce AAmachine71Machine */
		    {
			ArrayList list = new72();
			push(goTo(1), list);
		    }
		    break;
                    case 73: /* reduce AAmachine72Machine */
		    {
			ArrayList list = new73();
			push(goTo(1), list);
		    }
		    break;
                    case 74: /* reduce AAmachine73Machine */
		    {
			ArrayList list = new74();
			push(goTo(1), list);
		    }
		    break;
                    case 75: /* reduce AAmachine74Machine */
		    {
			ArrayList list = new75();
			push(goTo(1), list);
		    }
		    break;
                    case 76: /* reduce AAmachine75Machine */
		    {
			ArrayList list = new76();
			push(goTo(1), list);
		    }
		    break;
                    case 77: /* reduce AAmachine76Machine */
		    {
			ArrayList list = new77();
			push(goTo(1), list);
		    }
		    break;
                    case 78: /* reduce AAmachine77Machine */
		    {
			ArrayList list = new78();
			push(goTo(1), list);
		    }
		    break;
                    case 79: /* reduce AAmachine78Machine */
		    {
			ArrayList list = new79();
			push(goTo(1), list);
		    }
		    break;
                    case 80: /* reduce AAmachine79Machine */
		    {
			ArrayList list = new80();
			push(goTo(1), list);
		    }
		    break;
                    case 81: /* reduce AAmachine80Machine */
		    {
			ArrayList list = new81();
			push(goTo(1), list);
		    }
		    break;
                    case 82: /* reduce AAmachine81Machine */
		    {
			ArrayList list = new82();
			push(goTo(1), list);
		    }
		    break;
                    case 83: /* reduce AAmachine82Machine */
		    {
			ArrayList list = new83();
			push(goTo(1), list);
		    }
		    break;
                    case 84: /* reduce AAmachine83Machine */
		    {
			ArrayList list = new84();
			push(goTo(1), list);
		    }
		    break;
                    case 85: /* reduce AAmachine84Machine */
		    {
			ArrayList list = new85();
			push(goTo(1), list);
		    }
		    break;
                    case 86: /* reduce AAmachine85Machine */
		    {
			ArrayList list = new86();
			push(goTo(1), list);
		    }
		    break;
                    case 87: /* reduce AAmachine86Machine */
		    {
			ArrayList list = new87();
			push(goTo(1), list);
		    }
		    break;
                    case 88: /* reduce AAmachine87Machine */
		    {
			ArrayList list = new88();
			push(goTo(1), list);
		    }
		    break;
                    case 89: /* reduce AAmachine88Machine */
		    {
			ArrayList list = new89();
			push(goTo(1), list);
		    }
		    break;
                    case 90: /* reduce AAmachine89Machine */
		    {
			ArrayList list = new90();
			push(goTo(1), list);
		    }
		    break;
                    case 91: /* reduce AAmachine90Machine */
		    {
			ArrayList list = new91();
			push(goTo(1), list);
		    }
		    break;
                    case 92: /* reduce AAmachine91Machine */
		    {
			ArrayList list = new92();
			push(goTo(1), list);
		    }
		    break;
                    case 93: /* reduce AAmachine92Machine */
		    {
			ArrayList list = new93();
			push(goTo(1), list);
		    }
		    break;
                    case 94: /* reduce AAmachine93Machine */
		    {
			ArrayList list = new94();
			push(goTo(1), list);
		    }
		    break;
                    case 95: /* reduce AAmachine94Machine */
		    {
			ArrayList list = new95();
			push(goTo(1), list);
		    }
		    break;
                    case 96: /* reduce AAmachine95Machine */
		    {
			ArrayList list = new96();
			push(goTo(1), list);
		    }
		    break;
                    case 97: /* reduce AAmachine96Machine */
		    {
			ArrayList list = new97();
			push(goTo(1), list);
		    }
		    break;
                    case 98: /* reduce AAmachine97Machine */
		    {
			ArrayList list = new98();
			push(goTo(1), list);
		    }
		    break;
                    case 99: /* reduce AAmachine98Machine */
		    {
			ArrayList list = new99();
			push(goTo(1), list);
		    }
		    break;
                    case 100: /* reduce AAmachine99Machine */
		    {
			ArrayList list = new100();
			push(goTo(1), list);
		    }
		    break;
                    case 101: /* reduce AAmachine100Machine */
		    {
			ArrayList list = new101();
			push(goTo(1), list);
		    }
		    break;
                    case 102: /* reduce AAmachine101Machine */
		    {
			ArrayList list = new102();
			push(goTo(1), list);
		    }
		    break;
                    case 103: /* reduce AAmachine102Machine */
		    {
			ArrayList list = new103();
			push(goTo(1), list);
		    }
		    break;
                    case 104: /* reduce AAmachine103Machine */
		    {
			ArrayList list = new104();
			push(goTo(1), list);
		    }
		    break;
                    case 105: /* reduce AAmachine104Machine */
		    {
			ArrayList list = new105();
			push(goTo(1), list);
		    }
		    break;
                    case 106: /* reduce AAmachine105Machine */
		    {
			ArrayList list = new106();
			push(goTo(1), list);
		    }
		    break;
                    case 107: /* reduce AAmachine106Machine */
		    {
			ArrayList list = new107();
			push(goTo(1), list);
		    }
		    break;
                    case 108: /* reduce AAmachine107Machine */
		    {
			ArrayList list = new108();
			push(goTo(1), list);
		    }
		    break;
                    case 109: /* reduce AAmachine108Machine */
		    {
			ArrayList list = new109();
			push(goTo(1), list);
		    }
		    break;
                    case 110: /* reduce AAmachine109Machine */
		    {
			ArrayList list = new110();
			push(goTo(1), list);
		    }
		    break;
                    case 111: /* reduce AAmachine110Machine */
		    {
			ArrayList list = new111();
			push(goTo(1), list);
		    }
		    break;
                    case 112: /* reduce AAmachine111Machine */
		    {
			ArrayList list = new112();
			push(goTo(1), list);
		    }
		    break;
                    case 113: /* reduce AAmachine112Machine */
		    {
			ArrayList list = new113();
			push(goTo(1), list);
		    }
		    break;
                    case 114: /* reduce AAmachine113Machine */
		    {
			ArrayList list = new114();
			push(goTo(1), list);
		    }
		    break;
                    case 115: /* reduce AAmachine114Machine */
		    {
			ArrayList list = new115();
			push(goTo(1), list);
		    }
		    break;
                    case 116: /* reduce AAmachine115Machine */
		    {
			ArrayList list = new116();
			push(goTo(1), list);
		    }
		    break;
                    case 117: /* reduce AAmachine116Machine */
		    {
			ArrayList list = new117();
			push(goTo(1), list);
		    }
		    break;
                    case 118: /* reduce AAmachine117Machine */
		    {
			ArrayList list = new118();
			push(goTo(1), list);
		    }
		    break;
                    case 119: /* reduce AAmachine118Machine */
		    {
			ArrayList list = new119();
			push(goTo(1), list);
		    }
		    break;
                    case 120: /* reduce AAmachine119Machine */
		    {
			ArrayList list = new120();
			push(goTo(1), list);
		    }
		    break;
                    case 121: /* reduce AAmachine120Machine */
		    {
			ArrayList list = new121();
			push(goTo(1), list);
		    }
		    break;
                    case 122: /* reduce AAmachine121Machine */
		    {
			ArrayList list = new122();
			push(goTo(1), list);
		    }
		    break;
                    case 123: /* reduce AAmachine122Machine */
		    {
			ArrayList list = new123();
			push(goTo(1), list);
		    }
		    break;
                    case 124: /* reduce AAmachine123Machine */
		    {
			ArrayList list = new124();
			push(goTo(1), list);
		    }
		    break;
                    case 125: /* reduce AAmachine124Machine */
		    {
			ArrayList list = new125();
			push(goTo(1), list);
		    }
		    break;
                    case 126: /* reduce AAmachine125Machine */
		    {
			ArrayList list = new126();
			push(goTo(1), list);
		    }
		    break;
                    case 127: /* reduce AAmachine126Machine */
		    {
			ArrayList list = new127();
			push(goTo(1), list);
		    }
		    break;
                    case 128: /* reduce AAmachine127Machine */
		    {
			ArrayList list = new128();
			push(goTo(1), list);
		    }
		    break;
                    case 129: /* reduce AAmachine128Machine */
		    {
			ArrayList list = new129();
			push(goTo(1), list);
		    }
		    break;
                    case 130: /* reduce AArefinesclause1RefinesClause */
		    {
			ArrayList list = new130();
			push(goTo(2), list);
		    }
		    break;
                    case 131: /* reduce AArefinesclause2RefinesClause */
		    {
			ArrayList list = new131();
			push(goTo(2), list);
		    }
		    break;
                    case 132: /* reduce ARefinesClauseTail */
		    {
			ArrayList list = new132();
			push(goTo(3), list);
		    }
		    break;
                    case 133: /* reduce AAseesclause1SeesClause */
		    {
			ArrayList list = new133();
			push(goTo(4), list);
		    }
		    break;
                    case 134: /* reduce AAseesclause2SeesClause */
		    {
			ArrayList list = new134();
			push(goTo(4), list);
		    }
		    break;
                    case 135: /* reduce ASeesClauseTail */
		    {
			ArrayList list = new135();
			push(goTo(5), list);
		    }
		    break;
                    case 136: /* reduce AVariablesClause */
		    {
			ArrayList list = new136();
			push(goTo(6), list);
		    }
		    break;
                    case 137: /* reduce AAsinglevariablelist1VariableList */
		    {
			ArrayList list = new137();
			push(goTo(7), list);
		    }
		    break;
                    case 138: /* reduce AAsinglevariablelist2VariableList */
		    {
			ArrayList list = new138();
			push(goTo(7), list);
		    }
		    break;
                    case 139: /* reduce AAmultivariablelist1VariableList */
		    {
			ArrayList list = new139();
			push(goTo(7), list);
		    }
		    break;
                    case 140: /* reduce AAmultivariablelist2VariableList */
		    {
			ArrayList list = new140();
			push(goTo(7), list);
		    }
		    break;
                    case 141: /* reduce AAinvariantsclause1InvariantsClause */
		    {
			ArrayList list = new141();
			push(goTo(8), list);
		    }
		    break;
                    case 142: /* reduce AAinvariantsclause2InvariantsClause */
		    {
			ArrayList list = new142();
			push(goTo(8), list);
		    }
		    break;
                    case 143: /* reduce AInvariantsTail */
		    {
			ArrayList list = new143();
			push(goTo(9), list);
		    }
		    break;
                    case 144: /* reduce AAinvariant1Invariant */
		    {
			ArrayList list = new144();
			push(goTo(10), list);
		    }
		    break;
                    case 145: /* reduce AAinvariant2Invariant */
		    {
			ArrayList list = new145();
			push(goTo(10), list);
		    }
		    break;
                    case 146: /* reduce AAderivedinvariant1Invariant */
		    {
			ArrayList list = new146();
			push(goTo(10), list);
		    }
		    break;
                    case 147: /* reduce AAderivedinvariant2Invariant */
		    {
			ArrayList list = new147();
			push(goTo(10), list);
		    }
		    break;
                    case 148: /* reduce AAvariantclause1VariantClause */
		    {
			ArrayList list = new148();
			push(goTo(11), list);
		    }
		    break;
                    case 149: /* reduce AAvariantclause2VariantClause */
		    {
			ArrayList list = new149();
			push(goTo(11), list);
		    }
		    break;
                    case 150: /* reduce AAeventsclause1EventsClause */
		    {
			ArrayList list = new150();
			push(goTo(12), list);
		    }
		    break;
                    case 151: /* reduce AAeventsclause2EventsClause */
		    {
			ArrayList list = new151();
			push(goTo(12), list);
		    }
		    break;
                    case 152: /* reduce AEventsTail */
		    {
			ArrayList list = new152();
			push(goTo(13), list);
		    }
		    break;
                    case 153: /* reduce AAevent1Event */
		    {
			ArrayList list = new153();
			push(goTo(14), list);
		    }
		    break;
                    case 154: /* reduce AAevent2Event */
		    {
			ArrayList list = new154();
			push(goTo(14), list);
		    }
		    break;
                    case 155: /* reduce AAevent3Event */
		    {
			ArrayList list = new155();
			push(goTo(14), list);
		    }
		    break;
                    case 156: /* reduce AAevent4Event */
		    {
			ArrayList list = new156();
			push(goTo(14), list);
		    }
		    break;
                    case 157: /* reduce AAevent5Event */
		    {
			ArrayList list = new157();
			push(goTo(14), list);
		    }
		    break;
                    case 158: /* reduce AAevent6Event */
		    {
			ArrayList list = new158();
			push(goTo(14), list);
		    }
		    break;
                    case 159: /* reduce AAevent7Event */
		    {
			ArrayList list = new159();
			push(goTo(14), list);
		    }
		    break;
                    case 160: /* reduce AAevent8Event */
		    {
			ArrayList list = new160();
			push(goTo(14), list);
		    }
		    break;
                    case 161: /* reduce AAevent9Event */
		    {
			ArrayList list = new161();
			push(goTo(14), list);
		    }
		    break;
                    case 162: /* reduce AAevent10Event */
		    {
			ArrayList list = new162();
			push(goTo(14), list);
		    }
		    break;
                    case 163: /* reduce AAevent11Event */
		    {
			ArrayList list = new163();
			push(goTo(14), list);
		    }
		    break;
                    case 164: /* reduce AAevent12Event */
		    {
			ArrayList list = new164();
			push(goTo(14), list);
		    }
		    break;
                    case 165: /* reduce AAevent13Event */
		    {
			ArrayList list = new165();
			push(goTo(14), list);
		    }
		    break;
                    case 166: /* reduce AAevent14Event */
		    {
			ArrayList list = new166();
			push(goTo(14), list);
		    }
		    break;
                    case 167: /* reduce AAevent15Event */
		    {
			ArrayList list = new167();
			push(goTo(14), list);
		    }
		    break;
                    case 168: /* reduce AAevent16Event */
		    {
			ArrayList list = new168();
			push(goTo(14), list);
		    }
		    break;
                    case 169: /* reduce AAevent17Event */
		    {
			ArrayList list = new169();
			push(goTo(14), list);
		    }
		    break;
                    case 170: /* reduce AAevent18Event */
		    {
			ArrayList list = new170();
			push(goTo(14), list);
		    }
		    break;
                    case 171: /* reduce AAevent19Event */
		    {
			ArrayList list = new171();
			push(goTo(14), list);
		    }
		    break;
                    case 172: /* reduce AAevent20Event */
		    {
			ArrayList list = new172();
			push(goTo(14), list);
		    }
		    break;
                    case 173: /* reduce AAevent21Event */
		    {
			ArrayList list = new173();
			push(goTo(14), list);
		    }
		    break;
                    case 174: /* reduce AAevent22Event */
		    {
			ArrayList list = new174();
			push(goTo(14), list);
		    }
		    break;
                    case 175: /* reduce AAevent23Event */
		    {
			ArrayList list = new175();
			push(goTo(14), list);
		    }
		    break;
                    case 176: /* reduce AAevent24Event */
		    {
			ArrayList list = new176();
			push(goTo(14), list);
		    }
		    break;
                    case 177: /* reduce AAevent25Event */
		    {
			ArrayList list = new177();
			push(goTo(14), list);
		    }
		    break;
                    case 178: /* reduce AAevent26Event */
		    {
			ArrayList list = new178();
			push(goTo(14), list);
		    }
		    break;
                    case 179: /* reduce AAevent27Event */
		    {
			ArrayList list = new179();
			push(goTo(14), list);
		    }
		    break;
                    case 180: /* reduce AAevent28Event */
		    {
			ArrayList list = new180();
			push(goTo(14), list);
		    }
		    break;
                    case 181: /* reduce AAevent29Event */
		    {
			ArrayList list = new181();
			push(goTo(14), list);
		    }
		    break;
                    case 182: /* reduce AAevent30Event */
		    {
			ArrayList list = new182();
			push(goTo(14), list);
		    }
		    break;
                    case 183: /* reduce AAevent31Event */
		    {
			ArrayList list = new183();
			push(goTo(14), list);
		    }
		    break;
                    case 184: /* reduce AAevent32Event */
		    {
			ArrayList list = new184();
			push(goTo(14), list);
		    }
		    break;
                    case 185: /* reduce AAevent33Event */
		    {
			ArrayList list = new185();
			push(goTo(14), list);
		    }
		    break;
                    case 186: /* reduce AAevent34Event */
		    {
			ArrayList list = new186();
			push(goTo(14), list);
		    }
		    break;
                    case 187: /* reduce AAevent35Event */
		    {
			ArrayList list = new187();
			push(goTo(14), list);
		    }
		    break;
                    case 188: /* reduce AAevent36Event */
		    {
			ArrayList list = new188();
			push(goTo(14), list);
		    }
		    break;
                    case 189: /* reduce AAevent37Event */
		    {
			ArrayList list = new189();
			push(goTo(14), list);
		    }
		    break;
                    case 190: /* reduce AAevent38Event */
		    {
			ArrayList list = new190();
			push(goTo(14), list);
		    }
		    break;
                    case 191: /* reduce AAevent39Event */
		    {
			ArrayList list = new191();
			push(goTo(14), list);
		    }
		    break;
                    case 192: /* reduce AAevent40Event */
		    {
			ArrayList list = new192();
			push(goTo(14), list);
		    }
		    break;
                    case 193: /* reduce AAevent41Event */
		    {
			ArrayList list = new193();
			push(goTo(14), list);
		    }
		    break;
                    case 194: /* reduce AAevent42Event */
		    {
			ArrayList list = new194();
			push(goTo(14), list);
		    }
		    break;
                    case 195: /* reduce AAevent43Event */
		    {
			ArrayList list = new195();
			push(goTo(14), list);
		    }
		    break;
                    case 196: /* reduce AAevent44Event */
		    {
			ArrayList list = new196();
			push(goTo(14), list);
		    }
		    break;
                    case 197: /* reduce AAevent45Event */
		    {
			ArrayList list = new197();
			push(goTo(14), list);
		    }
		    break;
                    case 198: /* reduce AAevent46Event */
		    {
			ArrayList list = new198();
			push(goTo(14), list);
		    }
		    break;
                    case 199: /* reduce AAevent47Event */
		    {
			ArrayList list = new199();
			push(goTo(14), list);
		    }
		    break;
                    case 200: /* reduce AAevent48Event */
		    {
			ArrayList list = new200();
			push(goTo(14), list);
		    }
		    break;
                    case 201: /* reduce AAevent49Event */
		    {
			ArrayList list = new201();
			push(goTo(14), list);
		    }
		    break;
                    case 202: /* reduce AAevent50Event */
		    {
			ArrayList list = new202();
			push(goTo(14), list);
		    }
		    break;
                    case 203: /* reduce AAevent51Event */
		    {
			ArrayList list = new203();
			push(goTo(14), list);
		    }
		    break;
                    case 204: /* reduce AAevent52Event */
		    {
			ArrayList list = new204();
			push(goTo(14), list);
		    }
		    break;
                    case 205: /* reduce AAevent53Event */
		    {
			ArrayList list = new205();
			push(goTo(14), list);
		    }
		    break;
                    case 206: /* reduce AAevent54Event */
		    {
			ArrayList list = new206();
			push(goTo(14), list);
		    }
		    break;
                    case 207: /* reduce AAevent55Event */
		    {
			ArrayList list = new207();
			push(goTo(14), list);
		    }
		    break;
                    case 208: /* reduce AAevent56Event */
		    {
			ArrayList list = new208();
			push(goTo(14), list);
		    }
		    break;
                    case 209: /* reduce AAevent57Event */
		    {
			ArrayList list = new209();
			push(goTo(14), list);
		    }
		    break;
                    case 210: /* reduce AAevent58Event */
		    {
			ArrayList list = new210();
			push(goTo(14), list);
		    }
		    break;
                    case 211: /* reduce AAevent59Event */
		    {
			ArrayList list = new211();
			push(goTo(14), list);
		    }
		    break;
                    case 212: /* reduce AAevent60Event */
		    {
			ArrayList list = new212();
			push(goTo(14), list);
		    }
		    break;
                    case 213: /* reduce AAevent61Event */
		    {
			ArrayList list = new213();
			push(goTo(14), list);
		    }
		    break;
                    case 214: /* reduce AAevent62Event */
		    {
			ArrayList list = new214();
			push(goTo(14), list);
		    }
		    break;
                    case 215: /* reduce AAevent63Event */
		    {
			ArrayList list = new215();
			push(goTo(14), list);
		    }
		    break;
                    case 216: /* reduce AAevent64Event */
		    {
			ArrayList list = new216();
			push(goTo(14), list);
		    }
		    break;
                    case 217: /* reduce AAevent65Event */
		    {
			ArrayList list = new217();
			push(goTo(14), list);
		    }
		    break;
                    case 218: /* reduce AAevent66Event */
		    {
			ArrayList list = new218();
			push(goTo(14), list);
		    }
		    break;
                    case 219: /* reduce AAevent67Event */
		    {
			ArrayList list = new219();
			push(goTo(14), list);
		    }
		    break;
                    case 220: /* reduce AAevent68Event */
		    {
			ArrayList list = new220();
			push(goTo(14), list);
		    }
		    break;
                    case 221: /* reduce AAevent69Event */
		    {
			ArrayList list = new221();
			push(goTo(14), list);
		    }
		    break;
                    case 222: /* reduce AAevent70Event */
		    {
			ArrayList list = new222();
			push(goTo(14), list);
		    }
		    break;
                    case 223: /* reduce AAevent71Event */
		    {
			ArrayList list = new223();
			push(goTo(14), list);
		    }
		    break;
                    case 224: /* reduce AAevent72Event */
		    {
			ArrayList list = new224();
			push(goTo(14), list);
		    }
		    break;
                    case 225: /* reduce AAevent73Event */
		    {
			ArrayList list = new225();
			push(goTo(14), list);
		    }
		    break;
                    case 226: /* reduce AAevent74Event */
		    {
			ArrayList list = new226();
			push(goTo(14), list);
		    }
		    break;
                    case 227: /* reduce AAevent75Event */
		    {
			ArrayList list = new227();
			push(goTo(14), list);
		    }
		    break;
                    case 228: /* reduce AAevent76Event */
		    {
			ArrayList list = new228();
			push(goTo(14), list);
		    }
		    break;
                    case 229: /* reduce AAevent77Event */
		    {
			ArrayList list = new229();
			push(goTo(14), list);
		    }
		    break;
                    case 230: /* reduce AAevent78Event */
		    {
			ArrayList list = new230();
			push(goTo(14), list);
		    }
		    break;
                    case 231: /* reduce AAevent79Event */
		    {
			ArrayList list = new231();
			push(goTo(14), list);
		    }
		    break;
                    case 232: /* reduce AAevent80Event */
		    {
			ArrayList list = new232();
			push(goTo(14), list);
		    }
		    break;
                    case 233: /* reduce AAevent81Event */
		    {
			ArrayList list = new233();
			push(goTo(14), list);
		    }
		    break;
                    case 234: /* reduce AAevent82Event */
		    {
			ArrayList list = new234();
			push(goTo(14), list);
		    }
		    break;
                    case 235: /* reduce AAevent83Event */
		    {
			ArrayList list = new235();
			push(goTo(14), list);
		    }
		    break;
                    case 236: /* reduce AAevent84Event */
		    {
			ArrayList list = new236();
			push(goTo(14), list);
		    }
		    break;
                    case 237: /* reduce AAevent85Event */
		    {
			ArrayList list = new237();
			push(goTo(14), list);
		    }
		    break;
                    case 238: /* reduce AAevent86Event */
		    {
			ArrayList list = new238();
			push(goTo(14), list);
		    }
		    break;
                    case 239: /* reduce AAevent87Event */
		    {
			ArrayList list = new239();
			push(goTo(14), list);
		    }
		    break;
                    case 240: /* reduce AAevent88Event */
		    {
			ArrayList list = new240();
			push(goTo(14), list);
		    }
		    break;
                    case 241: /* reduce AAevent89Event */
		    {
			ArrayList list = new241();
			push(goTo(14), list);
		    }
		    break;
                    case 242: /* reduce AAevent90Event */
		    {
			ArrayList list = new242();
			push(goTo(14), list);
		    }
		    break;
                    case 243: /* reduce AAevent91Event */
		    {
			ArrayList list = new243();
			push(goTo(14), list);
		    }
		    break;
                    case 244: /* reduce AAevent92Event */
		    {
			ArrayList list = new244();
			push(goTo(14), list);
		    }
		    break;
                    case 245: /* reduce AAevent93Event */
		    {
			ArrayList list = new245();
			push(goTo(14), list);
		    }
		    break;
                    case 246: /* reduce AAevent94Event */
		    {
			ArrayList list = new246();
			push(goTo(14), list);
		    }
		    break;
                    case 247: /* reduce AAevent95Event */
		    {
			ArrayList list = new247();
			push(goTo(14), list);
		    }
		    break;
                    case 248: /* reduce AAevent96Event */
		    {
			ArrayList list = new248();
			push(goTo(14), list);
		    }
		    break;
                    case 249: /* reduce AAevent97Event */
		    {
			ArrayList list = new249();
			push(goTo(14), list);
		    }
		    break;
                    case 250: /* reduce AAevent98Event */
		    {
			ArrayList list = new250();
			push(goTo(14), list);
		    }
		    break;
                    case 251: /* reduce AAevent99Event */
		    {
			ArrayList list = new251();
			push(goTo(14), list);
		    }
		    break;
                    case 252: /* reduce AAevent100Event */
		    {
			ArrayList list = new252();
			push(goTo(14), list);
		    }
		    break;
                    case 253: /* reduce AAevent101Event */
		    {
			ArrayList list = new253();
			push(goTo(14), list);
		    }
		    break;
                    case 254: /* reduce AAevent102Event */
		    {
			ArrayList list = new254();
			push(goTo(14), list);
		    }
		    break;
                    case 255: /* reduce AAevent103Event */
		    {
			ArrayList list = new255();
			push(goTo(14), list);
		    }
		    break;
                    case 256: /* reduce AAevent104Event */
		    {
			ArrayList list = new256();
			push(goTo(14), list);
		    }
		    break;
                    case 257: /* reduce AAevent105Event */
		    {
			ArrayList list = new257();
			push(goTo(14), list);
		    }
		    break;
                    case 258: /* reduce AAevent106Event */
		    {
			ArrayList list = new258();
			push(goTo(14), list);
		    }
		    break;
                    case 259: /* reduce AAevent107Event */
		    {
			ArrayList list = new259();
			push(goTo(14), list);
		    }
		    break;
                    case 260: /* reduce AAevent108Event */
		    {
			ArrayList list = new260();
			push(goTo(14), list);
		    }
		    break;
                    case 261: /* reduce AAevent109Event */
		    {
			ArrayList list = new261();
			push(goTo(14), list);
		    }
		    break;
                    case 262: /* reduce AAevent110Event */
		    {
			ArrayList list = new262();
			push(goTo(14), list);
		    }
		    break;
                    case 263: /* reduce AAevent111Event */
		    {
			ArrayList list = new263();
			push(goTo(14), list);
		    }
		    break;
                    case 264: /* reduce AAevent112Event */
		    {
			ArrayList list = new264();
			push(goTo(14), list);
		    }
		    break;
                    case 265: /* reduce AAevent113Event */
		    {
			ArrayList list = new265();
			push(goTo(14), list);
		    }
		    break;
                    case 266: /* reduce AAevent114Event */
		    {
			ArrayList list = new266();
			push(goTo(14), list);
		    }
		    break;
                    case 267: /* reduce AAevent115Event */
		    {
			ArrayList list = new267();
			push(goTo(14), list);
		    }
		    break;
                    case 268: /* reduce AAevent116Event */
		    {
			ArrayList list = new268();
			push(goTo(14), list);
		    }
		    break;
                    case 269: /* reduce AAevent117Event */
		    {
			ArrayList list = new269();
			push(goTo(14), list);
		    }
		    break;
                    case 270: /* reduce AAevent118Event */
		    {
			ArrayList list = new270();
			push(goTo(14), list);
		    }
		    break;
                    case 271: /* reduce AAevent119Event */
		    {
			ArrayList list = new271();
			push(goTo(14), list);
		    }
		    break;
                    case 272: /* reduce AAevent120Event */
		    {
			ArrayList list = new272();
			push(goTo(14), list);
		    }
		    break;
                    case 273: /* reduce AAevent121Event */
		    {
			ArrayList list = new273();
			push(goTo(14), list);
		    }
		    break;
                    case 274: /* reduce AAevent122Event */
		    {
			ArrayList list = new274();
			push(goTo(14), list);
		    }
		    break;
                    case 275: /* reduce AAevent123Event */
		    {
			ArrayList list = new275();
			push(goTo(14), list);
		    }
		    break;
                    case 276: /* reduce AAevent124Event */
		    {
			ArrayList list = new276();
			push(goTo(14), list);
		    }
		    break;
                    case 277: /* reduce AAevent125Event */
		    {
			ArrayList list = new277();
			push(goTo(14), list);
		    }
		    break;
                    case 278: /* reduce AAevent126Event */
		    {
			ArrayList list = new278();
			push(goTo(14), list);
		    }
		    break;
                    case 279: /* reduce AAevent127Event */
		    {
			ArrayList list = new279();
			push(goTo(14), list);
		    }
		    break;
                    case 280: /* reduce AAevent128Event */
		    {
			ArrayList list = new280();
			push(goTo(14), list);
		    }
		    break;
                    case 281: /* reduce AOrdinaryConvergence */
		    {
			ArrayList list = new281();
			push(goTo(15), list);
		    }
		    break;
                    case 282: /* reduce AConvergentConvergence */
		    {
			ArrayList list = new282();
			push(goTo(15), list);
		    }
		    break;
                    case 283: /* reduce AAnticipatedConvergence */
		    {
			ArrayList list = new283();
			push(goTo(15), list);
		    }
		    break;
                    case 284: /* reduce ARefinesEventRefinement */
		    {
			ArrayList list = new284();
			push(goTo(16), list);
		    }
		    break;
                    case 285: /* reduce AExtendedEventRefinement */
		    {
			ArrayList list = new285();
			push(goTo(16), list);
		    }
		    break;
                    case 286: /* reduce AAeventrefines1EventRefines */
		    {
			ArrayList list = new286();
			push(goTo(17), list);
		    }
		    break;
                    case 287: /* reduce AAeventrefines2EventRefines */
		    {
			ArrayList list = new287();
			push(goTo(17), list);
		    }
		    break;
                    case 288: /* reduce AEventRefinesTail */
		    {
			ArrayList list = new288();
			push(goTo(18), list);
		    }
		    break;
                    case 289: /* reduce AAeventany1EventAny */
		    {
			ArrayList list = new289();
			push(goTo(19), list);
		    }
		    break;
                    case 290: /* reduce AAeventany2EventAny */
		    {
			ArrayList list = new290();
			push(goTo(19), list);
		    }
		    break;
                    case 291: /* reduce AEventAnyTail */
		    {
			ArrayList list = new291();
			push(goTo(20), list);
		    }
		    break;
                    case 292: /* reduce AAparameter1Parameter */
		    {
			ArrayList list = new292();
			push(goTo(21), list);
		    }
		    break;
                    case 293: /* reduce AAparameter2Parameter */
		    {
			ArrayList list = new293();
			push(goTo(21), list);
		    }
		    break;
                    case 294: /* reduce AAeventwhere1EventWhere */
		    {
			ArrayList list = new294();
			push(goTo(22), list);
		    }
		    break;
                    case 295: /* reduce AAeventwhere2EventWhere */
		    {
			ArrayList list = new295();
			push(goTo(22), list);
		    }
		    break;
                    case 296: /* reduce AEventWhereTail */
		    {
			ArrayList list = new296();
			push(goTo(23), list);
		    }
		    break;
                    case 297: /* reduce AAguard1Guard */
		    {
			ArrayList list = new297();
			push(goTo(24), list);
		    }
		    break;
                    case 298: /* reduce AAguard2Guard */
		    {
			ArrayList list = new298();
			push(goTo(24), list);
		    }
		    break;
                    case 299: /* reduce AAderivedguard1Guard */
		    {
			ArrayList list = new299();
			push(goTo(24), list);
		    }
		    break;
                    case 300: /* reduce AAderivedguard2Guard */
		    {
			ArrayList list = new300();
			push(goTo(24), list);
		    }
		    break;
                    case 301: /* reduce AAeventwith1EventWith */
		    {
			ArrayList list = new301();
			push(goTo(25), list);
		    }
		    break;
                    case 302: /* reduce AAeventwith2EventWith */
		    {
			ArrayList list = new302();
			push(goTo(25), list);
		    }
		    break;
                    case 303: /* reduce AEventWithTail */
		    {
			ArrayList list = new303();
			push(goTo(26), list);
		    }
		    break;
                    case 304: /* reduce AAwitness1Witness */
		    {
			ArrayList list = new304();
			push(goTo(27), list);
		    }
		    break;
                    case 305: /* reduce AAwitness2Witness */
		    {
			ArrayList list = new305();
			push(goTo(27), list);
		    }
		    break;
                    case 306: /* reduce AAeventthen1EventThen */
		    {
			ArrayList list = new306();
			push(goTo(28), list);
		    }
		    break;
                    case 307: /* reduce AAeventthen2EventThen */
		    {
			ArrayList list = new307();
			push(goTo(28), list);
		    }
		    break;
                    case 308: /* reduce AEventThenTail */
		    {
			ArrayList list = new308();
			push(goTo(29), list);
		    }
		    break;
                    case 309: /* reduce AAaction1Action */
		    {
			ArrayList list = new309();
			push(goTo(30), list);
		    }
		    break;
                    case 310: /* reduce AAaction2Action */
		    {
			ArrayList list = new310();
			push(goTo(30), list);
		    }
		    break;
                    case 311: /* reduce AAcontext1Context */
		    {
			ArrayList list = new311();
			push(goTo(31), list);
		    }
		    break;
                    case 312: /* reduce AAcontext2Context */
		    {
			ArrayList list = new312();
			push(goTo(31), list);
		    }
		    break;
                    case 313: /* reduce AAcontext3Context */
		    {
			ArrayList list = new313();
			push(goTo(31), list);
		    }
		    break;
                    case 314: /* reduce AAcontext4Context */
		    {
			ArrayList list = new314();
			push(goTo(31), list);
		    }
		    break;
                    case 315: /* reduce AAcontext5Context */
		    {
			ArrayList list = new315();
			push(goTo(31), list);
		    }
		    break;
                    case 316: /* reduce AAcontext6Context */
		    {
			ArrayList list = new316();
			push(goTo(31), list);
		    }
		    break;
                    case 317: /* reduce AAcontext7Context */
		    {
			ArrayList list = new317();
			push(goTo(31), list);
		    }
		    break;
                    case 318: /* reduce AAcontext8Context */
		    {
			ArrayList list = new318();
			push(goTo(31), list);
		    }
		    break;
                    case 319: /* reduce AAcontext9Context */
		    {
			ArrayList list = new319();
			push(goTo(31), list);
		    }
		    break;
                    case 320: /* reduce AAcontext10Context */
		    {
			ArrayList list = new320();
			push(goTo(31), list);
		    }
		    break;
                    case 321: /* reduce AAcontext11Context */
		    {
			ArrayList list = new321();
			push(goTo(31), list);
		    }
		    break;
                    case 322: /* reduce AAcontext12Context */
		    {
			ArrayList list = new322();
			push(goTo(31), list);
		    }
		    break;
                    case 323: /* reduce AAcontext13Context */
		    {
			ArrayList list = new323();
			push(goTo(31), list);
		    }
		    break;
                    case 324: /* reduce AAcontext14Context */
		    {
			ArrayList list = new324();
			push(goTo(31), list);
		    }
		    break;
                    case 325: /* reduce AAcontext15Context */
		    {
			ArrayList list = new325();
			push(goTo(31), list);
		    }
		    break;
                    case 326: /* reduce AAcontext16Context */
		    {
			ArrayList list = new326();
			push(goTo(31), list);
		    }
		    break;
                    case 327: /* reduce AAcontext17Context */
		    {
			ArrayList list = new327();
			push(goTo(31), list);
		    }
		    break;
                    case 328: /* reduce AAcontext18Context */
		    {
			ArrayList list = new328();
			push(goTo(31), list);
		    }
		    break;
                    case 329: /* reduce AAcontext19Context */
		    {
			ArrayList list = new329();
			push(goTo(31), list);
		    }
		    break;
                    case 330: /* reduce AAcontext20Context */
		    {
			ArrayList list = new330();
			push(goTo(31), list);
		    }
		    break;
                    case 331: /* reduce AAcontext21Context */
		    {
			ArrayList list = new331();
			push(goTo(31), list);
		    }
		    break;
                    case 332: /* reduce AAcontext22Context */
		    {
			ArrayList list = new332();
			push(goTo(31), list);
		    }
		    break;
                    case 333: /* reduce AAcontext23Context */
		    {
			ArrayList list = new333();
			push(goTo(31), list);
		    }
		    break;
                    case 334: /* reduce AAcontext24Context */
		    {
			ArrayList list = new334();
			push(goTo(31), list);
		    }
		    break;
                    case 335: /* reduce AAcontext25Context */
		    {
			ArrayList list = new335();
			push(goTo(31), list);
		    }
		    break;
                    case 336: /* reduce AAcontext26Context */
		    {
			ArrayList list = new336();
			push(goTo(31), list);
		    }
		    break;
                    case 337: /* reduce AAcontext27Context */
		    {
			ArrayList list = new337();
			push(goTo(31), list);
		    }
		    break;
                    case 338: /* reduce AAcontext28Context */
		    {
			ArrayList list = new338();
			push(goTo(31), list);
		    }
		    break;
                    case 339: /* reduce AAcontext29Context */
		    {
			ArrayList list = new339();
			push(goTo(31), list);
		    }
		    break;
                    case 340: /* reduce AAcontext30Context */
		    {
			ArrayList list = new340();
			push(goTo(31), list);
		    }
		    break;
                    case 341: /* reduce AAcontext31Context */
		    {
			ArrayList list = new341();
			push(goTo(31), list);
		    }
		    break;
                    case 342: /* reduce AAcontext32Context */
		    {
			ArrayList list = new342();
			push(goTo(31), list);
		    }
		    break;
                    case 343: /* reduce AAextendsclause1ExtendsClause */
		    {
			ArrayList list = new343();
			push(goTo(32), list);
		    }
		    break;
                    case 344: /* reduce AAextendsclause2ExtendsClause */
		    {
			ArrayList list = new344();
			push(goTo(32), list);
		    }
		    break;
                    case 345: /* reduce AExtendsClauseTail */
		    {
			ArrayList list = new345();
			push(goTo(33), list);
		    }
		    break;
                    case 346: /* reduce AAsetsclause1SetsClause */
		    {
			ArrayList list = new346();
			push(goTo(34), list);
		    }
		    break;
                    case 347: /* reduce AAsetsclause2SetsClause */
		    {
			ArrayList list = new347();
			push(goTo(34), list);
		    }
		    break;
                    case 348: /* reduce ASetsClauseTail */
		    {
			ArrayList list = new348();
			push(goTo(35), list);
		    }
		    break;
                    case 349: /* reduce AAset1Set */
		    {
			ArrayList list = new349();
			push(goTo(36), list);
		    }
		    break;
                    case 350: /* reduce AAset2Set */
		    {
			ArrayList list = new350();
			push(goTo(36), list);
		    }
		    break;
                    case 351: /* reduce AAconstantsclause1ConstantsClause */
		    {
			ArrayList list = new351();
			push(goTo(37), list);
		    }
		    break;
                    case 352: /* reduce AAconstantsclause2ConstantsClause */
		    {
			ArrayList list = new352();
			push(goTo(37), list);
		    }
		    break;
                    case 353: /* reduce AConstantsClauseTail */
		    {
			ArrayList list = new353();
			push(goTo(38), list);
		    }
		    break;
                    case 354: /* reduce AAconstant1Constant */
		    {
			ArrayList list = new354();
			push(goTo(39), list);
		    }
		    break;
                    case 355: /* reduce AAconstant2Constant */
		    {
			ArrayList list = new355();
			push(goTo(39), list);
		    }
		    break;
                    case 356: /* reduce AAaxiomsclause1AxiomsClause */
		    {
			ArrayList list = new356();
			push(goTo(40), list);
		    }
		    break;
                    case 357: /* reduce AAaxiomsclause2AxiomsClause */
		    {
			ArrayList list = new357();
			push(goTo(40), list);
		    }
		    break;
                    case 358: /* reduce AAxiomsClauseTail */
		    {
			ArrayList list = new358();
			push(goTo(41), list);
		    }
		    break;
                    case 359: /* reduce AAaxiom1Axiom */
		    {
			ArrayList list = new359();
			push(goTo(42), list);
		    }
		    break;
                    case 360: /* reduce AAaxiom2Axiom */
		    {
			ArrayList list = new360();
			push(goTo(42), list);
		    }
		    break;
                    case 361: /* reduce AAderivedaxiom1Axiom */
		    {
			ArrayList list = new361();
			push(goTo(42), list);
		    }
		    break;
                    case 362: /* reduce AAderivedaxiom2Axiom */
		    {
			ArrayList list = new362();
			push(goTo(42), list);
		    }
		    break;
                    case 363: /* reduce ALabel */
		    {
			ArrayList list = new363();
			push(goTo(43), list);
		    }
		    break;
                    case 364: /* reduce ATerminal$Comment */
		    {
			ArrayList list = new364();
			push(goTo(44), list);
		    }
		    break;
                    case 365: /* reduce ANonTerminal$Comment */
		    {
			ArrayList list = new365();
			push(goTo(44), list);
		    }
		    break;
                    case 366: /* reduce ATerminal$RefinesClauseTail */
		    {
			ArrayList list = new366();
			push(goTo(45), list);
		    }
		    break;
                    case 367: /* reduce ANonTerminal$RefinesClauseTail */
		    {
			ArrayList list = new367();
			push(goTo(45), list);
		    }
		    break;
                    case 368: /* reduce ATerminal$SeesClauseTail */
		    {
			ArrayList list = new368();
			push(goTo(46), list);
		    }
		    break;
                    case 369: /* reduce ANonTerminal$SeesClauseTail */
		    {
			ArrayList list = new369();
			push(goTo(46), list);
		    }
		    break;
                    case 370: /* reduce ATerminal$InvariantsTail */
		    {
			ArrayList list = new370();
			push(goTo(47), list);
		    }
		    break;
                    case 371: /* reduce ANonTerminal$InvariantsTail */
		    {
			ArrayList list = new371();
			push(goTo(47), list);
		    }
		    break;
                    case 372: /* reduce ATerminal$EventsTail */
		    {
			ArrayList list = new372();
			push(goTo(48), list);
		    }
		    break;
                    case 373: /* reduce ANonTerminal$EventsTail */
		    {
			ArrayList list = new373();
			push(goTo(48), list);
		    }
		    break;
                    case 374: /* reduce ATerminal$EventRefinesTail */
		    {
			ArrayList list = new374();
			push(goTo(49), list);
		    }
		    break;
                    case 375: /* reduce ANonTerminal$EventRefinesTail */
		    {
			ArrayList list = new375();
			push(goTo(49), list);
		    }
		    break;
                    case 376: /* reduce ATerminal$EventAnyTail */
		    {
			ArrayList list = new376();
			push(goTo(50), list);
		    }
		    break;
                    case 377: /* reduce ANonTerminal$EventAnyTail */
		    {
			ArrayList list = new377();
			push(goTo(50), list);
		    }
		    break;
                    case 378: /* reduce ATerminal$EventWhereTail */
		    {
			ArrayList list = new378();
			push(goTo(51), list);
		    }
		    break;
                    case 379: /* reduce ANonTerminal$EventWhereTail */
		    {
			ArrayList list = new379();
			push(goTo(51), list);
		    }
		    break;
                    case 380: /* reduce ATerminal$EventWithTail */
		    {
			ArrayList list = new380();
			push(goTo(52), list);
		    }
		    break;
                    case 381: /* reduce ANonTerminal$EventWithTail */
		    {
			ArrayList list = new381();
			push(goTo(52), list);
		    }
		    break;
                    case 382: /* reduce ATerminal$EventThenTail */
		    {
			ArrayList list = new382();
			push(goTo(53), list);
		    }
		    break;
                    case 383: /* reduce ANonTerminal$EventThenTail */
		    {
			ArrayList list = new383();
			push(goTo(53), list);
		    }
		    break;
                    case 384: /* reduce ATerminal$ExtendsClauseTail */
		    {
			ArrayList list = new384();
			push(goTo(54), list);
		    }
		    break;
                    case 385: /* reduce ANonTerminal$ExtendsClauseTail */
		    {
			ArrayList list = new385();
			push(goTo(54), list);
		    }
		    break;
                    case 386: /* reduce ATerminal$SetsClauseTail */
		    {
			ArrayList list = new386();
			push(goTo(55), list);
		    }
		    break;
                    case 387: /* reduce ANonTerminal$SetsClauseTail */
		    {
			ArrayList list = new387();
			push(goTo(55), list);
		    }
		    break;
                    case 388: /* reduce ATerminal$ConstantsClauseTail */
		    {
			ArrayList list = new388();
			push(goTo(56), list);
		    }
		    break;
                    case 389: /* reduce ANonTerminal$ConstantsClauseTail */
		    {
			ArrayList list = new389();
			push(goTo(56), list);
		    }
		    break;
                    case 390: /* reduce ATerminal$AxiomsClauseTail */
		    {
			ArrayList list = new390();
			push(goTo(57), list);
		    }
		    break;
                    case 391: /* reduce ANonTerminal$AxiomsClauseTail */
		    {
			ArrayList list = new391();
			push(goTo(57), list);
		    }
		    break;
                    }
                    break;
                case ACCEPT:
                    {
                        EOF node2 = (EOF) this.lexer.next();
                        PParseUnit node1 = (PParseUnit) pop().get(0);
                        Start node = new Start(node1, node2);
                        return node;
                    }
                case ERROR:
                    throw new ParserException(this.last_token,
                        "[" + this.last_line + "," + this.last_pos + "] " ,
                        Parser.errorMessages[Parser.errors[this.action[1]]]);
            }
        }
    }



     
    ArrayList new0() /* reduce AMachineParseUnit */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        pparseunitNode1 = (PParseUnit)nodeArrayList1.get(0);
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new1() /* reduce AContextParseUnit */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        pparseunitNode1 = (PParseUnit)nodeArrayList1.get(0);
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new2() /* reduce AAmachine1Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
          Object nullNode8 = null;
        LinkedList listNode9 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode5, listNode6, listNode7, null, listNode9);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new3() /* reduce AAmachine2Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
          Object nullNode9 = null;
        LinkedList listNode10 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode6, listNode7, listNode8, null, listNode10);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new4() /* reduce AAmachine3Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
          Object nullNode9 = null;
        LinkedList listNode10 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode6, listNode7, listNode8, null, listNode10);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new5() /* reduce AAmachine4Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
          Object nullNode10 = null;
        LinkedList listNode11 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode7, listNode8, listNode9, null, listNode11);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new6() /* reduce AAmachine5Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
          Object nullNode9 = null;
        LinkedList listNode10 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList3.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode6, listNode7, listNode8, null, listNode10);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new7() /* reduce AAmachine6Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
          Object nullNode10 = null;
        LinkedList listNode11 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode7, listNode8, listNode9, null, listNode11);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new8() /* reduce AAmachine7Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
          Object nullNode10 = null;
        LinkedList listNode11 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode7, listNode8, listNode9, null, listNode11);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new9() /* reduce AAmachine8Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
          Object nullNode11 = null;
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode8, listNode9, listNode10, null, listNode12);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new10() /* reduce AAmachine9Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
          Object nullNode9 = null;
        LinkedList listNode10 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList3.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode5, listNode7, listNode8, null, listNode10);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new11() /* reduce AAmachine10Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
          Object nullNode10 = null;
        LinkedList listNode11 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode6, listNode8, listNode9, null, listNode11);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new12() /* reduce AAmachine11Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
          Object nullNode10 = null;
        LinkedList listNode11 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode6, listNode8, listNode9, null, listNode11);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new13() /* reduce AAmachine12Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
          Object nullNode11 = null;
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode7, listNode9, listNode10, null, listNode12);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new14() /* reduce AAmachine13Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
          Object nullNode10 = null;
        LinkedList listNode11 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList3.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode6, listNode8, listNode9, null, listNode11);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new15() /* reduce AAmachine14Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
          Object nullNode11 = null;
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode7, listNode9, listNode10, null, listNode12);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new16() /* reduce AAmachine15Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
          Object nullNode11 = null;
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode7, listNode9, listNode10, null, listNode12);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new17() /* reduce AAmachine16Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
          Object nullNode12 = null;
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList6.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode8, listNode10, listNode11, null, listNode13);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new18() /* reduce AAmachine17Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
          Object nullNode9 = null;
        LinkedList listNode10 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList3.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode5, listNode6, listNode8, null, listNode10);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new19() /* reduce AAmachine18Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
          Object nullNode10 = null;
        LinkedList listNode11 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList4.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode6, listNode7, listNode9, null, listNode11);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new20() /* reduce AAmachine19Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
          Object nullNode10 = null;
        LinkedList listNode11 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList4.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode6, listNode7, listNode9, null, listNode11);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new21() /* reduce AAmachine20Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
          Object nullNode11 = null;
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode7, listNode8, listNode10, null, listNode12);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new22() /* reduce AAmachine21Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
          Object nullNode10 = null;
        LinkedList listNode11 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList3.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList4.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode6, listNode7, listNode9, null, listNode11);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new23() /* reduce AAmachine22Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
          Object nullNode11 = null;
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode7, listNode8, listNode10, null, listNode12);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new24() /* reduce AAmachine23Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
          Object nullNode11 = null;
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode7, listNode8, listNode10, null, listNode12);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new25() /* reduce AAmachine24Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
          Object nullNode12 = null;
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode8, listNode9, listNode11, null, listNode13);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new26() /* reduce AAmachine25Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
          Object nullNode10 = null;
        LinkedList listNode11 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList3.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList4.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode5, listNode7, listNode9, null, listNode11);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new27() /* reduce AAmachine26Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
          Object nullNode11 = null;
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode6, listNode8, listNode10, null, listNode12);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new28() /* reduce AAmachine27Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
          Object nullNode11 = null;
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode6, listNode8, listNode10, null, listNode12);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new29() /* reduce AAmachine28Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
          Object nullNode12 = null;
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode7, listNode9, listNode11, null, listNode13);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new30() /* reduce AAmachine29Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
          Object nullNode11 = null;
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList3.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode6, listNode8, listNode10, null, listNode12);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new31() /* reduce AAmachine30Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
          Object nullNode12 = null;
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode7, listNode9, listNode11, null, listNode13);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new32() /* reduce AAmachine31Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
          Object nullNode12 = null;
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode7, listNode9, listNode11, null, listNode13);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new33() /* reduce AAmachine32Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
          Object nullNode13 = null;
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList6.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList7.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode8, listNode10, listNode12, null, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new34() /* reduce AAmachine33Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        PVariant pvariantNode8;
        LinkedList listNode9 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        pvariantNode8 = (PVariant)nodeArrayList3.get(0);
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode5, listNode6, listNode7, pvariantNode8, listNode9);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new35() /* reduce AAmachine34Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        PVariant pvariantNode9;
        LinkedList listNode10 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        pvariantNode9 = (PVariant)nodeArrayList4.get(0);
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode6, listNode7, listNode8, pvariantNode9, listNode10);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new36() /* reduce AAmachine35Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        PVariant pvariantNode9;
        LinkedList listNode10 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        pvariantNode9 = (PVariant)nodeArrayList4.get(0);
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode6, listNode7, listNode8, pvariantNode9, listNode10);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new37() /* reduce AAmachine36Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        PVariant pvariantNode10;
        LinkedList listNode11 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        pvariantNode10 = (PVariant)nodeArrayList5.get(0);
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode7, listNode8, listNode9, pvariantNode10, listNode11);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new38() /* reduce AAmachine37Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        PVariant pvariantNode9;
        LinkedList listNode10 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList3.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        pvariantNode9 = (PVariant)nodeArrayList4.get(0);
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode6, listNode7, listNode8, pvariantNode9, listNode10);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new39() /* reduce AAmachine38Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        PVariant pvariantNode10;
        LinkedList listNode11 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        pvariantNode10 = (PVariant)nodeArrayList5.get(0);
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode7, listNode8, listNode9, pvariantNode10, listNode11);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new40() /* reduce AAmachine39Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        PVariant pvariantNode10;
        LinkedList listNode11 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        pvariantNode10 = (PVariant)nodeArrayList5.get(0);
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode7, listNode8, listNode9, pvariantNode10, listNode11);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new41() /* reduce AAmachine40Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        PVariant pvariantNode11;
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        pvariantNode11 = (PVariant)nodeArrayList6.get(0);
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode8, listNode9, listNode10, pvariantNode11, listNode12);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new42() /* reduce AAmachine41Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        PVariant pvariantNode9;
        LinkedList listNode10 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList3.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        pvariantNode9 = (PVariant)nodeArrayList4.get(0);
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode5, listNode7, listNode8, pvariantNode9, listNode10);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new43() /* reduce AAmachine42Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        PVariant pvariantNode10;
        LinkedList listNode11 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        pvariantNode10 = (PVariant)nodeArrayList5.get(0);
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode6, listNode8, listNode9, pvariantNode10, listNode11);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new44() /* reduce AAmachine43Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        PVariant pvariantNode10;
        LinkedList listNode11 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        pvariantNode10 = (PVariant)nodeArrayList5.get(0);
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode6, listNode8, listNode9, pvariantNode10, listNode11);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new45() /* reduce AAmachine44Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        PVariant pvariantNode11;
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        pvariantNode11 = (PVariant)nodeArrayList6.get(0);
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode7, listNode9, listNode10, pvariantNode11, listNode12);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new46() /* reduce AAmachine45Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        PVariant pvariantNode10;
        LinkedList listNode11 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList3.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        pvariantNode10 = (PVariant)nodeArrayList5.get(0);
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode6, listNode8, listNode9, pvariantNode10, listNode11);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new47() /* reduce AAmachine46Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        PVariant pvariantNode11;
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        pvariantNode11 = (PVariant)nodeArrayList6.get(0);
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode7, listNode9, listNode10, pvariantNode11, listNode12);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new48() /* reduce AAmachine47Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        PVariant pvariantNode11;
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        pvariantNode11 = (PVariant)nodeArrayList6.get(0);
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode7, listNode9, listNode10, pvariantNode11, listNode12);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new49() /* reduce AAmachine48Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        PVariant pvariantNode12;
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList6.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }
        pvariantNode12 = (PVariant)nodeArrayList7.get(0);
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode8, listNode10, listNode11, pvariantNode12, listNode13);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new50() /* reduce AAmachine49Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        PVariant pvariantNode9;
        LinkedList listNode10 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList3.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        pvariantNode9 = (PVariant)nodeArrayList4.get(0);
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode5, listNode6, listNode8, pvariantNode9, listNode10);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new51() /* reduce AAmachine50Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        PVariant pvariantNode10;
        LinkedList listNode11 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList4.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        pvariantNode10 = (PVariant)nodeArrayList5.get(0);
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode6, listNode7, listNode9, pvariantNode10, listNode11);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new52() /* reduce AAmachine51Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        PVariant pvariantNode10;
        LinkedList listNode11 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList4.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        pvariantNode10 = (PVariant)nodeArrayList5.get(0);
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode6, listNode7, listNode9, pvariantNode10, listNode11);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new53() /* reduce AAmachine52Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        PVariant pvariantNode11;
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        pvariantNode11 = (PVariant)nodeArrayList6.get(0);
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode7, listNode8, listNode10, pvariantNode11, listNode12);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new54() /* reduce AAmachine53Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        PVariant pvariantNode10;
        LinkedList listNode11 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList3.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList4.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        pvariantNode10 = (PVariant)nodeArrayList5.get(0);
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode6, listNode7, listNode9, pvariantNode10, listNode11);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new55() /* reduce AAmachine54Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        PVariant pvariantNode11;
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        pvariantNode11 = (PVariant)nodeArrayList6.get(0);
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode7, listNode8, listNode10, pvariantNode11, listNode12);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new56() /* reduce AAmachine55Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        PVariant pvariantNode11;
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        pvariantNode11 = (PVariant)nodeArrayList6.get(0);
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode7, listNode8, listNode10, pvariantNode11, listNode12);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new57() /* reduce AAmachine56Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        PVariant pvariantNode12;
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        pvariantNode12 = (PVariant)nodeArrayList7.get(0);
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode8, listNode9, listNode11, pvariantNode12, listNode13);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new58() /* reduce AAmachine57Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        PVariant pvariantNode10;
        LinkedList listNode11 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList3.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList4.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        pvariantNode10 = (PVariant)nodeArrayList5.get(0);
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode5, listNode7, listNode9, pvariantNode10, listNode11);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new59() /* reduce AAmachine58Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        PVariant pvariantNode11;
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        pvariantNode11 = (PVariant)nodeArrayList6.get(0);
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode6, listNode8, listNode10, pvariantNode11, listNode12);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new60() /* reduce AAmachine59Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        PVariant pvariantNode11;
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        pvariantNode11 = (PVariant)nodeArrayList6.get(0);
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode6, listNode8, listNode10, pvariantNode11, listNode12);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new61() /* reduce AAmachine60Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        PVariant pvariantNode12;
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        pvariantNode12 = (PVariant)nodeArrayList7.get(0);
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode7, listNode9, listNode11, pvariantNode12, listNode13);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new62() /* reduce AAmachine61Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        PVariant pvariantNode11;
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList3.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        pvariantNode11 = (PVariant)nodeArrayList6.get(0);
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode6, listNode8, listNode10, pvariantNode11, listNode12);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new63() /* reduce AAmachine62Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        PVariant pvariantNode12;
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        pvariantNode12 = (PVariant)nodeArrayList7.get(0);
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode7, listNode9, listNode11, pvariantNode12, listNode13);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new64() /* reduce AAmachine63Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        PVariant pvariantNode12;
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        pvariantNode12 = (PVariant)nodeArrayList7.get(0);
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode7, listNode9, listNode11, pvariantNode12, listNode13);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new65() /* reduce AAmachine64Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        PVariant pvariantNode13;
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList6.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList7.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        pvariantNode13 = (PVariant)nodeArrayList8.get(0);
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode8, listNode10, listNode12, pvariantNode13, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new66() /* reduce AAmachine65Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
          Object nullNode8 = null;
        LinkedList listNode10 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList3.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode5, listNode6, listNode7, null, listNode10);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new67() /* reduce AAmachine66Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
          Object nullNode9 = null;
        LinkedList listNode11 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList4.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode6, listNode7, listNode8, null, listNode11);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new68() /* reduce AAmachine67Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
          Object nullNode9 = null;
        LinkedList listNode11 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList4.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode6, listNode7, listNode8, null, listNode11);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new69() /* reduce AAmachine68Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
          Object nullNode10 = null;
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList5.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode7, listNode8, listNode9, null, listNode12);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new70() /* reduce AAmachine69Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
          Object nullNode9 = null;
        LinkedList listNode11 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList3.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList4.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode6, listNode7, listNode8, null, listNode11);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new71() /* reduce AAmachine70Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
          Object nullNode10 = null;
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList5.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode7, listNode8, listNode9, null, listNode12);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new72() /* reduce AAmachine71Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
          Object nullNode10 = null;
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList5.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode7, listNode8, listNode9, null, listNode12);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new73() /* reduce AAmachine72Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
          Object nullNode11 = null;
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList6.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode8, listNode9, listNode10, null, listNode13);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new74() /* reduce AAmachine73Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
          Object nullNode9 = null;
        LinkedList listNode11 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList3.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList4.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode5, listNode7, listNode8, null, listNode11);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new75() /* reduce AAmachine74Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
          Object nullNode10 = null;
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList5.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode6, listNode8, listNode9, null, listNode12);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new76() /* reduce AAmachine75Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
          Object nullNode10 = null;
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList5.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode6, listNode8, listNode9, null, listNode12);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new77() /* reduce AAmachine76Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
          Object nullNode11 = null;
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList6.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode7, listNode9, listNode10, null, listNode13);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new78() /* reduce AAmachine77Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
          Object nullNode10 = null;
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList3.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList5.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode6, listNode8, listNode9, null, listNode12);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new79() /* reduce AAmachine78Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
          Object nullNode11 = null;
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList6.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode7, listNode9, listNode10, null, listNode13);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new80() /* reduce AAmachine79Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
          Object nullNode11 = null;
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList6.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode7, listNode9, listNode10, null, listNode13);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new81() /* reduce AAmachine80Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
          Object nullNode12 = null;
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList6.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode13 = new LinkedList();
        listNode13 = (LinkedList)nodeArrayList7.get(0);
	if(listNode13 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode14.addAll(listNode13);
  	  //listNode14 = listNode13;
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode8, listNode10, listNode11, null, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new82() /* reduce AAmachine81Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
          Object nullNode9 = null;
        LinkedList listNode11 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList3.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList4.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode5, listNode6, listNode8, null, listNode11);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new83() /* reduce AAmachine82Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
          Object nullNode10 = null;
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList4.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList5.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode6, listNode7, listNode9, null, listNode12);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new84() /* reduce AAmachine83Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
          Object nullNode10 = null;
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList4.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList5.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode6, listNode7, listNode9, null, listNode12);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new85() /* reduce AAmachine84Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
          Object nullNode11 = null;
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList6.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode7, listNode8, listNode10, null, listNode13);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new86() /* reduce AAmachine85Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
          Object nullNode10 = null;
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList3.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList4.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList5.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode6, listNode7, listNode9, null, listNode12);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new87() /* reduce AAmachine86Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
          Object nullNode11 = null;
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList6.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode7, listNode8, listNode10, null, listNode13);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new88() /* reduce AAmachine87Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
          Object nullNode11 = null;
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList6.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode7, listNode8, listNode10, null, listNode13);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new89() /* reduce AAmachine88Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
          Object nullNode12 = null;
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        LinkedList listNode13 = new LinkedList();
        listNode13 = (LinkedList)nodeArrayList7.get(0);
	if(listNode13 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode14.addAll(listNode13);
  	  //listNode14 = listNode13;
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode8, listNode9, listNode11, null, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new90() /* reduce AAmachine89Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
          Object nullNode10 = null;
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList3.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList4.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList5.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode5, listNode7, listNode9, null, listNode12);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new91() /* reduce AAmachine90Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
          Object nullNode11 = null;
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList6.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode6, listNode8, listNode10, null, listNode13);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new92() /* reduce AAmachine91Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
          Object nullNode11 = null;
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList6.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode6, listNode8, listNode10, null, listNode13);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new93() /* reduce AAmachine92Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
          Object nullNode12 = null;
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        LinkedList listNode13 = new LinkedList();
        listNode13 = (LinkedList)nodeArrayList7.get(0);
	if(listNode13 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode14.addAll(listNode13);
  	  //listNode14 = listNode13;
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode7, listNode9, listNode11, null, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new94() /* reduce AAmachine93Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
          Object nullNode11 = null;
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList3.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList6.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode6, listNode8, listNode10, null, listNode13);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new95() /* reduce AAmachine94Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
          Object nullNode12 = null;
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        LinkedList listNode13 = new LinkedList();
        listNode13 = (LinkedList)nodeArrayList7.get(0);
	if(listNode13 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode14.addAll(listNode13);
  	  //listNode14 = listNode13;
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode7, listNode9, listNode11, null, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new96() /* reduce AAmachine95Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
          Object nullNode12 = null;
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        LinkedList listNode13 = new LinkedList();
        listNode13 = (LinkedList)nodeArrayList7.get(0);
	if(listNode13 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode14.addAll(listNode13);
  	  //listNode14 = listNode13;
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode7, listNode9, listNode11, null, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new97() /* reduce AAmachine96Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
          Object nullNode13 = null;
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList6.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList7.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        {
            // Block
        LinkedList listNode14 = new LinkedList();
        listNode14 = (LinkedList)nodeArrayList8.get(0);
	if(listNode14 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode15.addAll(listNode14);
  	  //listNode15 = listNode14;
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode8, listNode10, listNode12, null, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new98() /* reduce AAmachine97Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        PVariant pvariantNode8;
        LinkedList listNode10 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        pvariantNode8 = (PVariant)nodeArrayList3.get(0);
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList4.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode5, listNode6, listNode7, pvariantNode8, listNode10);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new99() /* reduce AAmachine98Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        PVariant pvariantNode9;
        LinkedList listNode11 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        pvariantNode9 = (PVariant)nodeArrayList4.get(0);
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList5.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode6, listNode7, listNode8, pvariantNode9, listNode11);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new100() /* reduce AAmachine99Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        PVariant pvariantNode9;
        LinkedList listNode11 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        pvariantNode9 = (PVariant)nodeArrayList4.get(0);
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList5.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode6, listNode7, listNode8, pvariantNode9, listNode11);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new101() /* reduce AAmachine100Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        PVariant pvariantNode10;
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        pvariantNode10 = (PVariant)nodeArrayList5.get(0);
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList6.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode7, listNode8, listNode9, pvariantNode10, listNode12);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new102() /* reduce AAmachine101Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        PVariant pvariantNode9;
        LinkedList listNode11 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList3.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        pvariantNode9 = (PVariant)nodeArrayList4.get(0);
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList5.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode6, listNode7, listNode8, pvariantNode9, listNode11);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new103() /* reduce AAmachine102Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        PVariant pvariantNode10;
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        pvariantNode10 = (PVariant)nodeArrayList5.get(0);
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList6.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode7, listNode8, listNode9, pvariantNode10, listNode12);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new104() /* reduce AAmachine103Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        PVariant pvariantNode10;
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        pvariantNode10 = (PVariant)nodeArrayList5.get(0);
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList6.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode7, listNode8, listNode9, pvariantNode10, listNode12);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new105() /* reduce AAmachine104Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        PVariant pvariantNode11;
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        pvariantNode11 = (PVariant)nodeArrayList6.get(0);
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList7.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode8, listNode9, listNode10, pvariantNode11, listNode13);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new106() /* reduce AAmachine105Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        PVariant pvariantNode9;
        LinkedList listNode11 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList3.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        pvariantNode9 = (PVariant)nodeArrayList4.get(0);
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList5.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode5, listNode7, listNode8, pvariantNode9, listNode11);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new107() /* reduce AAmachine106Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        PVariant pvariantNode10;
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        pvariantNode10 = (PVariant)nodeArrayList5.get(0);
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList6.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode6, listNode8, listNode9, pvariantNode10, listNode12);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new108() /* reduce AAmachine107Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        PVariant pvariantNode10;
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        pvariantNode10 = (PVariant)nodeArrayList5.get(0);
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList6.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode6, listNode8, listNode9, pvariantNode10, listNode12);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new109() /* reduce AAmachine108Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        PVariant pvariantNode11;
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        pvariantNode11 = (PVariant)nodeArrayList6.get(0);
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList7.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode7, listNode9, listNode10, pvariantNode11, listNode13);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new110() /* reduce AAmachine109Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        PVariant pvariantNode10;
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList3.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        pvariantNode10 = (PVariant)nodeArrayList5.get(0);
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList6.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode6, listNode8, listNode9, pvariantNode10, listNode12);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new111() /* reduce AAmachine110Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        PVariant pvariantNode11;
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        pvariantNode11 = (PVariant)nodeArrayList6.get(0);
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList7.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode7, listNode9, listNode10, pvariantNode11, listNode13);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new112() /* reduce AAmachine111Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        PVariant pvariantNode11;
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        pvariantNode11 = (PVariant)nodeArrayList6.get(0);
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList7.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode7, listNode9, listNode10, pvariantNode11, listNode13);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new113() /* reduce AAmachine112Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        PVariant pvariantNode12;
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList6.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }
        pvariantNode12 = (PVariant)nodeArrayList7.get(0);
        {
            // Block
        LinkedList listNode13 = new LinkedList();
        listNode13 = (LinkedList)nodeArrayList8.get(0);
	if(listNode13 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode14.addAll(listNode13);
  	  //listNode14 = listNode13;
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode8, listNode10, listNode11, pvariantNode12, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new114() /* reduce AAmachine113Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        PVariant pvariantNode9;
        LinkedList listNode11 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList3.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        pvariantNode9 = (PVariant)nodeArrayList4.get(0);
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList5.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode5, listNode6, listNode8, pvariantNode9, listNode11);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new115() /* reduce AAmachine114Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        PVariant pvariantNode10;
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList4.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        pvariantNode10 = (PVariant)nodeArrayList5.get(0);
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList6.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode6, listNode7, listNode9, pvariantNode10, listNode12);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new116() /* reduce AAmachine115Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        PVariant pvariantNode10;
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList4.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        pvariantNode10 = (PVariant)nodeArrayList5.get(0);
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList6.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode6, listNode7, listNode9, pvariantNode10, listNode12);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new117() /* reduce AAmachine116Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        PVariant pvariantNode11;
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        pvariantNode11 = (PVariant)nodeArrayList6.get(0);
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList7.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode7, listNode8, listNode10, pvariantNode11, listNode13);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new118() /* reduce AAmachine117Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        PVariant pvariantNode10;
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList3.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList4.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        pvariantNode10 = (PVariant)nodeArrayList5.get(0);
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList6.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode6, listNode7, listNode9, pvariantNode10, listNode12);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new119() /* reduce AAmachine118Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        PVariant pvariantNode11;
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        pvariantNode11 = (PVariant)nodeArrayList6.get(0);
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList7.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode7, listNode8, listNode10, pvariantNode11, listNode13);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new120() /* reduce AAmachine119Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        PVariant pvariantNode11;
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        pvariantNode11 = (PVariant)nodeArrayList6.get(0);
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList7.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode7, listNode8, listNode10, pvariantNode11, listNode13);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new121() /* reduce AAmachine120Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        PVariant pvariantNode12;
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        pvariantNode12 = (PVariant)nodeArrayList7.get(0);
        {
            // Block
        LinkedList listNode13 = new LinkedList();
        listNode13 = (LinkedList)nodeArrayList8.get(0);
	if(listNode13 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode14.addAll(listNode13);
  	  //listNode14 = listNode13;
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode8, listNode9, listNode11, pvariantNode12, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new122() /* reduce AAmachine121Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        PVariant pvariantNode10;
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList3.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList4.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        pvariantNode10 = (PVariant)nodeArrayList5.get(0);
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList6.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode5, listNode7, listNode9, pvariantNode10, listNode12);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new123() /* reduce AAmachine122Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        PVariant pvariantNode11;
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        pvariantNode11 = (PVariant)nodeArrayList6.get(0);
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList7.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode6, listNode8, listNode10, pvariantNode11, listNode13);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new124() /* reduce AAmachine123Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        PVariant pvariantNode11;
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        pvariantNode11 = (PVariant)nodeArrayList6.get(0);
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList7.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode6, listNode8, listNode10, pvariantNode11, listNode13);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new125() /* reduce AAmachine124Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        PVariant pvariantNode12;
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        pvariantNode12 = (PVariant)nodeArrayList7.get(0);
        {
            // Block
        LinkedList listNode13 = new LinkedList();
        listNode13 = (LinkedList)nodeArrayList8.get(0);
	if(listNode13 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode14.addAll(listNode13);
  	  //listNode14 = listNode13;
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode7, listNode9, listNode11, pvariantNode12, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new126() /* reduce AAmachine125Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        PVariant pvariantNode11;
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList3.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        pvariantNode11 = (PVariant)nodeArrayList6.get(0);
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList7.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode6, listNode8, listNode10, pvariantNode11, listNode13);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new127() /* reduce AAmachine126Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        PVariant pvariantNode12;
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        pvariantNode12 = (PVariant)nodeArrayList7.get(0);
        {
            // Block
        LinkedList listNode13 = new LinkedList();
        listNode13 = (LinkedList)nodeArrayList8.get(0);
	if(listNode13 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode14.addAll(listNode13);
  	  //listNode14 = listNode13;
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode7, listNode9, listNode11, pvariantNode12, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new128() /* reduce AAmachine127Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        PVariant pvariantNode12;
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        pvariantNode12 = (PVariant)nodeArrayList7.get(0);
        {
            // Block
        LinkedList listNode13 = new LinkedList();
        listNode13 = (LinkedList)nodeArrayList8.get(0);
	if(listNode13 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode14.addAll(listNode13);
  	  //listNode14 = listNode13;
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode7, listNode9, listNode11, pvariantNode12, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new129() /* reduce AAmachine128Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList10 = pop();
          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        PVariant pvariantNode13;
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList6.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList7.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        pvariantNode13 = (PVariant)nodeArrayList8.get(0);
        {
            // Block
        LinkedList listNode14 = new LinkedList();
        listNode14 = (LinkedList)nodeArrayList9.get(0);
	if(listNode14 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode15.addAll(listNode14);
  	  //listNode15 = listNode14;
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode8, listNode10, listNode12, pvariantNode13, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new130() /* reduce AArefinesclause1RefinesClause */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        LinkedList listNode2 = new LinkedList();
        {
            // Block
        TIdentifierLiteral tidentifierliteralNode1;
        tidentifierliteralNode1 = (TIdentifierLiteral)nodeArrayList2.get(0);
	if(tidentifierliteralNode1 != null)
	{
	  listNode2.add(tidentifierliteralNode1);
	}
        }
	nodeList.add(listNode2);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new131() /* reduce AArefinesclause2RefinesClause */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        LinkedList listNode3 = new LinkedList();
        {
            // Block
        TIdentifierLiteral tidentifierliteralNode1;
        LinkedList listNode2 = new LinkedList();
        tidentifierliteralNode1 = (TIdentifierLiteral)nodeArrayList2.get(0);
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(tidentifierliteralNode1 != null)
	{
	  listNode3.add(tidentifierliteralNode1);
	}
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
	nodeList.add(listNode3);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new132() /* reduce ARefinesClauseTail */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList1 = pop();
        TIdentifierLiteral tidentifierliteralNode1;
        tidentifierliteralNode1 = (TIdentifierLiteral)nodeArrayList1.get(0);
	nodeList.add(tidentifierliteralNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new133() /* reduce AAseesclause1SeesClause */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        LinkedList listNode2 = new LinkedList();
        {
            // Block
        TIdentifierLiteral tidentifierliteralNode1;
        tidentifierliteralNode1 = (TIdentifierLiteral)nodeArrayList2.get(0);
	if(tidentifierliteralNode1 != null)
	{
	  listNode2.add(tidentifierliteralNode1);
	}
        }
	nodeList.add(listNode2);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new134() /* reduce AAseesclause2SeesClause */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        LinkedList listNode3 = new LinkedList();
        {
            // Block
        TIdentifierLiteral tidentifierliteralNode1;
        LinkedList listNode2 = new LinkedList();
        tidentifierliteralNode1 = (TIdentifierLiteral)nodeArrayList2.get(0);
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(tidentifierliteralNode1 != null)
	{
	  listNode3.add(tidentifierliteralNode1);
	}
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
	nodeList.add(listNode3);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new135() /* reduce ASeesClauseTail */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList1 = pop();
        TIdentifierLiteral tidentifierliteralNode1;
        tidentifierliteralNode1 = (TIdentifierLiteral)nodeArrayList1.get(0);
	nodeList.add(tidentifierliteralNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new136() /* reduce AVariablesClause */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        LinkedList listNode2 = new LinkedList();
        {
            // Block
        LinkedList listNode1 = new LinkedList();
        listNode1 = (LinkedList)nodeArrayList2.get(0);
	if(listNode1 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode2.addAll(listNode1);
  	  //listNode2 = listNode1;
	}
        }
	nodeList.add(listNode2);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new137() /* reduce AAsinglevariablelist1VariableList */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList1 = pop();
        LinkedList listNode4 = new LinkedList();
        {
            // Block
        PVariable pvariableNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList1.get(0);

        pvariableNode1 = new AVariable(listNode2, tidentifierliteralNode3);
        }
	if(pvariableNode1 != null)
	{
	  listNode4.add(pvariableNode1);
	}
        }
	nodeList.add(listNode4);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new138() /* reduce AAsinglevariablelist2VariableList */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        LinkedList listNode5 = new LinkedList();
        {
            // Block
        PVariable pvariableNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList2.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList1.get(0);

        pvariableNode1 = new AVariable(listNode3, tidentifierliteralNode4);
        }
	if(pvariableNode1 != null)
	{
	  listNode5.add(pvariableNode1);
	}
        }
	nodeList.add(listNode5);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new139() /* reduce AAmultivariablelist1VariableList */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        LinkedList listNode5 = new LinkedList();
        {
            // Block
        LinkedList listNode1 = new LinkedList();
        PVariable pvariableNode2;
        listNode1 = (LinkedList)nodeArrayList1.get(0);
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        {
            // Block
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);

        pvariableNode2 = new AVariable(listNode3, tidentifierliteralNode4);
        }
	if(listNode1 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode1);
  	  //listNode5 = listNode1;
	}
	if(pvariableNode2 != null)
	{
	  listNode5.add(pvariableNode2);
	}
        }
	nodeList.add(listNode5);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new140() /* reduce AAmultivariablelist2VariableList */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        LinkedList listNode6 = new LinkedList();
        {
            // Block
        LinkedList listNode1 = new LinkedList();
        PVariable pvariableNode2;
        listNode1 = (LinkedList)nodeArrayList1.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode5;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        listNode3 = (LinkedList)nodeArrayList3.get(0);
	if(listNode3 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode4.addAll(listNode3);
  	  //listNode4 = listNode3;
	}
        }
        tidentifierliteralNode5 = (TIdentifierLiteral)nodeArrayList2.get(0);

        pvariableNode2 = new AVariable(listNode4, tidentifierliteralNode5);
        }
	if(listNode1 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode1);
  	  //listNode6 = listNode1;
	}
	if(pvariableNode2 != null)
	{
	  listNode6.add(pvariableNode2);
	}
        }
	nodeList.add(listNode6);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new141() /* reduce AAinvariantsclause1InvariantsClause */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        LinkedList listNode2 = new LinkedList();
        {
            // Block
        PInvariant pinvariantNode1;
        pinvariantNode1 = (PInvariant)nodeArrayList2.get(0);
	if(pinvariantNode1 != null)
	{
	  listNode2.add(pinvariantNode1);
	}
        }
	nodeList.add(listNode2);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new142() /* reduce AAinvariantsclause2InvariantsClause */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        LinkedList listNode3 = new LinkedList();
        {
            // Block
        PInvariant pinvariantNode1;
        LinkedList listNode2 = new LinkedList();
        pinvariantNode1 = (PInvariant)nodeArrayList2.get(0);
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(pinvariantNode1 != null)
	{
	  listNode3.add(pinvariantNode1);
	}
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
	nodeList.add(listNode3);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new143() /* reduce AInvariantsTail */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList1 = pop();
        PInvariant pinvariantNode1;
        pinvariantNode1 = (PInvariant)nodeArrayList1.get(0);
	nodeList.add(pinvariantNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new144() /* reduce AAinvariant1Invariant */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PInvariant pinvariantNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TLabel tlabelNode3;
        TFormula tformulaNode4;
        {
            // Block
        }
        tlabelNode3 = (TLabel)nodeArrayList1.get(0);
        tformulaNode4 = (TFormula)nodeArrayList2.get(0);

        pinvariantNode1 = new AInvariant(listNode2, tlabelNode3, tformulaNode4);
        }
	nodeList.add(pinvariantNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new145() /* reduce AAinvariant2Invariant */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PInvariant pinvariantNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TLabel tlabelNode4;
        TFormula tformulaNode5;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tlabelNode4 = (TLabel)nodeArrayList1.get(0);
        tformulaNode5 = (TFormula)nodeArrayList2.get(0);

        pinvariantNode1 = new AInvariant(listNode3, tlabelNode4, tformulaNode5);
        }
	nodeList.add(pinvariantNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new146() /* reduce AAderivedinvariant1Invariant */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PInvariant pinvariantNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TLabel tlabelNode3;
        TFormula tformulaNode4;
        {
            // Block
        }
        tlabelNode3 = (TLabel)nodeArrayList2.get(0);
        tformulaNode4 = (TFormula)nodeArrayList3.get(0);

        pinvariantNode1 = new ADerivedInvariant(listNode2, tlabelNode3, tformulaNode4);
        }
	nodeList.add(pinvariantNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new147() /* reduce AAderivedinvariant2Invariant */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PInvariant pinvariantNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TLabel tlabelNode4;
        TFormula tformulaNode5;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList4.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tlabelNode4 = (TLabel)nodeArrayList2.get(0);
        tformulaNode5 = (TFormula)nodeArrayList3.get(0);

        pinvariantNode1 = new ADerivedInvariant(listNode3, tlabelNode4, tformulaNode5);
        }
	nodeList.add(pinvariantNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new148() /* reduce AAvariantclause1VariantClause */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PVariant pvariantNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TFormula tformulaNode3;
        {
            // Block
        }
        tformulaNode3 = (TFormula)nodeArrayList2.get(0);

        pvariantNode1 = new AVariant(listNode2, tformulaNode3);
        }
	nodeList.add(pvariantNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new149() /* reduce AAvariantclause2VariantClause */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PVariant pvariantNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TFormula tformulaNode4;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tformulaNode4 = (TFormula)nodeArrayList2.get(0);

        pvariantNode1 = new AVariant(listNode3, tformulaNode4);
        }
	nodeList.add(pvariantNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new150() /* reduce AAeventsclause1EventsClause */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        LinkedList listNode2 = new LinkedList();
        {
            // Block
        PEvent peventNode1;
        peventNode1 = (PEvent)nodeArrayList2.get(0);
	if(peventNode1 != null)
	{
	  listNode2.add(peventNode1);
	}
        }
	nodeList.add(listNode2);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new151() /* reduce AAeventsclause2EventsClause */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        LinkedList listNode3 = new LinkedList();
        {
            // Block
        PEvent peventNode1;
        LinkedList listNode2 = new LinkedList();
        peventNode1 = (PEvent)nodeArrayList2.get(0);
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(peventNode1 != null)
	{
	  listNode3.add(peventNode1);
	}
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
	nodeList.add(listNode3);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new152() /* reduce AEventsTail */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        peventNode1 = (PEvent)nodeArrayList1.get(0);
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new153() /* reduce AAevent1Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
          Object nullNode4 = null;
          Object nullNode5 = null;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, null, null, listNode6, listNode7, listNode8, listNode9);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new154() /* reduce AAevent2Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        PConvergence pconvergenceNode4;
          Object nullNode5 = null;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode4 = (PConvergence)nodeArrayList1.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, pconvergenceNode4, null, listNode6, listNode7, listNode8, listNode9);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new155() /* reduce AAevent3Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
          Object nullNode5 = null;
          Object nullNode6 = null;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, null, null, listNode7, listNode8, listNode9, listNode10);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new156() /* reduce AAevent4Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        PConvergence pconvergenceNode5;
          Object nullNode6 = null;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList4.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode5 = (PConvergence)nodeArrayList1.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, pconvergenceNode5, null, listNode7, listNode8, listNode9, listNode10);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new157() /* reduce AAevent5Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
          Object nullNode4 = null;
        PEventRefinement peventrefinementNode5;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        peventrefinementNode5 = (PEventRefinement)nodeArrayList3.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, null, peventrefinementNode5, listNode6, listNode7, listNode8, listNode9);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new158() /* reduce AAevent6Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        PConvergence pconvergenceNode4;
        PEventRefinement peventrefinementNode5;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode4 = (PConvergence)nodeArrayList1.get(0);
        peventrefinementNode5 = (PEventRefinement)nodeArrayList4.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, pconvergenceNode4, peventrefinementNode5, listNode6, listNode7, listNode8, listNode9);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new159() /* reduce AAevent7Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
          Object nullNode5 = null;
        PEventRefinement peventrefinementNode6;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        peventrefinementNode6 = (PEventRefinement)nodeArrayList4.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, null, peventrefinementNode6, listNode7, listNode8, listNode9, listNode10);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new160() /* reduce AAevent8Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        PConvergence pconvergenceNode5;
        PEventRefinement peventrefinementNode6;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList4.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode5 = (PConvergence)nodeArrayList1.get(0);
        peventrefinementNode6 = (PEventRefinement)nodeArrayList5.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, pconvergenceNode5, peventrefinementNode6, listNode7, listNode8, listNode9, listNode10);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new161() /* reduce AAevent9Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
          Object nullNode4 = null;
          Object nullNode5 = null;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList3.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, null, null, listNode7, listNode8, listNode9, listNode10);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new162() /* reduce AAevent10Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        PConvergence pconvergenceNode4;
          Object nullNode5 = null;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode4 = (PConvergence)nodeArrayList1.get(0);
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, pconvergenceNode4, null, listNode7, listNode8, listNode9, listNode10);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new163() /* reduce AAevent11Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
          Object nullNode5 = null;
          Object nullNode6 = null;
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, null, null, listNode8, listNode9, listNode10, listNode11);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new164() /* reduce AAevent12Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        PConvergence pconvergenceNode5;
          Object nullNode6 = null;
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList4.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode5 = (PConvergence)nodeArrayList1.get(0);
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, pconvergenceNode5, null, listNode8, listNode9, listNode10, listNode11);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new165() /* reduce AAevent13Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
          Object nullNode4 = null;
        PEventRefinement peventrefinementNode5;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        peventrefinementNode5 = (PEventRefinement)nodeArrayList3.get(0);
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, null, peventrefinementNode5, listNode7, listNode8, listNode9, listNode10);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new166() /* reduce AAevent14Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        PConvergence pconvergenceNode4;
        PEventRefinement peventrefinementNode5;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode4 = (PConvergence)nodeArrayList1.get(0);
        peventrefinementNode5 = (PEventRefinement)nodeArrayList4.get(0);
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList5.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, pconvergenceNode4, peventrefinementNode5, listNode7, listNode8, listNode9, listNode10);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new167() /* reduce AAevent15Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
          Object nullNode5 = null;
        PEventRefinement peventrefinementNode6;
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        peventrefinementNode6 = (PEventRefinement)nodeArrayList4.get(0);
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, null, peventrefinementNode6, listNode8, listNode9, listNode10, listNode11);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new168() /* reduce AAevent16Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        PConvergence pconvergenceNode5;
        PEventRefinement peventrefinementNode6;
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList4.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode5 = (PConvergence)nodeArrayList1.get(0);
        peventrefinementNode6 = (PEventRefinement)nodeArrayList5.get(0);
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList6.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, pconvergenceNode5, peventrefinementNode6, listNode8, listNode9, listNode10, listNode11);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new169() /* reduce AAevent17Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
          Object nullNode4 = null;
          Object nullNode5 = null;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList3.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, null, null, listNode6, listNode8, listNode9, listNode10);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new170() /* reduce AAevent18Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        PConvergence pconvergenceNode4;
          Object nullNode5 = null;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode4 = (PConvergence)nodeArrayList1.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, pconvergenceNode4, null, listNode6, listNode8, listNode9, listNode10);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new171() /* reduce AAevent19Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
          Object nullNode5 = null;
          Object nullNode6 = null;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList4.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, null, null, listNode7, listNode9, listNode10, listNode11);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new172() /* reduce AAevent20Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        PConvergence pconvergenceNode5;
          Object nullNode6 = null;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList4.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode5 = (PConvergence)nodeArrayList1.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, pconvergenceNode5, null, listNode7, listNode9, listNode10, listNode11);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new173() /* reduce AAevent21Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
          Object nullNode4 = null;
        PEventRefinement peventrefinementNode5;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        peventrefinementNode5 = (PEventRefinement)nodeArrayList3.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, null, peventrefinementNode5, listNode6, listNode8, listNode9, listNode10);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new174() /* reduce AAevent22Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        PConvergence pconvergenceNode4;
        PEventRefinement peventrefinementNode5;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode4 = (PConvergence)nodeArrayList1.get(0);
        peventrefinementNode5 = (PEventRefinement)nodeArrayList4.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, pconvergenceNode4, peventrefinementNode5, listNode6, listNode8, listNode9, listNode10);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new175() /* reduce AAevent23Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
          Object nullNode5 = null;
        PEventRefinement peventrefinementNode6;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        peventrefinementNode6 = (PEventRefinement)nodeArrayList4.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, null, peventrefinementNode6, listNode7, listNode9, listNode10, listNode11);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new176() /* reduce AAevent24Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        PConvergence pconvergenceNode5;
        PEventRefinement peventrefinementNode6;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList4.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode5 = (PConvergence)nodeArrayList1.get(0);
        peventrefinementNode6 = (PEventRefinement)nodeArrayList5.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList6.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, pconvergenceNode5, peventrefinementNode6, listNode7, listNode9, listNode10, listNode11);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new177() /* reduce AAevent25Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
          Object nullNode4 = null;
          Object nullNode5 = null;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList3.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList4.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, null, null, listNode7, listNode9, listNode10, listNode11);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new178() /* reduce AAevent26Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        PConvergence pconvergenceNode4;
          Object nullNode5 = null;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode4 = (PConvergence)nodeArrayList1.get(0);
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, pconvergenceNode4, null, listNode7, listNode9, listNode10, listNode11);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new179() /* reduce AAevent27Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
          Object nullNode5 = null;
          Object nullNode6 = null;
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, null, null, listNode8, listNode10, listNode11, listNode12);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new180() /* reduce AAevent28Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        PConvergence pconvergenceNode5;
          Object nullNode6 = null;
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList4.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode5 = (PConvergence)nodeArrayList1.get(0);
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList6.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, pconvergenceNode5, null, listNode8, listNode10, listNode11, listNode12);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new181() /* reduce AAevent29Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
          Object nullNode4 = null;
        PEventRefinement peventrefinementNode5;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        peventrefinementNode5 = (PEventRefinement)nodeArrayList3.get(0);
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, null, peventrefinementNode5, listNode7, listNode9, listNode10, listNode11);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new182() /* reduce AAevent30Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        PConvergence pconvergenceNode4;
        PEventRefinement peventrefinementNode5;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode4 = (PConvergence)nodeArrayList1.get(0);
        peventrefinementNode5 = (PEventRefinement)nodeArrayList4.get(0);
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList5.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList6.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, pconvergenceNode4, peventrefinementNode5, listNode7, listNode9, listNode10, listNode11);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new183() /* reduce AAevent31Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
          Object nullNode5 = null;
        PEventRefinement peventrefinementNode6;
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        peventrefinementNode6 = (PEventRefinement)nodeArrayList4.get(0);
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList6.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, null, peventrefinementNode6, listNode8, listNode10, listNode11, listNode12);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new184() /* reduce AAevent32Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        PConvergence pconvergenceNode5;
        PEventRefinement peventrefinementNode6;
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList4.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode5 = (PConvergence)nodeArrayList1.get(0);
        peventrefinementNode6 = (PEventRefinement)nodeArrayList5.get(0);
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList6.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList7.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, pconvergenceNode5, peventrefinementNode6, listNode8, listNode10, listNode11, listNode12);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new185() /* reduce AAevent33Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
          Object nullNode4 = null;
          Object nullNode5 = null;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList3.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, null, null, listNode6, listNode7, listNode9, listNode10);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new186() /* reduce AAevent34Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        PConvergence pconvergenceNode4;
          Object nullNode5 = null;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode4 = (PConvergence)nodeArrayList1.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList4.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, pconvergenceNode4, null, listNode6, listNode7, listNode9, listNode10);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new187() /* reduce AAevent35Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
          Object nullNode5 = null;
          Object nullNode6 = null;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList4.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, null, null, listNode7, listNode8, listNode10, listNode11);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new188() /* reduce AAevent36Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        PConvergence pconvergenceNode5;
          Object nullNode6 = null;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList4.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode5 = (PConvergence)nodeArrayList1.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, pconvergenceNode5, null, listNode7, listNode8, listNode10, listNode11);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new189() /* reduce AAevent37Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
          Object nullNode4 = null;
        PEventRefinement peventrefinementNode5;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        peventrefinementNode5 = (PEventRefinement)nodeArrayList3.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList4.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, null, peventrefinementNode5, listNode6, listNode7, listNode9, listNode10);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new190() /* reduce AAevent38Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        PConvergence pconvergenceNode4;
        PEventRefinement peventrefinementNode5;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode4 = (PConvergence)nodeArrayList1.get(0);
        peventrefinementNode5 = (PEventRefinement)nodeArrayList4.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, pconvergenceNode4, peventrefinementNode5, listNode6, listNode7, listNode9, listNode10);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new191() /* reduce AAevent39Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
          Object nullNode5 = null;
        PEventRefinement peventrefinementNode6;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        peventrefinementNode6 = (PEventRefinement)nodeArrayList4.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, null, peventrefinementNode6, listNode7, listNode8, listNode10, listNode11);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new192() /* reduce AAevent40Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        PConvergence pconvergenceNode5;
        PEventRefinement peventrefinementNode6;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList4.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode5 = (PConvergence)nodeArrayList1.get(0);
        peventrefinementNode6 = (PEventRefinement)nodeArrayList5.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList6.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, pconvergenceNode5, peventrefinementNode6, listNode7, listNode8, listNode10, listNode11);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new193() /* reduce AAevent41Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
          Object nullNode4 = null;
          Object nullNode5 = null;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList3.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList4.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, null, null, listNode7, listNode8, listNode10, listNode11);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new194() /* reduce AAevent42Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        PConvergence pconvergenceNode4;
          Object nullNode5 = null;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode4 = (PConvergence)nodeArrayList1.get(0);
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, pconvergenceNode4, null, listNode7, listNode8, listNode10, listNode11);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new195() /* reduce AAevent43Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
          Object nullNode5 = null;
          Object nullNode6 = null;
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList5.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, null, null, listNode8, listNode9, listNode11, listNode12);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new196() /* reduce AAevent44Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        PConvergence pconvergenceNode5;
          Object nullNode6 = null;
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList4.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode5 = (PConvergence)nodeArrayList1.get(0);
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, pconvergenceNode5, null, listNode8, listNode9, listNode11, listNode12);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new197() /* reduce AAevent45Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
          Object nullNode4 = null;
        PEventRefinement peventrefinementNode5;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        peventrefinementNode5 = (PEventRefinement)nodeArrayList3.get(0);
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, null, peventrefinementNode5, listNode7, listNode8, listNode10, listNode11);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new198() /* reduce AAevent46Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        PConvergence pconvergenceNode4;
        PEventRefinement peventrefinementNode5;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode4 = (PConvergence)nodeArrayList1.get(0);
        peventrefinementNode5 = (PEventRefinement)nodeArrayList4.get(0);
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList5.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList6.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, pconvergenceNode4, peventrefinementNode5, listNode7, listNode8, listNode10, listNode11);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new199() /* reduce AAevent47Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
          Object nullNode5 = null;
        PEventRefinement peventrefinementNode6;
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        peventrefinementNode6 = (PEventRefinement)nodeArrayList4.get(0);
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, null, peventrefinementNode6, listNode8, listNode9, listNode11, listNode12);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new200() /* reduce AAevent48Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        PConvergence pconvergenceNode5;
        PEventRefinement peventrefinementNode6;
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList4.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode5 = (PConvergence)nodeArrayList1.get(0);
        peventrefinementNode6 = (PEventRefinement)nodeArrayList5.get(0);
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList6.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList7.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, pconvergenceNode5, peventrefinementNode6, listNode8, listNode9, listNode11, listNode12);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new201() /* reduce AAevent49Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
          Object nullNode4 = null;
          Object nullNode5 = null;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList3.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList4.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, null, null, listNode6, listNode8, listNode10, listNode11);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new202() /* reduce AAevent50Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        PConvergence pconvergenceNode4;
          Object nullNode5 = null;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode4 = (PConvergence)nodeArrayList1.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, pconvergenceNode4, null, listNode6, listNode8, listNode10, listNode11);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new203() /* reduce AAevent51Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
          Object nullNode5 = null;
          Object nullNode6 = null;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList4.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList5.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, null, null, listNode7, listNode9, listNode11, listNode12);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new204() /* reduce AAevent52Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        PConvergence pconvergenceNode5;
          Object nullNode6 = null;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList4.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode5 = (PConvergence)nodeArrayList1.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, pconvergenceNode5, null, listNode7, listNode9, listNode11, listNode12);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new205() /* reduce AAevent53Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
          Object nullNode4 = null;
        PEventRefinement peventrefinementNode5;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        peventrefinementNode5 = (PEventRefinement)nodeArrayList3.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, null, peventrefinementNode5, listNode6, listNode8, listNode10, listNode11);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new206() /* reduce AAevent54Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        PConvergence pconvergenceNode4;
        PEventRefinement peventrefinementNode5;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode4 = (PConvergence)nodeArrayList1.get(0);
        peventrefinementNode5 = (PEventRefinement)nodeArrayList4.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList6.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, pconvergenceNode4, peventrefinementNode5, listNode6, listNode8, listNode10, listNode11);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new207() /* reduce AAevent55Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
          Object nullNode5 = null;
        PEventRefinement peventrefinementNode6;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        peventrefinementNode6 = (PEventRefinement)nodeArrayList4.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, null, peventrefinementNode6, listNode7, listNode9, listNode11, listNode12);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new208() /* reduce AAevent56Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        PConvergence pconvergenceNode5;
        PEventRefinement peventrefinementNode6;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList4.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode5 = (PConvergence)nodeArrayList1.get(0);
        peventrefinementNode6 = (PEventRefinement)nodeArrayList5.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList6.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList7.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, pconvergenceNode5, peventrefinementNode6, listNode7, listNode9, listNode11, listNode12);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new209() /* reduce AAevent57Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
          Object nullNode4 = null;
          Object nullNode5 = null;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList3.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList4.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList5.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, null, null, listNode7, listNode9, listNode11, listNode12);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new210() /* reduce AAevent58Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        PConvergence pconvergenceNode4;
          Object nullNode5 = null;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode4 = (PConvergence)nodeArrayList1.get(0);
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, pconvergenceNode4, null, listNode7, listNode9, listNode11, listNode12);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new211() /* reduce AAevent59Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
          Object nullNode5 = null;
          Object nullNode6 = null;
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList6.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, null, null, listNode8, listNode10, listNode12, listNode13);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new212() /* reduce AAevent60Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        PConvergence pconvergenceNode5;
          Object nullNode6 = null;
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList4.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode5 = (PConvergence)nodeArrayList1.get(0);
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList6.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList7.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, pconvergenceNode5, null, listNode8, listNode10, listNode12, listNode13);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new213() /* reduce AAevent61Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
          Object nullNode4 = null;
        PEventRefinement peventrefinementNode5;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        peventrefinementNode5 = (PEventRefinement)nodeArrayList3.get(0);
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, null, peventrefinementNode5, listNode7, listNode9, listNode11, listNode12);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new214() /* reduce AAevent62Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        PConvergence pconvergenceNode4;
        PEventRefinement peventrefinementNode5;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode4 = (PConvergence)nodeArrayList1.get(0);
        peventrefinementNode5 = (PEventRefinement)nodeArrayList4.get(0);
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList5.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList6.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList7.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, pconvergenceNode4, peventrefinementNode5, listNode7, listNode9, listNode11, listNode12);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new215() /* reduce AAevent63Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
          Object nullNode5 = null;
        PEventRefinement peventrefinementNode6;
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        peventrefinementNode6 = (PEventRefinement)nodeArrayList4.get(0);
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList6.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList7.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, null, peventrefinementNode6, listNode8, listNode10, listNode12, listNode13);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new216() /* reduce AAevent64Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        PConvergence pconvergenceNode5;
        PEventRefinement peventrefinementNode6;
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList4.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode5 = (PConvergence)nodeArrayList1.get(0);
        peventrefinementNode6 = (PEventRefinement)nodeArrayList5.get(0);
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList6.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList7.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList8.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, pconvergenceNode5, peventrefinementNode6, listNode8, listNode10, listNode12, listNode13);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new217() /* reduce AAevent65Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
          Object nullNode4 = null;
          Object nullNode5 = null;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList3.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, null, null, listNode6, listNode7, listNode8, listNode10);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new218() /* reduce AAevent66Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        PConvergence pconvergenceNode4;
          Object nullNode5 = null;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode4 = (PConvergence)nodeArrayList1.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList4.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, pconvergenceNode4, null, listNode6, listNode7, listNode8, listNode10);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new219() /* reduce AAevent67Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
          Object nullNode5 = null;
          Object nullNode6 = null;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList4.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, null, null, listNode7, listNode8, listNode9, listNode11);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new220() /* reduce AAevent68Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        PConvergence pconvergenceNode5;
          Object nullNode6 = null;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList4.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode5 = (PConvergence)nodeArrayList1.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList5.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, pconvergenceNode5, null, listNode7, listNode8, listNode9, listNode11);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new221() /* reduce AAevent69Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
          Object nullNode4 = null;
        PEventRefinement peventrefinementNode5;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        peventrefinementNode5 = (PEventRefinement)nodeArrayList3.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList4.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, null, peventrefinementNode5, listNode6, listNode7, listNode8, listNode10);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new222() /* reduce AAevent70Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        PConvergence pconvergenceNode4;
        PEventRefinement peventrefinementNode5;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode4 = (PConvergence)nodeArrayList1.get(0);
        peventrefinementNode5 = (PEventRefinement)nodeArrayList4.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, pconvergenceNode4, peventrefinementNode5, listNode6, listNode7, listNode8, listNode10);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new223() /* reduce AAevent71Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
          Object nullNode5 = null;
        PEventRefinement peventrefinementNode6;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        peventrefinementNode6 = (PEventRefinement)nodeArrayList4.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList5.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, null, peventrefinementNode6, listNode7, listNode8, listNode9, listNode11);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new224() /* reduce AAevent72Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        PConvergence pconvergenceNode5;
        PEventRefinement peventrefinementNode6;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList4.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode5 = (PConvergence)nodeArrayList1.get(0);
        peventrefinementNode6 = (PEventRefinement)nodeArrayList5.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, pconvergenceNode5, peventrefinementNode6, listNode7, listNode8, listNode9, listNode11);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new225() /* reduce AAevent73Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
          Object nullNode4 = null;
          Object nullNode5 = null;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList3.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList4.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, null, null, listNode7, listNode8, listNode9, listNode11);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new226() /* reduce AAevent74Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        PConvergence pconvergenceNode4;
          Object nullNode5 = null;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode4 = (PConvergence)nodeArrayList1.get(0);
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList5.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, pconvergenceNode4, null, listNode7, listNode8, listNode9, listNode11);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new227() /* reduce AAevent75Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
          Object nullNode5 = null;
          Object nullNode6 = null;
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList5.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, null, null, listNode8, listNode9, listNode10, listNode12);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new228() /* reduce AAevent76Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        PConvergence pconvergenceNode5;
          Object nullNode6 = null;
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList4.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode5 = (PConvergence)nodeArrayList1.get(0);
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList6.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, pconvergenceNode5, null, listNode8, listNode9, listNode10, listNode12);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new229() /* reduce AAevent77Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
          Object nullNode4 = null;
        PEventRefinement peventrefinementNode5;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        peventrefinementNode5 = (PEventRefinement)nodeArrayList3.get(0);
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList5.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, null, peventrefinementNode5, listNode7, listNode8, listNode9, listNode11);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new230() /* reduce AAevent78Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        PConvergence pconvergenceNode4;
        PEventRefinement peventrefinementNode5;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode4 = (PConvergence)nodeArrayList1.get(0);
        peventrefinementNode5 = (PEventRefinement)nodeArrayList4.get(0);
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList5.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, pconvergenceNode4, peventrefinementNode5, listNode7, listNode8, listNode9, listNode11);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new231() /* reduce AAevent79Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
          Object nullNode5 = null;
        PEventRefinement peventrefinementNode6;
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        peventrefinementNode6 = (PEventRefinement)nodeArrayList4.get(0);
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList6.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, null, peventrefinementNode6, listNode8, listNode9, listNode10, listNode12);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new232() /* reduce AAevent80Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        PConvergence pconvergenceNode5;
        PEventRefinement peventrefinementNode6;
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList4.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode5 = (PConvergence)nodeArrayList1.get(0);
        peventrefinementNode6 = (PEventRefinement)nodeArrayList5.get(0);
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList6.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList7.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, pconvergenceNode5, peventrefinementNode6, listNode8, listNode9, listNode10, listNode12);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new233() /* reduce AAevent81Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
          Object nullNode4 = null;
          Object nullNode5 = null;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList3.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList4.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, null, null, listNode6, listNode8, listNode9, listNode11);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new234() /* reduce AAevent82Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        PConvergence pconvergenceNode4;
          Object nullNode5 = null;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode4 = (PConvergence)nodeArrayList1.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList5.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, pconvergenceNode4, null, listNode6, listNode8, listNode9, listNode11);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new235() /* reduce AAevent83Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
          Object nullNode5 = null;
          Object nullNode6 = null;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList4.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList5.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, null, null, listNode7, listNode9, listNode10, listNode12);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new236() /* reduce AAevent84Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        PConvergence pconvergenceNode5;
          Object nullNode6 = null;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList4.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode5 = (PConvergence)nodeArrayList1.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList6.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, pconvergenceNode5, null, listNode7, listNode9, listNode10, listNode12);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new237() /* reduce AAevent85Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
          Object nullNode4 = null;
        PEventRefinement peventrefinementNode5;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        peventrefinementNode5 = (PEventRefinement)nodeArrayList3.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList5.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, null, peventrefinementNode5, listNode6, listNode8, listNode9, listNode11);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new238() /* reduce AAevent86Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        PConvergence pconvergenceNode4;
        PEventRefinement peventrefinementNode5;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode4 = (PConvergence)nodeArrayList1.get(0);
        peventrefinementNode5 = (PEventRefinement)nodeArrayList4.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, pconvergenceNode4, peventrefinementNode5, listNode6, listNode8, listNode9, listNode11);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new239() /* reduce AAevent87Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
          Object nullNode5 = null;
        PEventRefinement peventrefinementNode6;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        peventrefinementNode6 = (PEventRefinement)nodeArrayList4.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList6.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, null, peventrefinementNode6, listNode7, listNode9, listNode10, listNode12);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new240() /* reduce AAevent88Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        PConvergence pconvergenceNode5;
        PEventRefinement peventrefinementNode6;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList4.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode5 = (PConvergence)nodeArrayList1.get(0);
        peventrefinementNode6 = (PEventRefinement)nodeArrayList5.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList6.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList7.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, pconvergenceNode5, peventrefinementNode6, listNode7, listNode9, listNode10, listNode12);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new241() /* reduce AAevent89Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
          Object nullNode4 = null;
          Object nullNode5 = null;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList3.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList4.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList5.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, null, null, listNode7, listNode9, listNode10, listNode12);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new242() /* reduce AAevent90Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        PConvergence pconvergenceNode4;
          Object nullNode5 = null;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode4 = (PConvergence)nodeArrayList1.get(0);
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList6.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, pconvergenceNode4, null, listNode7, listNode9, listNode10, listNode12);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new243() /* reduce AAevent91Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
          Object nullNode5 = null;
          Object nullNode6 = null;
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList6.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, null, null, listNode8, listNode10, listNode11, listNode13);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new244() /* reduce AAevent92Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        PConvergence pconvergenceNode5;
          Object nullNode6 = null;
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList4.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode5 = (PConvergence)nodeArrayList1.get(0);
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList6.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList7.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, pconvergenceNode5, null, listNode8, listNode10, listNode11, listNode13);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new245() /* reduce AAevent93Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
          Object nullNode4 = null;
        PEventRefinement peventrefinementNode5;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        peventrefinementNode5 = (PEventRefinement)nodeArrayList3.get(0);
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList6.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, null, peventrefinementNode5, listNode7, listNode9, listNode10, listNode12);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new246() /* reduce AAevent94Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        PConvergence pconvergenceNode4;
        PEventRefinement peventrefinementNode5;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode4 = (PConvergence)nodeArrayList1.get(0);
        peventrefinementNode5 = (PEventRefinement)nodeArrayList4.get(0);
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList5.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList6.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList7.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, pconvergenceNode4, peventrefinementNode5, listNode7, listNode9, listNode10, listNode12);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new247() /* reduce AAevent95Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
          Object nullNode5 = null;
        PEventRefinement peventrefinementNode6;
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        peventrefinementNode6 = (PEventRefinement)nodeArrayList4.get(0);
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList6.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList7.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, null, peventrefinementNode6, listNode8, listNode10, listNode11, listNode13);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new248() /* reduce AAevent96Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        PConvergence pconvergenceNode5;
        PEventRefinement peventrefinementNode6;
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList4.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode5 = (PConvergence)nodeArrayList1.get(0);
        peventrefinementNode6 = (PEventRefinement)nodeArrayList5.get(0);
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList6.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList7.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList8.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, pconvergenceNode5, peventrefinementNode6, listNode8, listNode10, listNode11, listNode13);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new249() /* reduce AAevent97Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
          Object nullNode4 = null;
          Object nullNode5 = null;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList3.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList4.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, null, null, listNode6, listNode7, listNode9, listNode11);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new250() /* reduce AAevent98Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        PConvergence pconvergenceNode4;
          Object nullNode5 = null;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode4 = (PConvergence)nodeArrayList1.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList4.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList5.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, pconvergenceNode4, null, listNode6, listNode7, listNode9, listNode11);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new251() /* reduce AAevent99Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
          Object nullNode5 = null;
          Object nullNode6 = null;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList4.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList5.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, null, null, listNode7, listNode8, listNode10, listNode12);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new252() /* reduce AAevent100Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        PConvergence pconvergenceNode5;
          Object nullNode6 = null;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList4.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode5 = (PConvergence)nodeArrayList1.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList6.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, pconvergenceNode5, null, listNode7, listNode8, listNode10, listNode12);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new253() /* reduce AAevent101Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
          Object nullNode4 = null;
        PEventRefinement peventrefinementNode5;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        peventrefinementNode5 = (PEventRefinement)nodeArrayList3.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList4.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList5.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, null, peventrefinementNode5, listNode6, listNode7, listNode9, listNode11);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new254() /* reduce AAevent102Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        PConvergence pconvergenceNode4;
        PEventRefinement peventrefinementNode5;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode4 = (PConvergence)nodeArrayList1.get(0);
        peventrefinementNode5 = (PEventRefinement)nodeArrayList4.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, pconvergenceNode4, peventrefinementNode5, listNode6, listNode7, listNode9, listNode11);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new255() /* reduce AAevent103Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
          Object nullNode5 = null;
        PEventRefinement peventrefinementNode6;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        peventrefinementNode6 = (PEventRefinement)nodeArrayList4.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList6.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, null, peventrefinementNode6, listNode7, listNode8, listNode10, listNode12);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new256() /* reduce AAevent104Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        PConvergence pconvergenceNode5;
        PEventRefinement peventrefinementNode6;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList4.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode5 = (PConvergence)nodeArrayList1.get(0);
        peventrefinementNode6 = (PEventRefinement)nodeArrayList5.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList6.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList7.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, pconvergenceNode5, peventrefinementNode6, listNode7, listNode8, listNode10, listNode12);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new257() /* reduce AAevent105Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
          Object nullNode4 = null;
          Object nullNode5 = null;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList3.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList4.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList5.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, null, null, listNode7, listNode8, listNode10, listNode12);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new258() /* reduce AAevent106Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        PConvergence pconvergenceNode4;
          Object nullNode5 = null;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode4 = (PConvergence)nodeArrayList1.get(0);
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList6.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, pconvergenceNode4, null, listNode7, listNode8, listNode10, listNode12);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new259() /* reduce AAevent107Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
          Object nullNode5 = null;
          Object nullNode6 = null;
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList5.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList6.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, null, null, listNode8, listNode9, listNode11, listNode13);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new260() /* reduce AAevent108Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        PConvergence pconvergenceNode5;
          Object nullNode6 = null;
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList4.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode5 = (PConvergence)nodeArrayList1.get(0);
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList7.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, pconvergenceNode5, null, listNode8, listNode9, listNode11, listNode13);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new261() /* reduce AAevent109Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
          Object nullNode4 = null;
        PEventRefinement peventrefinementNode5;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        peventrefinementNode5 = (PEventRefinement)nodeArrayList3.get(0);
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList6.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, null, peventrefinementNode5, listNode7, listNode8, listNode10, listNode12);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new262() /* reduce AAevent110Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        PConvergence pconvergenceNode4;
        PEventRefinement peventrefinementNode5;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode4 = (PConvergence)nodeArrayList1.get(0);
        peventrefinementNode5 = (PEventRefinement)nodeArrayList4.get(0);
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList5.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList6.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList7.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, pconvergenceNode4, peventrefinementNode5, listNode7, listNode8, listNode10, listNode12);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new263() /* reduce AAevent111Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
          Object nullNode5 = null;
        PEventRefinement peventrefinementNode6;
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        peventrefinementNode6 = (PEventRefinement)nodeArrayList4.get(0);
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList7.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, null, peventrefinementNode6, listNode8, listNode9, listNode11, listNode13);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new264() /* reduce AAevent112Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        PConvergence pconvergenceNode5;
        PEventRefinement peventrefinementNode6;
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList4.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode5 = (PConvergence)nodeArrayList1.get(0);
        peventrefinementNode6 = (PEventRefinement)nodeArrayList5.get(0);
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList6.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList7.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList8.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, pconvergenceNode5, peventrefinementNode6, listNode8, listNode9, listNode11, listNode13);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new265() /* reduce AAevent113Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
          Object nullNode4 = null;
          Object nullNode5 = null;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList3.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList4.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList5.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, null, null, listNode6, listNode8, listNode10, listNode12);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new266() /* reduce AAevent114Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        PConvergence pconvergenceNode4;
          Object nullNode5 = null;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode4 = (PConvergence)nodeArrayList1.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList6.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, pconvergenceNode4, null, listNode6, listNode8, listNode10, listNode12);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new267() /* reduce AAevent115Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
          Object nullNode5 = null;
          Object nullNode6 = null;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList4.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList5.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList6.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, null, null, listNode7, listNode9, listNode11, listNode13);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new268() /* reduce AAevent116Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        PConvergence pconvergenceNode5;
          Object nullNode6 = null;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList4.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode5 = (PConvergence)nodeArrayList1.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList7.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, pconvergenceNode5, null, listNode7, listNode9, listNode11, listNode13);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new269() /* reduce AAevent117Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
          Object nullNode4 = null;
        PEventRefinement peventrefinementNode5;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        peventrefinementNode5 = (PEventRefinement)nodeArrayList3.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList6.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, null, peventrefinementNode5, listNode6, listNode8, listNode10, listNode12);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new270() /* reduce AAevent118Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        PConvergence pconvergenceNode4;
        PEventRefinement peventrefinementNode5;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode4 = (PConvergence)nodeArrayList1.get(0);
        peventrefinementNode5 = (PEventRefinement)nodeArrayList4.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList6.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList7.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, pconvergenceNode4, peventrefinementNode5, listNode6, listNode8, listNode10, listNode12);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new271() /* reduce AAevent119Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
          Object nullNode5 = null;
        PEventRefinement peventrefinementNode6;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        peventrefinementNode6 = (PEventRefinement)nodeArrayList4.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList7.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, null, peventrefinementNode6, listNode7, listNode9, listNode11, listNode13);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new272() /* reduce AAevent120Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        PConvergence pconvergenceNode5;
        PEventRefinement peventrefinementNode6;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList4.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode5 = (PConvergence)nodeArrayList1.get(0);
        peventrefinementNode6 = (PEventRefinement)nodeArrayList5.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList6.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList7.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList8.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, pconvergenceNode5, peventrefinementNode6, listNode7, listNode9, listNode11, listNode13);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new273() /* reduce AAevent121Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
          Object nullNode4 = null;
          Object nullNode5 = null;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList3.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList4.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList5.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList6.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, null, null, listNode7, listNode9, listNode11, listNode13);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new274() /* reduce AAevent122Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        PConvergence pconvergenceNode4;
          Object nullNode5 = null;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode4 = (PConvergence)nodeArrayList1.get(0);
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList7.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, pconvergenceNode4, null, listNode7, listNode9, listNode11, listNode13);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new275() /* reduce AAevent123Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
          Object nullNode5 = null;
          Object nullNode6 = null;
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList6.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        {
            // Block
        LinkedList listNode13 = new LinkedList();
        listNode13 = (LinkedList)nodeArrayList7.get(0);
	if(listNode13 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode14.addAll(listNode13);
  	  //listNode14 = listNode13;
	}
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, null, null, listNode8, listNode10, listNode12, listNode14);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new276() /* reduce AAevent124Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        PConvergence pconvergenceNode5;
          Object nullNode6 = null;
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList4.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode5 = (PConvergence)nodeArrayList1.get(0);
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList6.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList7.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        {
            // Block
        LinkedList listNode13 = new LinkedList();
        listNode13 = (LinkedList)nodeArrayList8.get(0);
	if(listNode13 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode14.addAll(listNode13);
  	  //listNode14 = listNode13;
	}
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, pconvergenceNode5, null, listNode8, listNode10, listNode12, listNode14);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new277() /* reduce AAevent125Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
          Object nullNode4 = null;
        PEventRefinement peventrefinementNode5;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        peventrefinementNode5 = (PEventRefinement)nodeArrayList3.get(0);
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList7.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, null, peventrefinementNode5, listNode7, listNode9, listNode11, listNode13);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new278() /* reduce AAevent126Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        PConvergence pconvergenceNode4;
        PEventRefinement peventrefinementNode5;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode4 = (PConvergence)nodeArrayList1.get(0);
        peventrefinementNode5 = (PEventRefinement)nodeArrayList4.get(0);
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList5.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList6.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList7.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList8.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, pconvergenceNode4, peventrefinementNode5, listNode7, listNode9, listNode11, listNode13);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new279() /* reduce AAevent127Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
          Object nullNode5 = null;
        PEventRefinement peventrefinementNode6;
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        peventrefinementNode6 = (PEventRefinement)nodeArrayList4.get(0);
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList6.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList7.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        {
            // Block
        LinkedList listNode13 = new LinkedList();
        listNode13 = (LinkedList)nodeArrayList8.get(0);
	if(listNode13 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode14.addAll(listNode13);
  	  //listNode14 = listNode13;
	}
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, null, peventrefinementNode6, listNode8, listNode10, listNode12, listNode14);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new280() /* reduce AAevent128Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList10 = pop();
          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        PConvergence pconvergenceNode5;
        PEventRefinement peventrefinementNode6;
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList4.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode5 = (PConvergence)nodeArrayList1.get(0);
        peventrefinementNode6 = (PEventRefinement)nodeArrayList5.get(0);
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList6.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList7.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList8.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        {
            // Block
        LinkedList listNode13 = new LinkedList();
        listNode13 = (LinkedList)nodeArrayList9.get(0);
	if(listNode13 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode14.addAll(listNode13);
  	  //listNode14 = listNode13;
	}
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, pconvergenceNode5, peventrefinementNode6, listNode8, listNode10, listNode12, listNode14);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new281() /* reduce AOrdinaryConvergence */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList1 = pop();
        PConvergence pconvergenceNode1;
        {
            // Block

        pconvergenceNode1 = new AOrdinaryConvergence();
        }
	nodeList.add(pconvergenceNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new282() /* reduce AConvergentConvergence */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList1 = pop();
        PConvergence pconvergenceNode1;
        {
            // Block

        pconvergenceNode1 = new AConvergentConvergence();
        }
	nodeList.add(pconvergenceNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new283() /* reduce AAnticipatedConvergence */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList1 = pop();
        PConvergence pconvergenceNode1;
        {
            // Block

        pconvergenceNode1 = new AAnticipatedConvergence();
        }
	nodeList.add(pconvergenceNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new284() /* reduce ARefinesEventRefinement */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList1 = pop();
        PEventRefinement peventrefinementNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList1.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }

        peventrefinementNode1 = new ARefinesEventRefinement(listNode3);
        }
	nodeList.add(peventrefinementNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new285() /* reduce AExtendedEventRefinement */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEventRefinement peventrefinementNode1;
        {
            // Block
        TIdentifierLiteral tidentifierliteralNode2;
        tidentifierliteralNode2 = (TIdentifierLiteral)nodeArrayList2.get(0);

        peventrefinementNode1 = new AExtendedEventRefinement(tidentifierliteralNode2);
        }
	nodeList.add(peventrefinementNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new286() /* reduce AAeventrefines1EventRefines */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        LinkedList listNode2 = new LinkedList();
        {
            // Block
        TIdentifierLiteral tidentifierliteralNode1;
        tidentifierliteralNode1 = (TIdentifierLiteral)nodeArrayList2.get(0);
	if(tidentifierliteralNode1 != null)
	{
	  listNode2.add(tidentifierliteralNode1);
	}
        }
	nodeList.add(listNode2);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new287() /* reduce AAeventrefines2EventRefines */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        LinkedList listNode3 = new LinkedList();
        {
            // Block
        TIdentifierLiteral tidentifierliteralNode1;
        LinkedList listNode2 = new LinkedList();
        tidentifierliteralNode1 = (TIdentifierLiteral)nodeArrayList2.get(0);
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(tidentifierliteralNode1 != null)
	{
	  listNode3.add(tidentifierliteralNode1);
	}
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
	nodeList.add(listNode3);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new288() /* reduce AEventRefinesTail */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList1 = pop();
        TIdentifierLiteral tidentifierliteralNode1;
        tidentifierliteralNode1 = (TIdentifierLiteral)nodeArrayList1.get(0);
	nodeList.add(tidentifierliteralNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new289() /* reduce AAeventany1EventAny */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        LinkedList listNode2 = new LinkedList();
        {
            // Block
        PParameter pparameterNode1;
        pparameterNode1 = (PParameter)nodeArrayList2.get(0);
	if(pparameterNode1 != null)
	{
	  listNode2.add(pparameterNode1);
	}
        }
	nodeList.add(listNode2);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new290() /* reduce AAeventany2EventAny */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        LinkedList listNode3 = new LinkedList();
        {
            // Block
        PParameter pparameterNode1;
        LinkedList listNode2 = new LinkedList();
        pparameterNode1 = (PParameter)nodeArrayList2.get(0);
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(pparameterNode1 != null)
	{
	  listNode3.add(pparameterNode1);
	}
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
	nodeList.add(listNode3);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new291() /* reduce AEventAnyTail */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList1 = pop();
        PParameter pparameterNode1;
        pparameterNode1 = (PParameter)nodeArrayList1.get(0);
	nodeList.add(pparameterNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new292() /* reduce AAparameter1Parameter */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList1 = pop();
        PParameter pparameterNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList1.get(0);

        pparameterNode1 = new AParameter(listNode2, tidentifierliteralNode3);
        }
	nodeList.add(pparameterNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new293() /* reduce AAparameter2Parameter */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParameter pparameterNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList2.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList1.get(0);

        pparameterNode1 = new AParameter(listNode3, tidentifierliteralNode4);
        }
	nodeList.add(pparameterNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new294() /* reduce AAeventwhere1EventWhere */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        LinkedList listNode2 = new LinkedList();
        {
            // Block
        PGuard pguardNode1;
        pguardNode1 = (PGuard)nodeArrayList2.get(0);
	if(pguardNode1 != null)
	{
	  listNode2.add(pguardNode1);
	}
        }
	nodeList.add(listNode2);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new295() /* reduce AAeventwhere2EventWhere */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        LinkedList listNode3 = new LinkedList();
        {
            // Block
        PGuard pguardNode1;
        LinkedList listNode2 = new LinkedList();
        pguardNode1 = (PGuard)nodeArrayList2.get(0);
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(pguardNode1 != null)
	{
	  listNode3.add(pguardNode1);
	}
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
	nodeList.add(listNode3);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new296() /* reduce AEventWhereTail */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList1 = pop();
        PGuard pguardNode1;
        pguardNode1 = (PGuard)nodeArrayList1.get(0);
	nodeList.add(pguardNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new297() /* reduce AAguard1Guard */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PGuard pguardNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TLabel tlabelNode3;
        TFormula tformulaNode4;
        {
            // Block
        }
        tlabelNode3 = (TLabel)nodeArrayList1.get(0);
        tformulaNode4 = (TFormula)nodeArrayList2.get(0);

        pguardNode1 = new AGuard(listNode2, tlabelNode3, tformulaNode4);
        }
	nodeList.add(pguardNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new298() /* reduce AAguard2Guard */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PGuard pguardNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TLabel tlabelNode4;
        TFormula tformulaNode5;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tlabelNode4 = (TLabel)nodeArrayList1.get(0);
        tformulaNode5 = (TFormula)nodeArrayList2.get(0);

        pguardNode1 = new AGuard(listNode3, tlabelNode4, tformulaNode5);
        }
	nodeList.add(pguardNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new299() /* reduce AAderivedguard1Guard */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PGuard pguardNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TLabel tlabelNode3;
        TFormula tformulaNode4;
        {
            // Block
        }
        tlabelNode3 = (TLabel)nodeArrayList2.get(0);
        tformulaNode4 = (TFormula)nodeArrayList3.get(0);

        pguardNode1 = new ADerivedGuard(listNode2, tlabelNode3, tformulaNode4);
        }
	nodeList.add(pguardNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new300() /* reduce AAderivedguard2Guard */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PGuard pguardNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TLabel tlabelNode4;
        TFormula tformulaNode5;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList4.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tlabelNode4 = (TLabel)nodeArrayList2.get(0);
        tformulaNode5 = (TFormula)nodeArrayList3.get(0);

        pguardNode1 = new ADerivedGuard(listNode3, tlabelNode4, tformulaNode5);
        }
	nodeList.add(pguardNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new301() /* reduce AAeventwith1EventWith */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        LinkedList listNode2 = new LinkedList();
        {
            // Block
        PWitness pwitnessNode1;
        pwitnessNode1 = (PWitness)nodeArrayList2.get(0);
	if(pwitnessNode1 != null)
	{
	  listNode2.add(pwitnessNode1);
	}
        }
	nodeList.add(listNode2);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new302() /* reduce AAeventwith2EventWith */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        LinkedList listNode3 = new LinkedList();
        {
            // Block
        PWitness pwitnessNode1;
        LinkedList listNode2 = new LinkedList();
        pwitnessNode1 = (PWitness)nodeArrayList2.get(0);
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(pwitnessNode1 != null)
	{
	  listNode3.add(pwitnessNode1);
	}
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
	nodeList.add(listNode3);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new303() /* reduce AEventWithTail */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList1 = pop();
        PWitness pwitnessNode1;
        pwitnessNode1 = (PWitness)nodeArrayList1.get(0);
	nodeList.add(pwitnessNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new304() /* reduce AAwitness1Witness */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PWitness pwitnessNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TLabel tlabelNode3;
        TFormula tformulaNode4;
        {
            // Block
        }
        tlabelNode3 = (TLabel)nodeArrayList1.get(0);
        tformulaNode4 = (TFormula)nodeArrayList2.get(0);

        pwitnessNode1 = new AWitness(listNode2, tlabelNode3, tformulaNode4);
        }
	nodeList.add(pwitnessNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new305() /* reduce AAwitness2Witness */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PWitness pwitnessNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TLabel tlabelNode4;
        TFormula tformulaNode5;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tlabelNode4 = (TLabel)nodeArrayList1.get(0);
        tformulaNode5 = (TFormula)nodeArrayList2.get(0);

        pwitnessNode1 = new AWitness(listNode3, tlabelNode4, tformulaNode5);
        }
	nodeList.add(pwitnessNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new306() /* reduce AAeventthen1EventThen */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        LinkedList listNode2 = new LinkedList();
        {
            // Block
        PAction pactionNode1;
        pactionNode1 = (PAction)nodeArrayList2.get(0);
	if(pactionNode1 != null)
	{
	  listNode2.add(pactionNode1);
	}
        }
	nodeList.add(listNode2);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new307() /* reduce AAeventthen2EventThen */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        LinkedList listNode3 = new LinkedList();
        {
            // Block
        PAction pactionNode1;
        LinkedList listNode2 = new LinkedList();
        pactionNode1 = (PAction)nodeArrayList2.get(0);
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(pactionNode1 != null)
	{
	  listNode3.add(pactionNode1);
	}
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
	nodeList.add(listNode3);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new308() /* reduce AEventThenTail */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList1 = pop();
        PAction pactionNode1;
        pactionNode1 = (PAction)nodeArrayList1.get(0);
	nodeList.add(pactionNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new309() /* reduce AAaction1Action */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PAction pactionNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TLabel tlabelNode3;
        TFormula tformulaNode4;
        {
            // Block
        }
        tlabelNode3 = (TLabel)nodeArrayList1.get(0);
        tformulaNode4 = (TFormula)nodeArrayList2.get(0);

        pactionNode1 = new AAction(listNode2, tlabelNode3, tformulaNode4);
        }
	nodeList.add(pactionNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new310() /* reduce AAaction2Action */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PAction pactionNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TLabel tlabelNode4;
        TFormula tformulaNode5;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tlabelNode4 = (TLabel)nodeArrayList1.get(0);
        tformulaNode5 = (TFormula)nodeArrayList2.get(0);

        pactionNode1 = new AAction(listNode3, tlabelNode4, tformulaNode5);
        }
	nodeList.add(pactionNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new311() /* reduce AAcontext1Context */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AContextParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode5, listNode6, listNode7);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new312() /* reduce AAcontext2Context */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AContextParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode6, listNode7, listNode8);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new313() /* reduce AAcontext3Context */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AContextParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode6, listNode7, listNode8);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new314() /* reduce AAcontext4Context */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AContextParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode7, listNode8, listNode9);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new315() /* reduce AAcontext5Context */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList3.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AContextParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode6, listNode7, listNode8);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new316() /* reduce AAcontext6Context */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AContextParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode7, listNode8, listNode9);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new317() /* reduce AAcontext7Context */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AContextParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode7, listNode8, listNode9);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new318() /* reduce AAcontext8Context */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AContextParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode8, listNode9, listNode10);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new319() /* reduce AAcontext9Context */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList3.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AContextParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode5, listNode7, listNode8);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new320() /* reduce AAcontext10Context */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AContextParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode6, listNode8, listNode9);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new321() /* reduce AAcontext11Context */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AContextParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode6, listNode8, listNode9);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new322() /* reduce AAcontext12Context */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AContextParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode7, listNode9, listNode10);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new323() /* reduce AAcontext13Context */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList3.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AContextParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode6, listNode8, listNode9);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new324() /* reduce AAcontext14Context */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AContextParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode7, listNode9, listNode10);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new325() /* reduce AAcontext15Context */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AContextParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode7, listNode9, listNode10);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new326() /* reduce AAcontext16Context */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList6.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AContextParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode8, listNode10, listNode11);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new327() /* reduce AAcontext17Context */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList3.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }

        pparseunitNode1 = new AContextParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode5, listNode6, listNode8);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new328() /* reduce AAcontext18Context */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList4.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }

        pparseunitNode1 = new AContextParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode6, listNode7, listNode9);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new329() /* reduce AAcontext19Context */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList4.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }

        pparseunitNode1 = new AContextParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode6, listNode7, listNode9);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new330() /* reduce AAcontext20Context */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }

        pparseunitNode1 = new AContextParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode7, listNode8, listNode10);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new331() /* reduce AAcontext21Context */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList3.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList4.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }

        pparseunitNode1 = new AContextParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode6, listNode7, listNode9);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new332() /* reduce AAcontext22Context */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }

        pparseunitNode1 = new AContextParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode7, listNode8, listNode10);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new333() /* reduce AAcontext23Context */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }

        pparseunitNode1 = new AContextParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode7, listNode8, listNode10);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new334() /* reduce AAcontext24Context */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }

        pparseunitNode1 = new AContextParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode8, listNode9, listNode11);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new335() /* reduce AAcontext25Context */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList3.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList4.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }

        pparseunitNode1 = new AContextParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode5, listNode7, listNode9);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new336() /* reduce AAcontext26Context */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }

        pparseunitNode1 = new AContextParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode6, listNode8, listNode10);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new337() /* reduce AAcontext27Context */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }

        pparseunitNode1 = new AContextParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode6, listNode8, listNode10);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new338() /* reduce AAcontext28Context */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }

        pparseunitNode1 = new AContextParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode7, listNode9, listNode11);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new339() /* reduce AAcontext29Context */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList3.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }

        pparseunitNode1 = new AContextParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode6, listNode8, listNode10);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new340() /* reduce AAcontext30Context */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }

        pparseunitNode1 = new AContextParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode7, listNode9, listNode11);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new341() /* reduce AAcontext31Context */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }

        pparseunitNode1 = new AContextParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode7, listNode9, listNode11);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new342() /* reduce AAcontext32Context */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList6.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList7.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }

        pparseunitNode1 = new AContextParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode8, listNode10, listNode12);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new343() /* reduce AAextendsclause1ExtendsClause */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        LinkedList listNode2 = new LinkedList();
        {
            // Block
        TIdentifierLiteral tidentifierliteralNode1;
        tidentifierliteralNode1 = (TIdentifierLiteral)nodeArrayList2.get(0);
	if(tidentifierliteralNode1 != null)
	{
	  listNode2.add(tidentifierliteralNode1);
	}
        }
	nodeList.add(listNode2);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new344() /* reduce AAextendsclause2ExtendsClause */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        LinkedList listNode3 = new LinkedList();
        {
            // Block
        TIdentifierLiteral tidentifierliteralNode1;
        LinkedList listNode2 = new LinkedList();
        tidentifierliteralNode1 = (TIdentifierLiteral)nodeArrayList2.get(0);
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(tidentifierliteralNode1 != null)
	{
	  listNode3.add(tidentifierliteralNode1);
	}
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
	nodeList.add(listNode3);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new345() /* reduce AExtendsClauseTail */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList1 = pop();
        TIdentifierLiteral tidentifierliteralNode1;
        tidentifierliteralNode1 = (TIdentifierLiteral)nodeArrayList1.get(0);
	nodeList.add(tidentifierliteralNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new346() /* reduce AAsetsclause1SetsClause */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        LinkedList listNode2 = new LinkedList();
        {
            // Block
        PCarrierSet pcarriersetNode1;
        pcarriersetNode1 = (PCarrierSet)nodeArrayList2.get(0);
	if(pcarriersetNode1 != null)
	{
	  listNode2.add(pcarriersetNode1);
	}
        }
	nodeList.add(listNode2);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new347() /* reduce AAsetsclause2SetsClause */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        LinkedList listNode3 = new LinkedList();
        {
            // Block
        PCarrierSet pcarriersetNode1;
        LinkedList listNode2 = new LinkedList();
        pcarriersetNode1 = (PCarrierSet)nodeArrayList2.get(0);
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(pcarriersetNode1 != null)
	{
	  listNode3.add(pcarriersetNode1);
	}
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
	nodeList.add(listNode3);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new348() /* reduce ASetsClauseTail */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList1 = pop();
        PCarrierSet pcarriersetNode1;
        pcarriersetNode1 = (PCarrierSet)nodeArrayList1.get(0);
	nodeList.add(pcarriersetNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new349() /* reduce AAset1Set */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList1 = pop();
        PCarrierSet pcarriersetNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList1.get(0);

        pcarriersetNode1 = new ACarrierSet(listNode2, tidentifierliteralNode3);
        }
	nodeList.add(pcarriersetNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new350() /* reduce AAset2Set */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PCarrierSet pcarriersetNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList2.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList1.get(0);

        pcarriersetNode1 = new ACarrierSet(listNode3, tidentifierliteralNode4);
        }
	nodeList.add(pcarriersetNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new351() /* reduce AAconstantsclause1ConstantsClause */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        LinkedList listNode2 = new LinkedList();
        {
            // Block
        PConstant pconstantNode1;
        pconstantNode1 = (PConstant)nodeArrayList2.get(0);
	if(pconstantNode1 != null)
	{
	  listNode2.add(pconstantNode1);
	}
        }
	nodeList.add(listNode2);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new352() /* reduce AAconstantsclause2ConstantsClause */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        LinkedList listNode3 = new LinkedList();
        {
            // Block
        PConstant pconstantNode1;
        LinkedList listNode2 = new LinkedList();
        pconstantNode1 = (PConstant)nodeArrayList2.get(0);
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(pconstantNode1 != null)
	{
	  listNode3.add(pconstantNode1);
	}
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
	nodeList.add(listNode3);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new353() /* reduce AConstantsClauseTail */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList1 = pop();
        PConstant pconstantNode1;
        pconstantNode1 = (PConstant)nodeArrayList1.get(0);
	nodeList.add(pconstantNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new354() /* reduce AAconstant1Constant */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList1 = pop();
        PConstant pconstantNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList1.get(0);

        pconstantNode1 = new AConstant(listNode2, tidentifierliteralNode3);
        }
	nodeList.add(pconstantNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new355() /* reduce AAconstant2Constant */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PConstant pconstantNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList2.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList1.get(0);

        pconstantNode1 = new AConstant(listNode3, tidentifierliteralNode4);
        }
	nodeList.add(pconstantNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new356() /* reduce AAaxiomsclause1AxiomsClause */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        LinkedList listNode2 = new LinkedList();
        {
            // Block
        PAxiom paxiomNode1;
        paxiomNode1 = (PAxiom)nodeArrayList2.get(0);
	if(paxiomNode1 != null)
	{
	  listNode2.add(paxiomNode1);
	}
        }
	nodeList.add(listNode2);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new357() /* reduce AAaxiomsclause2AxiomsClause */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        LinkedList listNode3 = new LinkedList();
        {
            // Block
        PAxiom paxiomNode1;
        LinkedList listNode2 = new LinkedList();
        paxiomNode1 = (PAxiom)nodeArrayList2.get(0);
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(paxiomNode1 != null)
	{
	  listNode3.add(paxiomNode1);
	}
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
	nodeList.add(listNode3);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new358() /* reduce AAxiomsClauseTail */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList1 = pop();
        PAxiom paxiomNode1;
        paxiomNode1 = (PAxiom)nodeArrayList1.get(0);
	nodeList.add(paxiomNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new359() /* reduce AAaxiom1Axiom */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PAxiom paxiomNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TLabel tlabelNode3;
        TFormula tformulaNode4;
        {
            // Block
        }
        tlabelNode3 = (TLabel)nodeArrayList1.get(0);
        tformulaNode4 = (TFormula)nodeArrayList2.get(0);

        paxiomNode1 = new AAxiom(listNode2, tlabelNode3, tformulaNode4);
        }
	nodeList.add(paxiomNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new360() /* reduce AAaxiom2Axiom */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PAxiom paxiomNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TLabel tlabelNode4;
        TFormula tformulaNode5;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tlabelNode4 = (TLabel)nodeArrayList1.get(0);
        tformulaNode5 = (TFormula)nodeArrayList2.get(0);

        paxiomNode1 = new AAxiom(listNode3, tlabelNode4, tformulaNode5);
        }
	nodeList.add(paxiomNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new361() /* reduce AAderivedaxiom1Axiom */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PAxiom paxiomNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TLabel tlabelNode3;
        TFormula tformulaNode4;
        {
            // Block
        }
        tlabelNode3 = (TLabel)nodeArrayList2.get(0);
        tformulaNode4 = (TFormula)nodeArrayList3.get(0);

        paxiomNode1 = new ADerivedAxiom(listNode2, tlabelNode3, tformulaNode4);
        }
	nodeList.add(paxiomNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new362() /* reduce AAderivedaxiom2Axiom */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PAxiom paxiomNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TLabel tlabelNode4;
        TFormula tformulaNode5;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList4.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tlabelNode4 = (TLabel)nodeArrayList2.get(0);
        tformulaNode5 = (TFormula)nodeArrayList3.get(0);

        paxiomNode1 = new ADerivedAxiom(listNode3, tlabelNode4, tformulaNode5);
        }
	nodeList.add(paxiomNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new363() /* reduce ALabel */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        TLabel tlabelNode1;
        tlabelNode1 = (TLabel)nodeArrayList2.get(0);
	nodeList.add(tlabelNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new364() /* reduce ATerminal$Comment */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList1 = pop();
        LinkedList listNode2 = new LinkedList();
        {
            // Block
        TComment tcommentNode1;
        tcommentNode1 = (TComment)nodeArrayList1.get(0);
	if(tcommentNode1 != null)
	{
	  listNode2.add(tcommentNode1);
	}
        }
	nodeList.add(listNode2);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new365() /* reduce ANonTerminal$Comment */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        LinkedList listNode3 = new LinkedList();
        {
            // Block
        LinkedList listNode1 = new LinkedList();
        TComment tcommentNode2;
        listNode1 = (LinkedList)nodeArrayList1.get(0);
        tcommentNode2 = (TComment)nodeArrayList2.get(0);
	if(listNode1 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode1);
  	  //listNode3 = listNode1;
	}
	if(tcommentNode2 != null)
	{
	  listNode3.add(tcommentNode2);
	}
        }
	nodeList.add(listNode3);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new366() /* reduce ATerminal$RefinesClauseTail */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList1 = pop();
        LinkedList listNode2 = new LinkedList();
        {
            // Block
        TIdentifierLiteral tidentifierliteralNode1;
        tidentifierliteralNode1 = (TIdentifierLiteral)nodeArrayList1.get(0);
	if(tidentifierliteralNode1 != null)
	{
	  listNode2.add(tidentifierliteralNode1);
	}
        }
	nodeList.add(listNode2);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new367() /* reduce ANonTerminal$RefinesClauseTail */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        LinkedList listNode3 = new LinkedList();
        {
            // Block
        LinkedList listNode1 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode2;
        listNode1 = (LinkedList)nodeArrayList1.get(0);
        tidentifierliteralNode2 = (TIdentifierLiteral)nodeArrayList2.get(0);
	if(listNode1 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode1);
  	  //listNode3 = listNode1;
	}
	if(tidentifierliteralNode2 != null)
	{
	  listNode3.add(tidentifierliteralNode2);
	}
        }
	nodeList.add(listNode3);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new368() /* reduce ATerminal$SeesClauseTail */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList1 = pop();
        LinkedList listNode2 = new LinkedList();
        {
            // Block
        TIdentifierLiteral tidentifierliteralNode1;
        tidentifierliteralNode1 = (TIdentifierLiteral)nodeArrayList1.get(0);
	if(tidentifierliteralNode1 != null)
	{
	  listNode2.add(tidentifierliteralNode1);
	}
        }
	nodeList.add(listNode2);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new369() /* reduce ANonTerminal$SeesClauseTail */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        LinkedList listNode3 = new LinkedList();
        {
            // Block
        LinkedList listNode1 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode2;
        listNode1 = (LinkedList)nodeArrayList1.get(0);
        tidentifierliteralNode2 = (TIdentifierLiteral)nodeArrayList2.get(0);
	if(listNode1 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode1);
  	  //listNode3 = listNode1;
	}
	if(tidentifierliteralNode2 != null)
	{
	  listNode3.add(tidentifierliteralNode2);
	}
        }
	nodeList.add(listNode3);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new370() /* reduce ATerminal$InvariantsTail */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList1 = pop();
        LinkedList listNode2 = new LinkedList();
        {
            // Block
        PInvariant pinvariantNode1;
        pinvariantNode1 = (PInvariant)nodeArrayList1.get(0);
	if(pinvariantNode1 != null)
	{
	  listNode2.add(pinvariantNode1);
	}
        }
	nodeList.add(listNode2);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new371() /* reduce ANonTerminal$InvariantsTail */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        LinkedList listNode3 = new LinkedList();
        {
            // Block
        LinkedList listNode1 = new LinkedList();
        PInvariant pinvariantNode2;
        listNode1 = (LinkedList)nodeArrayList1.get(0);
        pinvariantNode2 = (PInvariant)nodeArrayList2.get(0);
	if(listNode1 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode1);
  	  //listNode3 = listNode1;
	}
	if(pinvariantNode2 != null)
	{
	  listNode3.add(pinvariantNode2);
	}
        }
	nodeList.add(listNode3);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new372() /* reduce ATerminal$EventsTail */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList1 = pop();
        LinkedList listNode2 = new LinkedList();
        {
            // Block
        PEvent peventNode1;
        peventNode1 = (PEvent)nodeArrayList1.get(0);
	if(peventNode1 != null)
	{
	  listNode2.add(peventNode1);
	}
        }
	nodeList.add(listNode2);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new373() /* reduce ANonTerminal$EventsTail */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        LinkedList listNode3 = new LinkedList();
        {
            // Block
        LinkedList listNode1 = new LinkedList();
        PEvent peventNode2;
        listNode1 = (LinkedList)nodeArrayList1.get(0);
        peventNode2 = (PEvent)nodeArrayList2.get(0);
	if(listNode1 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode1);
  	  //listNode3 = listNode1;
	}
	if(peventNode2 != null)
	{
	  listNode3.add(peventNode2);
	}
        }
	nodeList.add(listNode3);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new374() /* reduce ATerminal$EventRefinesTail */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList1 = pop();
        LinkedList listNode2 = new LinkedList();
        {
            // Block
        TIdentifierLiteral tidentifierliteralNode1;
        tidentifierliteralNode1 = (TIdentifierLiteral)nodeArrayList1.get(0);
	if(tidentifierliteralNode1 != null)
	{
	  listNode2.add(tidentifierliteralNode1);
	}
        }
	nodeList.add(listNode2);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new375() /* reduce ANonTerminal$EventRefinesTail */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        LinkedList listNode3 = new LinkedList();
        {
            // Block
        LinkedList listNode1 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode2;
        listNode1 = (LinkedList)nodeArrayList1.get(0);
        tidentifierliteralNode2 = (TIdentifierLiteral)nodeArrayList2.get(0);
	if(listNode1 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode1);
  	  //listNode3 = listNode1;
	}
	if(tidentifierliteralNode2 != null)
	{
	  listNode3.add(tidentifierliteralNode2);
	}
        }
	nodeList.add(listNode3);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new376() /* reduce ATerminal$EventAnyTail */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList1 = pop();
        LinkedList listNode2 = new LinkedList();
        {
            // Block
        PParameter pparameterNode1;
        pparameterNode1 = (PParameter)nodeArrayList1.get(0);
	if(pparameterNode1 != null)
	{
	  listNode2.add(pparameterNode1);
	}
        }
	nodeList.add(listNode2);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new377() /* reduce ANonTerminal$EventAnyTail */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        LinkedList listNode3 = new LinkedList();
        {
            // Block
        LinkedList listNode1 = new LinkedList();
        PParameter pparameterNode2;
        listNode1 = (LinkedList)nodeArrayList1.get(0);
        pparameterNode2 = (PParameter)nodeArrayList2.get(0);
	if(listNode1 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode1);
  	  //listNode3 = listNode1;
	}
	if(pparameterNode2 != null)
	{
	  listNode3.add(pparameterNode2);
	}
        }
	nodeList.add(listNode3);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new378() /* reduce ATerminal$EventWhereTail */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList1 = pop();
        LinkedList listNode2 = new LinkedList();
        {
            // Block
        PGuard pguardNode1;
        pguardNode1 = (PGuard)nodeArrayList1.get(0);
	if(pguardNode1 != null)
	{
	  listNode2.add(pguardNode1);
	}
        }
	nodeList.add(listNode2);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new379() /* reduce ANonTerminal$EventWhereTail */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        LinkedList listNode3 = new LinkedList();
        {
            // Block
        LinkedList listNode1 = new LinkedList();
        PGuard pguardNode2;
        listNode1 = (LinkedList)nodeArrayList1.get(0);
        pguardNode2 = (PGuard)nodeArrayList2.get(0);
	if(listNode1 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode1);
  	  //listNode3 = listNode1;
	}
	if(pguardNode2 != null)
	{
	  listNode3.add(pguardNode2);
	}
        }
	nodeList.add(listNode3);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new380() /* reduce ATerminal$EventWithTail */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList1 = pop();
        LinkedList listNode2 = new LinkedList();
        {
            // Block
        PWitness pwitnessNode1;
        pwitnessNode1 = (PWitness)nodeArrayList1.get(0);
	if(pwitnessNode1 != null)
	{
	  listNode2.add(pwitnessNode1);
	}
        }
	nodeList.add(listNode2);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new381() /* reduce ANonTerminal$EventWithTail */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        LinkedList listNode3 = new LinkedList();
        {
            // Block
        LinkedList listNode1 = new LinkedList();
        PWitness pwitnessNode2;
        listNode1 = (LinkedList)nodeArrayList1.get(0);
        pwitnessNode2 = (PWitness)nodeArrayList2.get(0);
	if(listNode1 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode1);
  	  //listNode3 = listNode1;
	}
	if(pwitnessNode2 != null)
	{
	  listNode3.add(pwitnessNode2);
	}
        }
	nodeList.add(listNode3);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new382() /* reduce ATerminal$EventThenTail */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList1 = pop();
        LinkedList listNode2 = new LinkedList();
        {
            // Block
        PAction pactionNode1;
        pactionNode1 = (PAction)nodeArrayList1.get(0);
	if(pactionNode1 != null)
	{
	  listNode2.add(pactionNode1);
	}
        }
	nodeList.add(listNode2);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new383() /* reduce ANonTerminal$EventThenTail */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        LinkedList listNode3 = new LinkedList();
        {
            // Block
        LinkedList listNode1 = new LinkedList();
        PAction pactionNode2;
        listNode1 = (LinkedList)nodeArrayList1.get(0);
        pactionNode2 = (PAction)nodeArrayList2.get(0);
	if(listNode1 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode1);
  	  //listNode3 = listNode1;
	}
	if(pactionNode2 != null)
	{
	  listNode3.add(pactionNode2);
	}
        }
	nodeList.add(listNode3);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new384() /* reduce ATerminal$ExtendsClauseTail */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList1 = pop();
        LinkedList listNode2 = new LinkedList();
        {
            // Block
        TIdentifierLiteral tidentifierliteralNode1;
        tidentifierliteralNode1 = (TIdentifierLiteral)nodeArrayList1.get(0);
	if(tidentifierliteralNode1 != null)
	{
	  listNode2.add(tidentifierliteralNode1);
	}
        }
	nodeList.add(listNode2);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new385() /* reduce ANonTerminal$ExtendsClauseTail */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        LinkedList listNode3 = new LinkedList();
        {
            // Block
        LinkedList listNode1 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode2;
        listNode1 = (LinkedList)nodeArrayList1.get(0);
        tidentifierliteralNode2 = (TIdentifierLiteral)nodeArrayList2.get(0);
	if(listNode1 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode1);
  	  //listNode3 = listNode1;
	}
	if(tidentifierliteralNode2 != null)
	{
	  listNode3.add(tidentifierliteralNode2);
	}
        }
	nodeList.add(listNode3);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new386() /* reduce ATerminal$SetsClauseTail */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList1 = pop();
        LinkedList listNode2 = new LinkedList();
        {
            // Block
        PCarrierSet pcarriersetNode1;
        pcarriersetNode1 = (PCarrierSet)nodeArrayList1.get(0);
	if(pcarriersetNode1 != null)
	{
	  listNode2.add(pcarriersetNode1);
	}
        }
	nodeList.add(listNode2);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new387() /* reduce ANonTerminal$SetsClauseTail */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        LinkedList listNode3 = new LinkedList();
        {
            // Block
        LinkedList listNode1 = new LinkedList();
        PCarrierSet pcarriersetNode2;
        listNode1 = (LinkedList)nodeArrayList1.get(0);
        pcarriersetNode2 = (PCarrierSet)nodeArrayList2.get(0);
	if(listNode1 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode1);
  	  //listNode3 = listNode1;
	}
	if(pcarriersetNode2 != null)
	{
	  listNode3.add(pcarriersetNode2);
	}
        }
	nodeList.add(listNode3);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new388() /* reduce ATerminal$ConstantsClauseTail */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList1 = pop();
        LinkedList listNode2 = new LinkedList();
        {
            // Block
        PConstant pconstantNode1;
        pconstantNode1 = (PConstant)nodeArrayList1.get(0);
	if(pconstantNode1 != null)
	{
	  listNode2.add(pconstantNode1);
	}
        }
	nodeList.add(listNode2);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new389() /* reduce ANonTerminal$ConstantsClauseTail */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        LinkedList listNode3 = new LinkedList();
        {
            // Block
        LinkedList listNode1 = new LinkedList();
        PConstant pconstantNode2;
        listNode1 = (LinkedList)nodeArrayList1.get(0);
        pconstantNode2 = (PConstant)nodeArrayList2.get(0);
	if(listNode1 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode1);
  	  //listNode3 = listNode1;
	}
	if(pconstantNode2 != null)
	{
	  listNode3.add(pconstantNode2);
	}
        }
	nodeList.add(listNode3);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new390() /* reduce ATerminal$AxiomsClauseTail */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList1 = pop();
        LinkedList listNode2 = new LinkedList();
        {
            // Block
        PAxiom paxiomNode1;
        paxiomNode1 = (PAxiom)nodeArrayList1.get(0);
	if(paxiomNode1 != null)
	{
	  listNode2.add(paxiomNode1);
	}
        }
	nodeList.add(listNode2);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new391() /* reduce ANonTerminal$AxiomsClauseTail */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        LinkedList listNode3 = new LinkedList();
        {
            // Block
        LinkedList listNode1 = new LinkedList();
        PAxiom paxiomNode2;
        listNode1 = (LinkedList)nodeArrayList1.get(0);
        paxiomNode2 = (PAxiom)nodeArrayList2.get(0);
	if(listNode1 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode1);
  	  //listNode3 = listNode1;
	}
	if(paxiomNode2 != null)
	{
	  listNode3.add(paxiomNode2);
	}
        }
	nodeList.add(listNode3);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


    private static int[][][] actionTable;
/*      {
			{{-1, ERROR, 0}, {10, SHIFT, 1}, {19, SHIFT, 2}, },
			{{-1, ERROR, 1}, {29, SHIFT, 6}, },
			{{-1, ERROR, 2}, {29, SHIFT, 7}, },
			{{-1, ERROR, 3}, {32, ACCEPT, -1}, },
			{{-1, REDUCE, 0}, },
			{{-1, REDUCE, 1}, },
			{{-1, ERROR, 6}, {0, SHIFT, 8}, {11, SHIFT, 9}, {12, SHIFT, 10}, {13, SHIFT, 11}, {14, SHIFT, 12}, {16, SHIFT, 13}, {17, SHIFT, 14}, {18, SHIFT, 15}, },
			{{-1, ERROR, 7}, {0, SHIFT, 8}, {18, SHIFT, 23}, {20, SHIFT, 24}, {21, SHIFT, 25}, {22, SHIFT, 26}, {23, SHIFT, 27}, },
			{{-1, REDUCE, 364}, },
			{{-1, ERROR, 9}, {29, SHIFT, 33}, },
			{{-1, ERROR, 10}, {29, SHIFT, 34}, },
			{{-1, ERROR, 11}, {29, SHIFT, 35}, },
			{{-1, ERROR, 12}, {3, SHIFT, 37}, {15, SHIFT, 38}, },
			{{-1, ERROR, 13}, {7, SHIFT, 41}, {8, SHIFT, 42}, {9, SHIFT, 43}, {24, SHIFT, 44}, },
			{{-1, ERROR, 14}, {31, SHIFT, 47}, },
			{{-1, REDUCE, 2}, },
			{{-1, ERROR, 16}, {12, SHIFT, 10}, {13, SHIFT, 11}, {14, SHIFT, 12}, {16, SHIFT, 13}, {17, SHIFT, 14}, {18, SHIFT, 48}, },
			{{-1, ERROR, 17}, {13, SHIFT, 11}, {14, SHIFT, 12}, {16, SHIFT, 13}, {17, SHIFT, 14}, {18, SHIFT, 54}, },
			{{-1, ERROR, 18}, {14, SHIFT, 12}, {16, SHIFT, 13}, {17, SHIFT, 14}, {18, SHIFT, 59}, },
			{{-1, ERROR, 19}, {16, SHIFT, 13}, {17, SHIFT, 14}, {18, SHIFT, 63}, },
			{{-1, ERROR, 20}, {16, SHIFT, 13}, {18, SHIFT, 66}, },
			{{-1, ERROR, 21}, {18, SHIFT, 68}, },
			{{-1, ERROR, 22}, {0, SHIFT, 69}, {11, SHIFT, 9}, {12, SHIFT, 10}, {13, SHIFT, 11}, {14, SHIFT, 12}, {16, SHIFT, 13}, {17, SHIFT, 14}, {18, SHIFT, 70}, },
			{{-1, REDUCE, 311}, },
			{{-1, ERROR, 24}, {29, SHIFT, 77}, },
			{{-1, ERROR, 25}, {29, SHIFT, 78}, },
			{{-1, ERROR, 26}, {29, SHIFT, 80}, },
			{{-1, ERROR, 27}, {3, SHIFT, 37}, {15, SHIFT, 82}, },
			{{-1, ERROR, 28}, {18, SHIFT, 85}, {21, SHIFT, 25}, {22, SHIFT, 26}, {23, SHIFT, 27}, },
			{{-1, ERROR, 29}, {18, SHIFT, 89}, {22, SHIFT, 26}, {23, SHIFT, 27}, },
			{{-1, ERROR, 30}, {18, SHIFT, 92}, {23, SHIFT, 27}, },
			{{-1, ERROR, 31}, {18, SHIFT, 94}, },
			{{-1, ERROR, 32}, {0, SHIFT, 69}, {18, SHIFT, 95}, {20, SHIFT, 24}, {21, SHIFT, 25}, {22, SHIFT, 26}, {23, SHIFT, 27}, },
			{{-1, REDUCE, 130}, {29, SHIFT, 100}, },
			{{-1, REDUCE, 133}, {29, SHIFT, 103}, },
			{{-1, REDUCE, 137}, {0, SHIFT, 8}, },
			{{-1, REDUCE, 136}, {29, SHIFT, 107}, },
			{{-1, ERROR, 37}, {30, SHIFT, 108}, },
			{{-1, ERROR, 38}, {3, SHIFT, 37}, },
			{{-1, REDUCE, 141}, {3, SHIFT, 37}, {15, SHIFT, 38}, },
			{{-1, ERROR, 40}, {31, SHIFT, 113}, },
			{{-1, REDUCE, 281}, },
			{{-1, REDUCE, 282}, },
			{{-1, REDUCE, 283}, },
			{{-1, ERROR, 44}, {29, SHIFT, 114}, },
			{{-1, REDUCE, 150}, {7, SHIFT, 41}, {8, SHIFT, 42}, {9, SHIFT, 43}, {24, SHIFT, 44}, },
			{{-1, ERROR, 46}, {24, SHIFT, 118}, },
			{{-1, REDUCE, 148}, {0, SHIFT, 8}, },
			{{-1, REDUCE, 4}, },
			{{-1, ERROR, 49}, {13, SHIFT, 11}, {14, SHIFT, 12}, {16, SHIFT, 13}, {17, SHIFT, 14}, {18, SHIFT, 120}, },
			{{-1, ERROR, 50}, {14, SHIFT, 12}, {16, SHIFT, 13}, {17, SHIFT, 14}, {18, SHIFT, 125}, },
			{{-1, ERROR, 51}, {16, SHIFT, 13}, {17, SHIFT, 14}, {18, SHIFT, 129}, },
			{{-1, ERROR, 52}, {16, SHIFT, 13}, {18, SHIFT, 132}, },
			{{-1, ERROR, 53}, {18, SHIFT, 134}, },
			{{-1, REDUCE, 6}, },
			{{-1, ERROR, 55}, {14, SHIFT, 12}, {16, SHIFT, 13}, {17, SHIFT, 14}, {18, SHIFT, 135}, },
			{{-1, ERROR, 56}, {16, SHIFT, 13}, {17, SHIFT, 14}, {18, SHIFT, 139}, },
			{{-1, ERROR, 57}, {16, SHIFT, 13}, {18, SHIFT, 142}, },
			{{-1, ERROR, 58}, {18, SHIFT, 144}, },
			{{-1, REDUCE, 10}, },
			{{-1, ERROR, 60}, {16, SHIFT, 13}, {17, SHIFT, 14}, {18, SHIFT, 145}, },
			{{-1, ERROR, 61}, {16, SHIFT, 13}, {18, SHIFT, 148}, },
			{{-1, ERROR, 62}, {18, SHIFT, 150}, },
			{{-1, REDUCE, 18}, },
			{{-1, ERROR, 64}, {16, SHIFT, 13}, {18, SHIFT, 151}, },
			{{-1, ERROR, 65}, {18, SHIFT, 153}, },
			{{-1, REDUCE, 34}, },
			{{-1, ERROR, 67}, {18, SHIFT, 154}, },
			{{-1, REDUCE, 66}, },
			{{-1, REDUCE, 365}, },
			{{-1, REDUCE, 3}, },
			{{-1, ERROR, 71}, {12, SHIFT, 10}, {13, SHIFT, 11}, {14, SHIFT, 12}, {16, SHIFT, 13}, {17, SHIFT, 14}, {18, SHIFT, 155}, },
			{{-1, ERROR, 72}, {13, SHIFT, 11}, {14, SHIFT, 12}, {16, SHIFT, 13}, {17, SHIFT, 14}, {18, SHIFT, 161}, },
			{{-1, ERROR, 73}, {14, SHIFT, 12}, {16, SHIFT, 13}, {17, SHIFT, 14}, {18, SHIFT, 166}, },
			{{-1, ERROR, 74}, {16, SHIFT, 13}, {17, SHIFT, 14}, {18, SHIFT, 170}, },
			{{-1, ERROR, 75}, {16, SHIFT, 13}, {18, SHIFT, 173}, },
			{{-1, ERROR, 76}, {18, SHIFT, 175}, },
			{{-1, REDUCE, 343}, {29, SHIFT, 176}, },
			{{-1, REDUCE, 349}, {0, SHIFT, 8}, },
			{{-1, REDUCE, 346}, {29, SHIFT, 78}, },
			{{-1, REDUCE, 354}, {0, SHIFT, 8}, },
			{{-1, REDUCE, 351}, {29, SHIFT, 80}, },
			{{-1, ERROR, 82}, {3, SHIFT, 37}, },
			{{-1, REDUCE, 356}, {3, SHIFT, 37}, {15, SHIFT, 82}, },
			{{-1, ERROR, 84}, {31, SHIFT, 191}, },
			{{-1, REDUCE, 313}, },
			{{-1, ERROR, 86}, {18, SHIFT, 192}, {22, SHIFT, 26}, {23, SHIFT, 27}, },
			{{-1, ERROR, 87}, {18, SHIFT, 195}, {23, SHIFT, 27}, },
			{{-1, ERROR, 88}, {18, SHIFT, 197}, },
			{{-1, REDUCE, 315}, },
			{{-1, ERROR, 90}, {18, SHIFT, 198}, {23, SHIFT, 27}, },
			{{-1, ERROR, 91}, {18, SHIFT, 200}, },
			{{-1, REDUCE, 319}, },
			{{-1, ERROR, 93}, {18, SHIFT, 201}, },
			{{-1, REDUCE, 327}, },
			{{-1, REDUCE, 312}, },
			{{-1, ERROR, 96}, {18, SHIFT, 202}, {21, SHIFT, 25}, {22, SHIFT, 26}, {23, SHIFT, 27}, },
			{{-1, ERROR, 97}, {18, SHIFT, 206}, {22, SHIFT, 26}, {23, SHIFT, 27}, },
			{{-1, ERROR, 98}, {18, SHIFT, 209}, {23, SHIFT, 27}, },
			{{-1, ERROR, 99}, {18, SHIFT, 211}, },
			{{-1, REDUCE, 132}, },
			{{-1, REDUCE, 366}, },
			{{-1, REDUCE, 131}, {29, SHIFT, 100}, },
			{{-1, REDUCE, 135}, },
			{{-1, REDUCE, 368}, },
			{{-1, REDUCE, 134}, {29, SHIFT, 103}, },
			{{-1, REDUCE, 138}, {0, SHIFT, 69}, },
			{{-1, REDUCE, 139}, {0, SHIFT, 8}, },
			{{-1, REDUCE, 363}, },
			{{-1, ERROR, 109}, {31, SHIFT, 215}, },
			{{-1, REDUCE, 370}, },
			{{-1, REDUCE, 143}, },
			{{-1, REDUCE, 142}, {3, SHIFT, 37}, {15, SHIFT, 38}, },
			{{-1, REDUCE, 144}, {0, SHIFT, 8}, },
			{{-1, ERROR, 114}, {0, SHIFT, 8}, {11, SHIFT, 218}, {18, SHIFT, 219}, {20, SHIFT, 220}, {25, SHIFT, 221}, {26, SHIFT, 222}, {27, SHIFT, 223}, {28, SHIFT, 224}, },
			{{-1, REDUCE, 372}, },
			{{-1, REDUCE, 152}, },
			{{-1, REDUCE, 151}, {7, SHIFT, 41}, {8, SHIFT, 42}, {9, SHIFT, 43}, {24, SHIFT, 44}, },
			{{-1, ERROR, 118}, {29, SHIFT, 233}, },
			{{-1, REDUCE, 149}, {0, SHIFT, 69}, },
			{{-1, REDUCE, 8}, },
			{{-1, ERROR, 121}, {14, SHIFT, 12}, {16, SHIFT, 13}, {17, SHIFT, 14}, {18, SHIFT, 234}, },
			{{-1, ERROR, 122}, {16, SHIFT, 13}, {17, SHIFT, 14}, {18, SHIFT, 238}, },
			{{-1, ERROR, 123}, {16, SHIFT, 13}, {18, SHIFT, 241}, },
			{{-1, ERROR, 124}, {18, SHIFT, 243}, },
			{{-1, REDUCE, 12}, },
			{{-1, ERROR, 126}, {16, SHIFT, 13}, {17, SHIFT, 14}, {18, SHIFT, 244}, },
			{{-1, ERROR, 127}, {16, SHIFT, 13}, {18, SHIFT, 247}, },
			{{-1, ERROR, 128}, {18, SHIFT, 249}, },
			{{-1, REDUCE, 20}, },
			{{-1, ERROR, 130}, {16, SHIFT, 13}, {18, SHIFT, 250}, },
			{{-1, ERROR, 131}, {18, SHIFT, 252}, },
			{{-1, REDUCE, 36}, },
			{{-1, ERROR, 133}, {18, SHIFT, 253}, },
			{{-1, REDUCE, 68}, },
			{{-1, REDUCE, 14}, },
			{{-1, ERROR, 136}, {16, SHIFT, 13}, {17, SHIFT, 14}, {18, SHIFT, 254}, },
			{{-1, ERROR, 137}, {16, SHIFT, 13}, {18, SHIFT, 257}, },
			{{-1, ERROR, 138}, {18, SHIFT, 259}, },
			{{-1, REDUCE, 22}, },
			{{-1, ERROR, 140}, {16, SHIFT, 13}, {18, SHIFT, 260}, },
			{{-1, ERROR, 141}, {18, SHIFT, 262}, },
			{{-1, REDUCE, 38}, },
			{{-1, ERROR, 143}, {18, SHIFT, 263}, },
			{{-1, REDUCE, 70}, },
			{{-1, REDUCE, 26}, },
			{{-1, ERROR, 146}, {16, SHIFT, 13}, {18, SHIFT, 264}, },
			{{-1, ERROR, 147}, {18, SHIFT, 266}, },
			{{-1, REDUCE, 42}, },
			{{-1, ERROR, 149}, {18, SHIFT, 267}, },
			{{-1, REDUCE, 74}, },
			{{-1, REDUCE, 50}, },
			{{-1, ERROR, 152}, {18, SHIFT, 268}, },
			{{-1, REDUCE, 82}, },
			{{-1, REDUCE, 98}, },
			{{-1, REDUCE, 5}, },
			{{-1, ERROR, 156}, {13, SHIFT, 11}, {14, SHIFT, 12}, {16, SHIFT, 13}, {17, SHIFT, 14}, {18, SHIFT, 269}, },
			{{-1, ERROR, 157}, {14, SHIFT, 12}, {16, SHIFT, 13}, {17, SHIFT, 14}, {18, SHIFT, 274}, },
			{{-1, ERROR, 158}, {16, SHIFT, 13}, {17, SHIFT, 14}, {18, SHIFT, 278}, },
			{{-1, ERROR, 159}, {16, SHIFT, 13}, {18, SHIFT, 281}, },
			{{-1, ERROR, 160}, {18, SHIFT, 283}, },
			{{-1, REDUCE, 7}, },
			{{-1, ERROR, 162}, {14, SHIFT, 12}, {16, SHIFT, 13}, {17, SHIFT, 14}, {18, SHIFT, 284}, },
			{{-1, ERROR, 163}, {16, SHIFT, 13}, {17, SHIFT, 14}, {18, SHIFT, 288}, },
			{{-1, ERROR, 164}, {16, SHIFT, 13}, {18, SHIFT, 291}, },
			{{-1, ERROR, 165}, {18, SHIFT, 293}, },
			{{-1, REDUCE, 11}, },
			{{-1, ERROR, 167}, {16, SHIFT, 13}, {17, SHIFT, 14}, {18, SHIFT, 294}, },
			{{-1, ERROR, 168}, {16, SHIFT, 13}, {18, SHIFT, 297}, },
			{{-1, ERROR, 169}, {18, SHIFT, 299}, },
			{{-1, REDUCE, 19}, },
			{{-1, ERROR, 171}, {16, SHIFT, 13}, {18, SHIFT, 300}, },
			{{-1, ERROR, 172}, {18, SHIFT, 302}, },
			{{-1, REDUCE, 35}, },
			{{-1, ERROR, 174}, {18, SHIFT, 303}, },
			{{-1, REDUCE, 67}, },
			{{-1, REDUCE, 345}, },
			{{-1, REDUCE, 384}, },
			{{-1, REDUCE, 344}, {29, SHIFT, 176}, },
			{{-1, REDUCE, 350}, {0, SHIFT, 69}, },
			{{-1, REDUCE, 386}, },
			{{-1, REDUCE, 348}, },
			{{-1, REDUCE, 347}, {29, SHIFT, 78}, },
			{{-1, REDUCE, 355}, {0, SHIFT, 69}, },
			{{-1, REDUCE, 388}, },
			{{-1, REDUCE, 353}, },
			{{-1, REDUCE, 352}, {29, SHIFT, 80}, },
			{{-1, ERROR, 187}, {31, SHIFT, 307}, },
			{{-1, REDUCE, 390}, },
			{{-1, REDUCE, 358}, },
			{{-1, REDUCE, 357}, {3, SHIFT, 37}, {15, SHIFT, 82}, },
			{{-1, REDUCE, 359}, {0, SHIFT, 8}, },
			{{-1, REDUCE, 317}, },
			{{-1, ERROR, 193}, {18, SHIFT, 310}, {23, SHIFT, 27}, },
			{{-1, ERROR, 194}, {18, SHIFT, 312}, },
			{{-1, REDUCE, 321}, },
			{{-1, ERROR, 196}, {18, SHIFT, 313}, },
			{{-1, REDUCE, 329}, },
			{{-1, REDUCE, 323}, },
			{{-1, ERROR, 199}, {18, SHIFT, 314}, },
			{{-1, REDUCE, 331}, },
			{{-1, REDUCE, 335}, },
			{{-1, REDUCE, 314}, },
			{{-1, ERROR, 203}, {18, SHIFT, 315}, {22, SHIFT, 26}, {23, SHIFT, 27}, },
			{{-1, ERROR, 204}, {18, SHIFT, 318}, {23, SHIFT, 27}, },
			{{-1, ERROR, 205}, {18, SHIFT, 320}, },
			{{-1, REDUCE, 316}, },
			{{-1, ERROR, 207}, {18, SHIFT, 321}, {23, SHIFT, 27}, },
			{{-1, ERROR, 208}, {18, SHIFT, 323}, },
			{{-1, REDUCE, 320}, },
			{{-1, ERROR, 210}, {18, SHIFT, 324}, },
			{{-1, REDUCE, 328}, },
			{{-1, REDUCE, 367}, },
			{{-1, REDUCE, 369}, },
			{{-1, REDUCE, 140}, {0, SHIFT, 69}, },
			{{-1, REDUCE, 146}, {0, SHIFT, 8}, },
			{{-1, REDUCE, 371}, },
			{{-1, REDUCE, 145}, {0, SHIFT, 69}, },
			{{-1, ERROR, 218}, {29, SHIFT, 326}, },
			{{-1, REDUCE, 153}, },
			{{-1, ERROR, 220}, {29, SHIFT, 327}, },
			{{-1, ERROR, 221}, {29, SHIFT, 328}, },
			{{-1, ERROR, 222}, {3, SHIFT, 37}, {15, SHIFT, 330}, },
			{{-1, ERROR, 223}, {3, SHIFT, 37}, },
			{{-1, ERROR, 224}, {3, SHIFT, 37}, },
			{{-1, ERROR, 225}, {18, SHIFT, 337}, {25, SHIFT, 221}, {26, SHIFT, 222}, {27, SHIFT, 223}, {28, SHIFT, 224}, },
			{{-1, REDUCE, 284}, },
			{{-1, ERROR, 227}, {18, SHIFT, 342}, {26, SHIFT, 222}, {27, SHIFT, 223}, {28, SHIFT, 224}, },
			{{-1, ERROR, 228}, {18, SHIFT, 346}, {27, SHIFT, 223}, {28, SHIFT, 224}, },
			{{-1, ERROR, 229}, {18, SHIFT, 349}, {28, SHIFT, 224}, },
			{{-1, ERROR, 230}, {18, SHIFT, 351}, },
			{{-1, ERROR, 231}, {0, SHIFT, 69}, {11, SHIFT, 218}, {18, SHIFT, 352}, {20, SHIFT, 220}, {25, SHIFT, 221}, {26, SHIFT, 222}, {27, SHIFT, 223}, {28, SHIFT, 224}, },
			{{-1, REDUCE, 373}, },
			{{-1, ERROR, 233}, {0, SHIFT, 8}, {11, SHIFT, 218}, {18, SHIFT, 358}, {20, SHIFT, 220}, {25, SHIFT, 221}, {26, SHIFT, 222}, {27, SHIFT, 223}, {28, SHIFT, 224}, },
			{{-1, REDUCE, 16}, },
			{{-1, ERROR, 235}, {16, SHIFT, 13}, {17, SHIFT, 14}, {18, SHIFT, 365}, },
			{{-1, ERROR, 236}, {16, SHIFT, 13}, {18, SHIFT, 368}, },
			{{-1, ERROR, 237}, {18, SHIFT, 370}, },
			{{-1, REDUCE, 24}, },
			{{-1, ERROR, 239}, {16, SHIFT, 13}, {18, SHIFT, 371}, },
			{{-1, ERROR, 240}, {18, SHIFT, 373}, },
			{{-1, REDUCE, 40}, },
			{{-1, ERROR, 242}, {18, SHIFT, 374}, },
			{{-1, REDUCE, 72}, },
			{{-1, REDUCE, 28}, },
			{{-1, ERROR, 245}, {16, SHIFT, 13}, {18, SHIFT, 375}, },
			{{-1, ERROR, 246}, {18, SHIFT, 377}, },
			{{-1, REDUCE, 44}, },
			{{-1, ERROR, 248}, {18, SHIFT, 378}, },
			{{-1, REDUCE, 76}, },
			{{-1, REDUCE, 52}, },
			{{-1, ERROR, 251}, {18, SHIFT, 379}, },
			{{-1, REDUCE, 84}, },
			{{-1, REDUCE, 100}, },
			{{-1, REDUCE, 30}, },
			{{-1, ERROR, 255}, {16, SHIFT, 13}, {18, SHIFT, 380}, },
			{{-1, ERROR, 256}, {18, SHIFT, 382}, },
			{{-1, REDUCE, 46}, },
			{{-1, ERROR, 258}, {18, SHIFT, 383}, },
			{{-1, REDUCE, 78}, },
			{{-1, REDUCE, 54}, },
			{{-1, ERROR, 261}, {18, SHIFT, 384}, },
			{{-1, REDUCE, 86}, },
			{{-1, REDUCE, 102}, },
			{{-1, REDUCE, 58}, },
			{{-1, ERROR, 265}, {18, SHIFT, 385}, },
			{{-1, REDUCE, 90}, },
			{{-1, REDUCE, 106}, },
			{{-1, REDUCE, 114}, },
			{{-1, REDUCE, 9}, },
			{{-1, ERROR, 270}, {14, SHIFT, 12}, {16, SHIFT, 13}, {17, SHIFT, 14}, {18, SHIFT, 386}, },
			{{-1, ERROR, 271}, {16, SHIFT, 13}, {17, SHIFT, 14}, {18, SHIFT, 390}, },
			{{-1, ERROR, 272}, {16, SHIFT, 13}, {18, SHIFT, 393}, },
			{{-1, ERROR, 273}, {18, SHIFT, 395}, },
			{{-1, REDUCE, 13}, },
			{{-1, ERROR, 275}, {16, SHIFT, 13}, {17, SHIFT, 14}, {18, SHIFT, 396}, },
			{{-1, ERROR, 276}, {16, SHIFT, 13}, {18, SHIFT, 399}, },
			{{-1, ERROR, 277}, {18, SHIFT, 401}, },
			{{-1, REDUCE, 21}, },
			{{-1, ERROR, 279}, {16, SHIFT, 13}, {18, SHIFT, 402}, },
			{{-1, ERROR, 280}, {18, SHIFT, 404}, },
			{{-1, REDUCE, 37}, },
			{{-1, ERROR, 282}, {18, SHIFT, 405}, },
			{{-1, REDUCE, 69}, },
			{{-1, REDUCE, 15}, },
			{{-1, ERROR, 285}, {16, SHIFT, 13}, {17, SHIFT, 14}, {18, SHIFT, 406}, },
			{{-1, ERROR, 286}, {16, SHIFT, 13}, {18, SHIFT, 409}, },
			{{-1, ERROR, 287}, {18, SHIFT, 411}, },
			{{-1, REDUCE, 23}, },
			{{-1, ERROR, 289}, {16, SHIFT, 13}, {18, SHIFT, 412}, },
			{{-1, ERROR, 290}, {18, SHIFT, 414}, },
			{{-1, REDUCE, 39}, },
			{{-1, ERROR, 292}, {18, SHIFT, 415}, },
			{{-1, REDUCE, 71}, },
			{{-1, REDUCE, 27}, },
			{{-1, ERROR, 295}, {16, SHIFT, 13}, {18, SHIFT, 416}, },
			{{-1, ERROR, 296}, {18, SHIFT, 418}, },
			{{-1, REDUCE, 43}, },
			{{-1, ERROR, 298}, {18, SHIFT, 419}, },
			{{-1, REDUCE, 75}, },
			{{-1, REDUCE, 51}, },
			{{-1, ERROR, 301}, {18, SHIFT, 420}, },
			{{-1, REDUCE, 83}, },
			{{-1, REDUCE, 99}, },
			{{-1, REDUCE, 385}, },
			{{-1, REDUCE, 387}, },
			{{-1, REDUCE, 389}, },
			{{-1, REDUCE, 361}, {0, SHIFT, 8}, },
			{{-1, REDUCE, 391}, },
			{{-1, REDUCE, 360}, {0, SHIFT, 69}, },
			{{-1, REDUCE, 325}, },
			{{-1, ERROR, 311}, {18, SHIFT, 422}, },
			{{-1, REDUCE, 333}, },
			{{-1, REDUCE, 337}, },
			{{-1, REDUCE, 339}, },
			{{-1, REDUCE, 318}, },
			{{-1, ERROR, 316}, {18, SHIFT, 423}, {23, SHIFT, 27}, },
			{{-1, ERROR, 317}, {18, SHIFT, 425}, },
			{{-1, REDUCE, 322}, },
			{{-1, ERROR, 319}, {18, SHIFT, 426}, },
			{{-1, REDUCE, 330}, },
			{{-1, REDUCE, 324}, },
			{{-1, ERROR, 322}, {18, SHIFT, 427}, },
			{{-1, REDUCE, 332}, },
			{{-1, REDUCE, 336}, },
			{{-1, REDUCE, 147}, {0, SHIFT, 69}, },
			{{-1, REDUCE, 286}, {29, SHIFT, 428}, },
			{{-1, REDUCE, 285}, },
			{{-1, REDUCE, 292}, {0, SHIFT, 8}, },
			{{-1, REDUCE, 289}, {29, SHIFT, 328}, },
			{{-1, ERROR, 330}, {3, SHIFT, 37}, },
			{{-1, REDUCE, 294}, {3, SHIFT, 37}, {15, SHIFT, 330}, },
			{{-1, ERROR, 332}, {31, SHIFT, 439}, },
			{{-1, REDUCE, 301}, {3, SHIFT, 37}, },
			{{-1, ERROR, 334}, {31, SHIFT, 443}, },
			{{-1, REDUCE, 306}, {3, SHIFT, 37}, },
			{{-1, ERROR, 336}, {31, SHIFT, 447}, },
			{{-1, REDUCE, 157}, },
			{{-1, ERROR, 338}, {18, SHIFT, 448}, {26, SHIFT, 222}, {27, SHIFT, 223}, {28, SHIFT, 224}, },
			{{-1, ERROR, 339}, {18, SHIFT, 452}, {27, SHIFT, 223}, {28, SHIFT, 224}, },
			{{-1, ERROR, 340}, {18, SHIFT, 455}, {28, SHIFT, 224}, },
			{{-1, ERROR, 341}, {18, SHIFT, 457}, },
			{{-1, REDUCE, 161}, },
			{{-1, ERROR, 343}, {18, SHIFT, 458}, {27, SHIFT, 223}, {28, SHIFT, 224}, },
			{{-1, ERROR, 344}, {18, SHIFT, 461}, {28, SHIFT, 224}, },
			{{-1, ERROR, 345}, {18, SHIFT, 463}, },
			{{-1, REDUCE, 169}, },
			{{-1, ERROR, 347}, {18, SHIFT, 464}, {28, SHIFT, 224}, },
			{{-1, ERROR, 348}, {18, SHIFT, 466}, },
			{{-1, REDUCE, 185}, },
			{{-1, ERROR, 350}, {18, SHIFT, 467}, },
			{{-1, REDUCE, 217}, },
			{{-1, REDUCE, 155}, },
			{{-1, ERROR, 353}, {18, SHIFT, 468}, {25, SHIFT, 221}, {26, SHIFT, 222}, {27, SHIFT, 223}, {28, SHIFT, 224}, },
			{{-1, ERROR, 354}, {18, SHIFT, 473}, {26, SHIFT, 222}, {27, SHIFT, 223}, {28, SHIFT, 224}, },
			{{-1, ERROR, 355}, {18, SHIFT, 477}, {27, SHIFT, 223}, {28, SHIFT, 224}, },
			{{-1, ERROR, 356}, {18, SHIFT, 480}, {28, SHIFT, 224}, },
			{{-1, ERROR, 357}, {18, SHIFT, 482}, },
			{{-1, REDUCE, 154}, },
			{{-1, ERROR, 359}, {18, SHIFT, 483}, {25, SHIFT, 221}, {26, SHIFT, 222}, {27, SHIFT, 223}, {28, SHIFT, 224}, },
			{{-1, ERROR, 360}, {18, SHIFT, 488}, {26, SHIFT, 222}, {27, SHIFT, 223}, {28, SHIFT, 224}, },
			{{-1, ERROR, 361}, {18, SHIFT, 492}, {27, SHIFT, 223}, {28, SHIFT, 224}, },
			{{-1, ERROR, 362}, {18, SHIFT, 495}, {28, SHIFT, 224}, },
			{{-1, ERROR, 363}, {18, SHIFT, 497}, },
			{{-1, ERROR, 364}, {0, SHIFT, 69}, {11, SHIFT, 218}, {18, SHIFT, 498}, {20, SHIFT, 220}, {25, SHIFT, 221}, {26, SHIFT, 222}, {27, SHIFT, 223}, {28, SHIFT, 224}, },
			{{-1, REDUCE, 32}, },
			{{-1, ERROR, 366}, {16, SHIFT, 13}, {18, SHIFT, 504}, },
			{{-1, ERROR, 367}, {18, SHIFT, 506}, },
			{{-1, REDUCE, 48}, },
			{{-1, ERROR, 369}, {18, SHIFT, 507}, },
			{{-1, REDUCE, 80}, },
			{{-1, REDUCE, 56}, },
			{{-1, ERROR, 372}, {18, SHIFT, 508}, },
			{{-1, REDUCE, 88}, },
			{{-1, REDUCE, 104}, },
			{{-1, REDUCE, 60}, },
			{{-1, ERROR, 376}, {18, SHIFT, 509}, },
			{{-1, REDUCE, 92}, },
			{{-1, REDUCE, 108}, },
			{{-1, REDUCE, 116}, },
			{{-1, REDUCE, 62}, },
			{{-1, ERROR, 381}, {18, SHIFT, 510}, },
			{{-1, REDUCE, 94}, },
			{{-1, REDUCE, 110}, },
			{{-1, REDUCE, 118}, },
			{{-1, REDUCE, 122}, },
			{{-1, REDUCE, 17}, },
			{{-1, ERROR, 387}, {16, SHIFT, 13}, {17, SHIFT, 14}, {18, SHIFT, 511}, },
			{{-1, ERROR, 388}, {16, SHIFT, 13}, {18, SHIFT, 514}, },
			{{-1, ERROR, 389}, {18, SHIFT, 516}, },
			{{-1, REDUCE, 25}, },
			{{-1, ERROR, 391}, {16, SHIFT, 13}, {18, SHIFT, 517}, },
			{{-1, ERROR, 392}, {18, SHIFT, 519}, },
			{{-1, REDUCE, 41}, },
			{{-1, ERROR, 394}, {18, SHIFT, 520}, },
			{{-1, REDUCE, 73}, },
			{{-1, REDUCE, 29}, },
			{{-1, ERROR, 397}, {16, SHIFT, 13}, {18, SHIFT, 521}, },
			{{-1, ERROR, 398}, {18, SHIFT, 523}, },
			{{-1, REDUCE, 45}, },
			{{-1, ERROR, 400}, {18, SHIFT, 524}, },
			{{-1, REDUCE, 77}, },
			{{-1, REDUCE, 53}, },
			{{-1, ERROR, 403}, {18, SHIFT, 525}, },
			{{-1, REDUCE, 85}, },
			{{-1, REDUCE, 101}, },
			{{-1, REDUCE, 31}, },
			{{-1, ERROR, 407}, {16, SHIFT, 13}, {18, SHIFT, 526}, },
			{{-1, ERROR, 408}, {18, SHIFT, 528}, },
			{{-1, REDUCE, 47}, },
			{{-1, ERROR, 410}, {18, SHIFT, 529}, },
			{{-1, REDUCE, 79}, },
			{{-1, REDUCE, 55}, },
			{{-1, ERROR, 413}, {18, SHIFT, 530}, },
			{{-1, REDUCE, 87}, },
			{{-1, REDUCE, 103}, },
			{{-1, REDUCE, 59}, },
			{{-1, ERROR, 417}, {18, SHIFT, 531}, },
			{{-1, REDUCE, 91}, },
			{{-1, REDUCE, 107}, },
			{{-1, REDUCE, 115}, },
			{{-1, REDUCE, 362}, {0, SHIFT, 69}, },
			{{-1, REDUCE, 341}, },
			{{-1, REDUCE, 326}, },
			{{-1, ERROR, 424}, {18, SHIFT, 532}, },
			{{-1, REDUCE, 334}, },
			{{-1, REDUCE, 338}, },
			{{-1, REDUCE, 340}, },
			{{-1, REDUCE, 288}, },
			{{-1, REDUCE, 374}, },
			{{-1, REDUCE, 287}, {29, SHIFT, 428}, },
			{{-1, REDUCE, 293}, {0, SHIFT, 69}, },
			{{-1, REDUCE, 376}, },
			{{-1, REDUCE, 291}, },
			{{-1, REDUCE, 290}, {29, SHIFT, 328}, },
			{{-1, ERROR, 435}, {31, SHIFT, 535}, },
			{{-1, REDUCE, 378}, },
			{{-1, REDUCE, 296}, },
			{{-1, REDUCE, 295}, {3, SHIFT, 37}, {15, SHIFT, 330}, },
			{{-1, REDUCE, 297}, {0, SHIFT, 8}, },
			{{-1, REDUCE, 380}, },
			{{-1, REDUCE, 303}, },
			{{-1, REDUCE, 302}, {3, SHIFT, 37}, },
			{{-1, REDUCE, 304}, {0, SHIFT, 8}, },
			{{-1, REDUCE, 382}, },
			{{-1, REDUCE, 308}, },
			{{-1, REDUCE, 307}, {3, SHIFT, 37}, },
			{{-1, REDUCE, 309}, {0, SHIFT, 8}, },
			{{-1, REDUCE, 165}, },
			{{-1, ERROR, 449}, {18, SHIFT, 542}, {27, SHIFT, 223}, {28, SHIFT, 224}, },
			{{-1, ERROR, 450}, {18, SHIFT, 545}, {28, SHIFT, 224}, },
			{{-1, ERROR, 451}, {18, SHIFT, 547}, },
			{{-1, REDUCE, 173}, },
			{{-1, ERROR, 453}, {18, SHIFT, 548}, {28, SHIFT, 224}, },
			{{-1, ERROR, 454}, {18, SHIFT, 550}, },
			{{-1, REDUCE, 189}, },
			{{-1, ERROR, 456}, {18, SHIFT, 551}, },
			{{-1, REDUCE, 221}, },
			{{-1, REDUCE, 177}, },
			{{-1, ERROR, 459}, {18, SHIFT, 552}, {28, SHIFT, 224}, },
			{{-1, ERROR, 460}, {18, SHIFT, 554}, },
			{{-1, REDUCE, 193}, },
			{{-1, ERROR, 462}, {18, SHIFT, 555}, },
			{{-1, REDUCE, 225}, },
			{{-1, REDUCE, 201}, },
			{{-1, ERROR, 465}, {18, SHIFT, 556}, },
			{{-1, REDUCE, 233}, },
			{{-1, REDUCE, 249}, },
			{{-1, REDUCE, 159}, },
			{{-1, ERROR, 469}, {18, SHIFT, 557}, {26, SHIFT, 222}, {27, SHIFT, 223}, {28, SHIFT, 224}, },
			{{-1, ERROR, 470}, {18, SHIFT, 561}, {27, SHIFT, 223}, {28, SHIFT, 224}, },
			{{-1, ERROR, 471}, {18, SHIFT, 564}, {28, SHIFT, 224}, },
			{{-1, ERROR, 472}, {18, SHIFT, 566}, },
			{{-1, REDUCE, 163}, },
			{{-1, ERROR, 474}, {18, SHIFT, 567}, {27, SHIFT, 223}, {28, SHIFT, 224}, },
			{{-1, ERROR, 475}, {18, SHIFT, 570}, {28, SHIFT, 224}, },
			{{-1, ERROR, 476}, {18, SHIFT, 572}, },
			{{-1, REDUCE, 171}, },
			{{-1, ERROR, 478}, {18, SHIFT, 573}, {28, SHIFT, 224}, },
			{{-1, ERROR, 479}, {18, SHIFT, 575}, },
			{{-1, REDUCE, 187}, },
			{{-1, ERROR, 481}, {18, SHIFT, 576}, },
			{{-1, REDUCE, 219}, },
			{{-1, REDUCE, 158}, },
			{{-1, ERROR, 484}, {18, SHIFT, 577}, {26, SHIFT, 222}, {27, SHIFT, 223}, {28, SHIFT, 224}, },
			{{-1, ERROR, 485}, {18, SHIFT, 581}, {27, SHIFT, 223}, {28, SHIFT, 224}, },
			{{-1, ERROR, 486}, {18, SHIFT, 584}, {28, SHIFT, 224}, },
			{{-1, ERROR, 487}, {18, SHIFT, 586}, },
			{{-1, REDUCE, 162}, },
			{{-1, ERROR, 489}, {18, SHIFT, 587}, {27, SHIFT, 223}, {28, SHIFT, 224}, },
			{{-1, ERROR, 490}, {18, SHIFT, 590}, {28, SHIFT, 224}, },
			{{-1, ERROR, 491}, {18, SHIFT, 592}, },
			{{-1, REDUCE, 170}, },
			{{-1, ERROR, 493}, {18, SHIFT, 593}, {28, SHIFT, 224}, },
			{{-1, ERROR, 494}, {18, SHIFT, 595}, },
			{{-1, REDUCE, 186}, },
			{{-1, ERROR, 496}, {18, SHIFT, 596}, },
			{{-1, REDUCE, 218}, },
			{{-1, REDUCE, 156}, },
			{{-1, ERROR, 499}, {18, SHIFT, 597}, {25, SHIFT, 221}, {26, SHIFT, 222}, {27, SHIFT, 223}, {28, SHIFT, 224}, },
			{{-1, ERROR, 500}, {18, SHIFT, 602}, {26, SHIFT, 222}, {27, SHIFT, 223}, {28, SHIFT, 224}, },
			{{-1, ERROR, 501}, {18, SHIFT, 606}, {27, SHIFT, 223}, {28, SHIFT, 224}, },
			{{-1, ERROR, 502}, {18, SHIFT, 609}, {28, SHIFT, 224}, },
			{{-1, ERROR, 503}, {18, SHIFT, 611}, },
			{{-1, REDUCE, 64}, },
			{{-1, ERROR, 505}, {18, SHIFT, 612}, },
			{{-1, REDUCE, 96}, },
			{{-1, REDUCE, 112}, },
			{{-1, REDUCE, 120}, },
			{{-1, REDUCE, 124}, },
			{{-1, REDUCE, 126}, },
			{{-1, REDUCE, 33}, },
			{{-1, ERROR, 512}, {16, SHIFT, 13}, {18, SHIFT, 613}, },
			{{-1, ERROR, 513}, {18, SHIFT, 615}, },
			{{-1, REDUCE, 49}, },
			{{-1, ERROR, 515}, {18, SHIFT, 616}, },
			{{-1, REDUCE, 81}, },
			{{-1, REDUCE, 57}, },
			{{-1, ERROR, 518}, {18, SHIFT, 617}, },
			{{-1, REDUCE, 89}, },
			{{-1, REDUCE, 105}, },
			{{-1, REDUCE, 61}, },
			{{-1, ERROR, 522}, {18, SHIFT, 618}, },
			{{-1, REDUCE, 93}, },
			{{-1, REDUCE, 109}, },
			{{-1, REDUCE, 117}, },
			{{-1, REDUCE, 63}, },
			{{-1, ERROR, 527}, {18, SHIFT, 619}, },
			{{-1, REDUCE, 95}, },
			{{-1, REDUCE, 111}, },
			{{-1, REDUCE, 119}, },
			{{-1, REDUCE, 123}, },
			{{-1, REDUCE, 342}, },
			{{-1, REDUCE, 375}, },
			{{-1, REDUCE, 377}, },
			{{-1, REDUCE, 299}, {0, SHIFT, 8}, },
			{{-1, REDUCE, 379}, },
			{{-1, REDUCE, 298}, {0, SHIFT, 69}, },
			{{-1, REDUCE, 381}, },
			{{-1, REDUCE, 305}, {0, SHIFT, 69}, },
			{{-1, REDUCE, 383}, },
			{{-1, REDUCE, 310}, {0, SHIFT, 69}, },
			{{-1, REDUCE, 181}, },
			{{-1, ERROR, 543}, {18, SHIFT, 621}, {28, SHIFT, 224}, },
			{{-1, ERROR, 544}, {18, SHIFT, 623}, },
			{{-1, REDUCE, 197}, },
			{{-1, ERROR, 546}, {18, SHIFT, 624}, },
			{{-1, REDUCE, 229}, },
			{{-1, REDUCE, 205}, },
			{{-1, ERROR, 549}, {18, SHIFT, 625}, },
			{{-1, REDUCE, 237}, },
			{{-1, REDUCE, 253}, },
			{{-1, REDUCE, 209}, },
			{{-1, ERROR, 553}, {18, SHIFT, 626}, },
			{{-1, REDUCE, 241}, },
			{{-1, REDUCE, 257}, },
			{{-1, REDUCE, 265}, },
			{{-1, REDUCE, 167}, },
			{{-1, ERROR, 558}, {18, SHIFT, 627}, {27, SHIFT, 223}, {28, SHIFT, 224}, },
			{{-1, ERROR, 559}, {18, SHIFT, 630}, {28, SHIFT, 224}, },
			{{-1, ERROR, 560}, {18, SHIFT, 632}, },
			{{-1, REDUCE, 175}, },
			{{-1, ERROR, 562}, {18, SHIFT, 633}, {28, SHIFT, 224}, },
			{{-1, ERROR, 563}, {18, SHIFT, 635}, },
			{{-1, REDUCE, 191}, },
			{{-1, ERROR, 565}, {18, SHIFT, 636}, },
			{{-1, REDUCE, 223}, },
			{{-1, REDUCE, 179}, },
			{{-1, ERROR, 568}, {18, SHIFT, 637}, {28, SHIFT, 224}, },
			{{-1, ERROR, 569}, {18, SHIFT, 639}, },
			{{-1, REDUCE, 195}, },
			{{-1, ERROR, 571}, {18, SHIFT, 640}, },
			{{-1, REDUCE, 227}, },
			{{-1, REDUCE, 203}, },
			{{-1, ERROR, 574}, {18, SHIFT, 641}, },
			{{-1, REDUCE, 235}, },
			{{-1, REDUCE, 251}, },
			{{-1, REDUCE, 166}, },
			{{-1, ERROR, 578}, {18, SHIFT, 642}, {27, SHIFT, 223}, {28, SHIFT, 224}, },
			{{-1, ERROR, 579}, {18, SHIFT, 645}, {28, SHIFT, 224}, },
			{{-1, ERROR, 580}, {18, SHIFT, 647}, },
			{{-1, REDUCE, 174}, },
			{{-1, ERROR, 582}, {18, SHIFT, 648}, {28, SHIFT, 224}, },
			{{-1, ERROR, 583}, {18, SHIFT, 650}, },
			{{-1, REDUCE, 190}, },
			{{-1, ERROR, 585}, {18, SHIFT, 651}, },
			{{-1, REDUCE, 222}, },
			{{-1, REDUCE, 178}, },
			{{-1, ERROR, 588}, {18, SHIFT, 652}, {28, SHIFT, 224}, },
			{{-1, ERROR, 589}, {18, SHIFT, 654}, },
			{{-1, REDUCE, 194}, },
			{{-1, ERROR, 591}, {18, SHIFT, 655}, },
			{{-1, REDUCE, 226}, },
			{{-1, REDUCE, 202}, },
			{{-1, ERROR, 594}, {18, SHIFT, 656}, },
			{{-1, REDUCE, 234}, },
			{{-1, REDUCE, 250}, },
			{{-1, REDUCE, 160}, },
			{{-1, ERROR, 598}, {18, SHIFT, 657}, {26, SHIFT, 222}, {27, SHIFT, 223}, {28, SHIFT, 224}, },
			{{-1, ERROR, 599}, {18, SHIFT, 661}, {27, SHIFT, 223}, {28, SHIFT, 224}, },
			{{-1, ERROR, 600}, {18, SHIFT, 664}, {28, SHIFT, 224}, },
			{{-1, ERROR, 601}, {18, SHIFT, 666}, },
			{{-1, REDUCE, 164}, },
			{{-1, ERROR, 603}, {18, SHIFT, 667}, {27, SHIFT, 223}, {28, SHIFT, 224}, },
			{{-1, ERROR, 604}, {18, SHIFT, 670}, {28, SHIFT, 224}, },
			{{-1, ERROR, 605}, {18, SHIFT, 672}, },
			{{-1, REDUCE, 172}, },
			{{-1, ERROR, 607}, {18, SHIFT, 673}, {28, SHIFT, 224}, },
			{{-1, ERROR, 608}, {18, SHIFT, 675}, },
			{{-1, REDUCE, 188}, },
			{{-1, ERROR, 610}, {18, SHIFT, 676}, },
			{{-1, REDUCE, 220}, },
			{{-1, REDUCE, 128}, },
			{{-1, REDUCE, 65}, },
			{{-1, ERROR, 614}, {18, SHIFT, 677}, },
			{{-1, REDUCE, 97}, },
			{{-1, REDUCE, 113}, },
			{{-1, REDUCE, 121}, },
			{{-1, REDUCE, 125}, },
			{{-1, REDUCE, 127}, },
			{{-1, REDUCE, 300}, {0, SHIFT, 69}, },
			{{-1, REDUCE, 213}, },
			{{-1, ERROR, 622}, {18, SHIFT, 678}, },
			{{-1, REDUCE, 245}, },
			{{-1, REDUCE, 261}, },
			{{-1, REDUCE, 269}, },
			{{-1, REDUCE, 273}, },
			{{-1, REDUCE, 183}, },
			{{-1, ERROR, 628}, {18, SHIFT, 679}, {28, SHIFT, 224}, },
			{{-1, ERROR, 629}, {18, SHIFT, 681}, },
			{{-1, REDUCE, 199}, },
			{{-1, ERROR, 631}, {18, SHIFT, 682}, },
			{{-1, REDUCE, 231}, },
			{{-1, REDUCE, 207}, },
			{{-1, ERROR, 634}, {18, SHIFT, 683}, },
			{{-1, REDUCE, 239}, },
			{{-1, REDUCE, 255}, },
			{{-1, REDUCE, 211}, },
			{{-1, ERROR, 638}, {18, SHIFT, 684}, },
			{{-1, REDUCE, 243}, },
			{{-1, REDUCE, 259}, },
			{{-1, REDUCE, 267}, },
			{{-1, REDUCE, 182}, },
			{{-1, ERROR, 643}, {18, SHIFT, 685}, {28, SHIFT, 224}, },
			{{-1, ERROR, 644}, {18, SHIFT, 687}, },
			{{-1, REDUCE, 198}, },
			{{-1, ERROR, 646}, {18, SHIFT, 688}, },
			{{-1, REDUCE, 230}, },
			{{-1, REDUCE, 206}, },
			{{-1, ERROR, 649}, {18, SHIFT, 689}, },
			{{-1, REDUCE, 238}, },
			{{-1, REDUCE, 254}, },
			{{-1, REDUCE, 210}, },
			{{-1, ERROR, 653}, {18, SHIFT, 690}, },
			{{-1, REDUCE, 242}, },
			{{-1, REDUCE, 258}, },
			{{-1, REDUCE, 266}, },
			{{-1, REDUCE, 168}, },
			{{-1, ERROR, 658}, {18, SHIFT, 691}, {27, SHIFT, 223}, {28, SHIFT, 224}, },
			{{-1, ERROR, 659}, {18, SHIFT, 694}, {28, SHIFT, 224}, },
			{{-1, ERROR, 660}, {18, SHIFT, 696}, },
			{{-1, REDUCE, 176}, },
			{{-1, ERROR, 662}, {18, SHIFT, 697}, {28, SHIFT, 224}, },
			{{-1, ERROR, 663}, {18, SHIFT, 699}, },
			{{-1, REDUCE, 192}, },
			{{-1, ERROR, 665}, {18, SHIFT, 700}, },
			{{-1, REDUCE, 224}, },
			{{-1, REDUCE, 180}, },
			{{-1, ERROR, 668}, {18, SHIFT, 701}, {28, SHIFT, 224}, },
			{{-1, ERROR, 669}, {18, SHIFT, 703}, },
			{{-1, REDUCE, 196}, },
			{{-1, ERROR, 671}, {18, SHIFT, 704}, },
			{{-1, REDUCE, 228}, },
			{{-1, REDUCE, 204}, },
			{{-1, ERROR, 674}, {18, SHIFT, 705}, },
			{{-1, REDUCE, 236}, },
			{{-1, REDUCE, 252}, },
			{{-1, REDUCE, 129}, },
			{{-1, REDUCE, 277}, },
			{{-1, REDUCE, 215}, },
			{{-1, ERROR, 680}, {18, SHIFT, 706}, },
			{{-1, REDUCE, 247}, },
			{{-1, REDUCE, 263}, },
			{{-1, REDUCE, 271}, },
			{{-1, REDUCE, 275}, },
			{{-1, REDUCE, 214}, },
			{{-1, ERROR, 686}, {18, SHIFT, 707}, },
			{{-1, REDUCE, 246}, },
			{{-1, REDUCE, 262}, },
			{{-1, REDUCE, 270}, },
			{{-1, REDUCE, 274}, },
			{{-1, REDUCE, 184}, },
			{{-1, ERROR, 692}, {18, SHIFT, 708}, {28, SHIFT, 224}, },
			{{-1, ERROR, 693}, {18, SHIFT, 710}, },
			{{-1, REDUCE, 200}, },
			{{-1, ERROR, 695}, {18, SHIFT, 711}, },
			{{-1, REDUCE, 232}, },
			{{-1, REDUCE, 208}, },
			{{-1, ERROR, 698}, {18, SHIFT, 712}, },
			{{-1, REDUCE, 240}, },
			{{-1, REDUCE, 256}, },
			{{-1, REDUCE, 212}, },
			{{-1, ERROR, 702}, {18, SHIFT, 713}, },
			{{-1, REDUCE, 244}, },
			{{-1, REDUCE, 260}, },
			{{-1, REDUCE, 268}, },
			{{-1, REDUCE, 279}, },
			{{-1, REDUCE, 278}, },
			{{-1, REDUCE, 216}, },
			{{-1, ERROR, 709}, {18, SHIFT, 714}, },
			{{-1, REDUCE, 248}, },
			{{-1, REDUCE, 264}, },
			{{-1, REDUCE, 272}, },
			{{-1, REDUCE, 276}, },
			{{-1, REDUCE, 280}, },
        };*/
    private static int[][][] gotoTable;
/*      {
			{{-1, 3}, },
			{{-1, 4}, },
			{{-1, 16}, {22, 71}, },
			{{-1, 101}, {102, 212}, },
			{{-1, 17}, {16, 49}, {22, 72}, {71, 156}, },
			{{-1, 104}, {105, 213}, },
			{{-1, 18}, {16, 50}, {17, 55}, {22, 73}, {49, 121}, {71, 157}, {72, 162}, {156, 270}, },
			{{-1, 36}, },
			{{-1, 19}, {16, 51}, {17, 56}, {18, 60}, {22, 74}, {49, 122}, {50, 126}, {55, 136}, {71, 158}, {72, 163}, {73, 167}, {121, 235}, {156, 271}, {157, 275}, {162, 285}, {270, 387}, },
			{{-1, 110}, {112, 216}, },
			{{-1, 111}, {12, 39}, },
			{{-1, 20}, {16, 52}, {17, 57}, {18, 61}, {19, 64}, {22, 75}, {49, 123}, {50, 127}, {51, 130}, {55, 137}, {56, 140}, {60, 146}, {71, 159}, {72, 164}, {73, 168}, {74, 171}, {121, 236}, {122, 239}, {126, 245}, {136, 255}, {156, 272}, {157, 276}, {158, 279}, {162, 286}, {163, 289}, {167, 295}, {235, 366}, {270, 388}, {271, 391}, {275, 397}, {285, 407}, {387, 512}, },
			{{-1, 21}, {16, 53}, {17, 58}, {18, 62}, {19, 65}, {20, 67}, {22, 76}, {49, 124}, {50, 128}, {51, 131}, {52, 133}, {55, 138}, {56, 141}, {57, 143}, {60, 147}, {61, 149}, {64, 152}, {71, 160}, {72, 165}, {73, 169}, {74, 172}, {75, 174}, {121, 237}, {122, 240}, {123, 242}, {126, 246}, {127, 248}, {130, 251}, {136, 256}, {137, 258}, {140, 261}, {146, 265}, {156, 273}, {157, 277}, {158, 280}, {159, 282}, {162, 287}, {163, 290}, {164, 292}, {167, 296}, {168, 298}, {171, 301}, {235, 367}, {236, 369}, {239, 372}, {245, 376}, {255, 381}, {270, 389}, {271, 392}, {272, 394}, {275, 398}, {276, 400}, {279, 403}, {285, 408}, {286, 410}, {289, 413}, {295, 417}, {366, 505}, {387, 513}, {388, 515}, {391, 518}, {397, 522}, {407, 527}, {512, 614}, },
			{{-1, 115}, {117, 232}, },
			{{-1, 116}, {13, 45}, },
			{{-1, 46}, },
			{{-1, 225}, {231, 353}, {233, 359}, {364, 499}, },
			{{-1, 226}, },
			{{-1, 429}, {430, 533}, },
			{{-1, 227}, {225, 338}, {231, 354}, {233, 360}, {353, 469}, {359, 484}, {364, 500}, {499, 598}, },
			{{-1, 432}, {434, 534}, },
			{{-1, 433}, {221, 329}, },
			{{-1, 228}, {225, 339}, {227, 343}, {231, 355}, {233, 361}, {338, 449}, {353, 470}, {354, 474}, {359, 485}, {360, 489}, {364, 501}, {469, 558}, {484, 578}, {499, 599}, {500, 603}, {598, 658}, },
			{{-1, 436}, {438, 536}, },
			{{-1, 437}, {222, 331}, },
			{{-1, 229}, {225, 340}, {227, 344}, {228, 347}, {231, 356}, {233, 362}, {338, 450}, {339, 453}, {343, 459}, {353, 471}, {354, 475}, {355, 478}, {359, 486}, {360, 490}, {361, 493}, {364, 502}, {449, 543}, {469, 559}, {470, 562}, {474, 568}, {484, 579}, {485, 582}, {489, 588}, {499, 600}, {500, 604}, {501, 607}, {558, 628}, {578, 643}, {598, 659}, {599, 662}, {603, 668}, {658, 692}, },
			{{-1, 440}, {442, 538}, },
			{{-1, 441}, {223, 333}, },
			{{-1, 230}, {225, 341}, {227, 345}, {228, 348}, {229, 350}, {231, 357}, {233, 363}, {338, 451}, {339, 454}, {340, 456}, {343, 460}, {344, 462}, {347, 465}, {353, 472}, {354, 476}, {355, 479}, {356, 481}, {359, 487}, {360, 491}, {361, 494}, {362, 496}, {364, 503}, {449, 544}, {450, 546}, {453, 549}, {459, 553}, {469, 560}, {470, 563}, {471, 565}, {474, 569}, {475, 571}, {478, 574}, {484, 580}, {485, 583}, {486, 585}, {489, 589}, {490, 591}, {493, 594}, {499, 601}, {500, 605}, {501, 608}, {502, 610}, {543, 622}, {558, 629}, {559, 631}, {562, 634}, {568, 638}, {578, 644}, {579, 646}, {582, 649}, {588, 653}, {598, 660}, {599, 663}, {600, 665}, {603, 669}, {604, 671}, {607, 674}, {628, 680}, {643, 686}, {658, 693}, {659, 695}, {662, 698}, {668, 702}, {692, 709}, },
			{{-1, 444}, {446, 540}, },
			{{-1, 445}, {224, 335}, },
			{{-1, 5}, },
			{{-1, 28}, {32, 96}, },
			{{-1, 177}, {178, 304}, },
			{{-1, 29}, {28, 86}, {32, 97}, {96, 203}, },
			{{-1, 180}, {182, 305}, },
			{{-1, 181}, {25, 79}, },
			{{-1, 30}, {28, 87}, {29, 90}, {32, 98}, {86, 193}, {96, 204}, {97, 207}, {203, 316}, },
			{{-1, 184}, {186, 306}, },
			{{-1, 185}, {26, 81}, },
			{{-1, 31}, {28, 88}, {29, 91}, {30, 93}, {32, 99}, {86, 194}, {87, 196}, {90, 199}, {96, 205}, {97, 208}, {98, 210}, {193, 311}, {203, 317}, {204, 319}, {207, 322}, {316, 424}, },
			{{-1, 188}, {190, 308}, },
			{{-1, 189}, {27, 83}, },
			{{-1, 40}, {27, 84}, {38, 109}, {82, 187}, {83, 84}, {190, 84}, {222, 332}, {223, 334}, {224, 336}, {330, 435}, {331, 332}, {333, 334}, {335, 336}, {438, 332}, {442, 334}, {446, 336}, },
			{{-1, 22}, {7, 32}, {35, 106}, {47, 119}, {78, 179}, {80, 183}, {107, 214}, {113, 217}, {114, 231}, {191, 309}, {215, 325}, {233, 364}, {307, 421}, {328, 431}, {439, 537}, {443, 539}, {447, 541}, {535, 620}, },
			{{-1, 102}, },
			{{-1, 105}, },
			{{-1, 112}, },
			{{-1, 117}, },
			{{-1, 430}, },
			{{-1, 434}, },
			{{-1, 438}, },
			{{-1, 442}, },
			{{-1, 446}, },
			{{-1, 178}, },
			{{-1, 182}, },
			{{-1, 186}, },
			{{-1, 190}, },
        };*/
    private static String[] errorMessages;
/*      {
			"expecting: 'machine', 'context'",
			"expecting: identifier literal",
			"expecting: EOF",
			"expecting: comment, 'refines', 'sees', 'variables', 'invariants', 'events', 'variant', 'end'",
			"expecting: comment, 'end', 'extends', 'sets', 'constants', 'axioms'",
			"expecting: comment, at, 'refines', 'sees', 'variables', 'invariants', 'theorem', 'events', 'variant', 'end', 'extends', 'sets', 'constants', 'axioms', 'any', where, 'with', then, identifier literal",
			"expecting: at, 'theorem'",
			"expecting: 'ordinary', 'convergent', 'anticipated', 'event'",
			"expecting: formula",
			"expecting: 'sees', 'variables', 'invariants', 'events', 'variant', 'end'",
			"expecting: 'variables', 'invariants', 'events', 'variant', 'end'",
			"expecting: 'invariants', 'events', 'variant', 'end'",
			"expecting: 'events', 'variant', 'end'",
			"expecting: 'events', 'end'",
			"expecting: 'end'",
			"expecting: 'end', 'sets', 'constants', 'axioms'",
			"expecting: 'end', 'constants', 'axioms'",
			"expecting: 'end', 'axioms'",
			"expecting: 'sees', 'variables', 'invariants', 'events', 'variant', 'end', identifier literal",
			"expecting: 'variables', 'invariants', 'events', 'variant', 'end', identifier literal",
			"expecting: comment, 'invariants', 'events', 'variant', 'end', identifier literal",
			"expecting: 'invariants', 'events', 'variant', 'end', identifier literal",
			"expecting: label",
			"expecting: at",
			"expecting: at, 'theorem', 'events', 'variant', 'end'",
			"expecting: 'event'",
			"expecting: 'ordinary', 'convergent', 'anticipated', 'end', 'event'",
			"expecting: comment, 'events', 'end'",
			"expecting: 'end', 'sets', 'constants', 'axioms', identifier literal",
			"expecting: comment, 'end', 'constants', 'axioms', identifier literal",
			"expecting: 'end', 'constants', 'axioms', identifier literal",
			"expecting: comment, 'end', 'axioms', identifier literal",
			"expecting: 'end', 'axioms', identifier literal",
			"expecting: at, 'theorem', 'end'",
			"expecting: comment, at, 'theorem', 'events', 'variant', 'end'",
			"expecting: comment, 'refines', 'end', 'extends', 'any', where, 'with', then",
			"expecting: comment, at, 'theorem', 'end'",
			"expecting: 'end', 'any', where, 'with', then",
			"expecting: 'end', where, 'with', then",
			"expecting: 'end', 'with', then",
			"expecting: 'end', then",
			"expecting: 'end', 'any', where, 'with', then, identifier literal",
			"expecting: comment, 'end', where, 'with', then, identifier literal",
			"expecting: 'end', where, 'with', then, identifier literal",
			"expecting: at, 'theorem', 'end', 'with', then",
			"expecting: at, 'end', then",
			"expecting: at, 'end'",
			"expecting: comment, at, 'theorem', 'end', 'with', then",
			"expecting: comment, at, 'end', then",
			"expecting: comment, at, 'end'",
        };*/
    private static int[] errors;
/*      {
			0, 1, 1, 2, 2, 2, 3, 4, 5, 1, 1, 1, 6, 7, 8, 2, 9, 10, 11, 12, 13, 14, 3, 2, 1, 1, 1, 6, 15, 16, 17, 14, 4, 18, 19, 20, 21, 22, 23, 24, 8, 25, 25, 25, 1, 26, 25, 27, 2, 10, 11, 12, 13, 14, 2, 11, 12, 13, 14, 2, 12, 13, 14, 2, 13, 14, 2, 14, 2, 5, 2, 9, 10, 11, 12, 13, 14, 28, 29, 30, 31, 32, 23, 33, 8, 2, 16, 17, 14, 2, 17, 14, 2, 14, 2, 2, 15, 16, 17, 14, 18, 18, 18, 19, 19, 19, 20, 20, 8, 8, 24, 24, 24, 34, 35, 26, 26, 26, 1, 27, 2, 11, 12, 13, 14, 2, 12, 13, 14, 2, 13, 14, 2, 14, 2, 2, 12, 13, 14, 2, 13, 14, 2, 14, 2, 2, 13, 14, 2, 14, 2, 2, 14, 2, 2, 2, 10, 11, 12, 13, 14, 2, 11, 12, 13, 14, 2, 12, 13, 14, 2, 13, 14, 2, 14, 2, 28, 28, 28, 29, 30, 30, 30, 31, 32, 32, 32, 8, 33, 33, 33, 36, 2, 17, 14, 2, 14, 2, 2, 14, 2, 2, 2, 16, 17, 14, 2, 17, 14, 2, 14, 2, 18, 19, 20, 34, 24, 34, 1, 26, 1, 1, 6, 23, 23, 37, 37, 38, 39, 40, 14, 35, 26, 35, 2, 12, 13, 14, 2, 13, 14, 2, 14, 2, 2, 13, 14, 2, 14, 2, 2, 14, 2, 2, 2, 13, 14, 2, 14, 2, 2, 14, 2, 2, 2, 14, 2, 2, 2, 2, 11, 12, 13, 14, 2, 12, 13, 14, 2, 13, 14, 2, 14, 2, 2, 12, 13, 14, 2, 13, 14, 2, 14, 2, 2, 13, 14, 2, 14, 2, 2, 14, 2, 2, 28, 30, 32, 36, 33, 36, 2, 14, 2, 2, 2, 2, 17, 14, 2, 14, 2, 2, 14, 2, 2, 34, 41, 37, 42, 43, 23, 44, 8, 45, 8, 46, 8, 26, 38, 39, 40, 14, 26, 39, 40, 14, 26, 40, 14, 26, 14, 26, 26, 37, 38, 39, 40, 14, 26, 37, 38, 39, 40, 14, 35, 2, 13, 14, 2, 14, 2, 2, 14, 2, 2, 2, 14, 2, 2, 2, 2, 14, 2, 2, 2, 2, 2, 12, 13, 14, 2, 13, 14, 2, 14, 2, 2, 13, 14, 2, 14, 2, 2, 14, 2, 2, 2, 13, 14, 2, 14, 2, 2, 14, 2, 2, 2, 14, 2, 2, 2, 36, 2, 2, 14, 2, 2, 2, 41, 41, 41, 42, 43, 43, 43, 8, 44, 44, 44, 47, 45, 45, 45, 48, 46, 46, 46, 49, 26, 39, 40, 14, 26, 40, 14, 26, 14, 26, 26, 40, 14, 26, 14, 26, 26, 14, 26, 26, 26, 38, 39, 40, 14, 26, 39, 40, 14, 26, 40, 14, 26, 14, 26, 26, 38, 39, 40, 14, 26, 39, 40, 14, 26, 40, 14, 26, 14, 26, 26, 37, 38, 39, 40, 14, 2, 14, 2, 2, 2, 2, 2, 2, 13, 14, 2, 14, 2, 2, 14, 2, 2, 2, 14, 2, 2, 2, 2, 14, 2, 2, 2, 2, 2, 41, 43, 47, 44, 47, 45, 48, 46, 49, 26, 40, 14, 26, 14, 26, 26, 14, 26, 26, 26, 14, 26, 26, 26, 26, 39, 40, 14, 26, 40, 14, 26, 14, 26, 26, 40, 14, 26, 14, 26, 26, 14, 26, 26, 26, 39, 40, 14, 26, 40, 14, 26, 14, 26, 26, 40, 14, 26, 14, 26, 26, 14, 26, 26, 26, 38, 39, 40, 14, 26, 39, 40, 14, 26, 40, 14, 26, 14, 26, 2, 2, 14, 2, 2, 2, 2, 2, 47, 26, 14, 26, 26, 26, 26, 26, 40, 14, 26, 14, 26, 26, 14, 26, 26, 26, 14, 26, 26, 26, 26, 40, 14, 26, 14, 26, 26, 14, 26, 26, 26, 14, 26, 26, 26, 26, 39, 40, 14, 26, 40, 14, 26, 14, 26, 26, 40, 14, 26, 14, 26, 26, 14, 26, 26, 2, 26, 26, 14, 26, 26, 26, 26, 26, 14, 26, 26, 26, 26, 26, 40, 14, 26, 14, 26, 26, 14, 26, 26, 26, 14, 26, 26, 26, 26, 26, 26, 14, 26, 26, 26, 26, 26, 
        };*/

    static 
    {
        try
        {
            DataInputStream s = new DataInputStream(
                new BufferedInputStream(
                Parser.class.getResourceAsStream("parser.dat")));

            // read actionTable
            int length = s.readInt();
            Parser.actionTable = new int[length][][];
            for(int i = 0; i < Parser.actionTable.length; i++)
            {
                length = s.readInt();
                Parser.actionTable[i] = new int[length][3];
                for(int j = 0; j < Parser.actionTable[i].length; j++)
                {
                for(int k = 0; k < 3; k++)
                {
                    Parser.actionTable[i][j][k] = s.readInt();
                }
                }
            }

            // read gotoTable
            length = s.readInt();
            gotoTable = new int[length][][];
            for(int i = 0; i < gotoTable.length; i++)
            {
                length = s.readInt();
                gotoTable[i] = new int[length][2];
                for(int j = 0; j < gotoTable[i].length; j++)
                {
                for(int k = 0; k < 2; k++)
                {
                    gotoTable[i][j][k] = s.readInt();
                }
                }
            }

            // read errorMessages
            length = s.readInt();
            errorMessages = new String[length];
            for(int i = 0; i < errorMessages.length; i++)
            {
                length = s.readInt();
                StringBuffer buffer = new StringBuffer();

                for(int j = 0; j < length; j++)
                {
                buffer.append(s.readChar());
                }
                errorMessages[i] = buffer.toString();
            }

            // read errors
            length = s.readInt();
            errors = new int[length];
            for(int i = 0; i < errors.length; i++)
            {
                errors[i] = s.readInt();
            }

            s.close();
        }
        catch(Exception e)
        {
            throw new RuntimeException("The file \"parser.dat\" is either missing or corrupted.");
        }
    }
}
